/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#define	MAGIC_MVC	0x43564d78	@ "xMVC"
#define	MAGIC_SYST	0x53595378	@ "xSYS"
#define	MAGIC_OKAY	0x59414B4F	@ "OKAY"

      .section ".start", #alloc, #execinstr
      .align

start:
      .type    start,#function

      .long    MAGIC_OKAY              @ magic1 = "OKAY" to identify an image
      b   entry                        @ vector
      .long    0                       @ crc_start
      .long    0                       @ crc_end
      .long    0                       @ crc_code

/*----------------------------------------------------------------*
 | Between the .start and the .main section, the boot record      |
 | area is located. This is defined in the file bra.c and is      |
 | linked to the correct location as defined in the linker        |
 | script apfw_head.lds                                             |
 *----------------------------------------------------------------*/

      .section ".main", #alloc, #execinstr

/*----------------------------------------------------------------*
 | r0: Our own start address                                      |
 | r1: Address of boot struct                                     |
 | r2: Address of boot parameter block                            |
 | --> r1 and r2 need to be passed to each started component <--  |
 *----------------------------------------------------------------*/

entry:

         mov   r5, r0                  @ r5 holds our original start address
         ldr   r6, =MAGIC_MVC          @ r6 holds the magic that we are looking for, we start with MVC
         add   r3, r0, #0x01000000     @ Search through 16Mbyte
loop1:
         add   r0, r0, #512            @ in 512 byte increments
         cmp   r0, r3                  @ are we passed 16Mbyte yet ?
         beq   nothing_found
         ldr   r4, [r0]
         cmp   r4, r6                  @ do we see a magic here ?
         bne   loop1
         
         mov   lr, pc                  @ found an image: start it
         add   pc, r0, #4

         ldr   r6, =MAGIC_SYST         @ now continue searching for a SYSTEM image
         mov   r0, r5                  @ from the beginning
         b     loop1

nothing_found:

loop_forever:
         b     loop_forever            @ normally pc should never reach this point


.align	4
	.long  0                       @ Make sure the MAGIC_MVC and MAGIC_SYST which are stored
                                       @ as inline literals are not on a 512 byte boundary.
.ltorg
