/*  $Header$
 *
 *  Copyright (C) 2002 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef _COMPONENT_INTERFACE_H
#define _COMPONENT_INTERFACE_H

#include "component_version.h"
#include "identification/customer.h"		/* For OEM and Product interface */
#include "identification/hardware_variants.h"	/* For Hardware interface */

/* Dependent Interfaces */
#define AP_FW_NEEDED_HW_IF		BR_IF_VAR_ISL39300A_1

#define AP_FW_NEEDED_PRODUCT_IF		BR_IF_VAR_PRODUCT_2
#define AP_FW_NEEDED_OEM_IF		OEM_ID_INTERSIL
#define AP_FW_NEEDED_PRIMARY_PRODUCT_IF BR_IF_VAR_PRODUCT_2
#define AP_FW_NEEDED_PRIMARY_OEM_IF     OEM_ID_INTERSIL

#define AP_FW_NEEDED_DBO1_IF		BR_IF_VAR_DBO1_1

#define AP_FW_NEEDED_ISL37700_UAP_IF    BR_IF_VAR_ISL37700_UAP_IF_1
#define AP_FW_NEEDED_ISL39000_UAP_IF    BR_IF_VAR_ISL39000_UAP_IF_1


/* Exposed SNMP Interface Version */
#define AP_FW_EXPOSED_SNMP_IF		BR_IF_VAR_SNMP_18
#define AP_FW_EXPOSED_SNMP_IF_BTM	BR_IF_BOT_VAR_SNMP_18
#define AP_FW_EXPOSED_SNMP_IF_TOP	BR_IF_TOP_VAR_SNMP_18

#define AP_FW_EXPOSED_HTTP_IF		BR_IF_VAR_HTTP_1
#define AP_FW_EXPOSED_HTTP_IF_BTM	BR_IF_BOT_VAR_HTTP_1
#define AP_FW_EXPOSED_HTTP_IF_TOP	BR_IF_TOP_VAR_HTTP_1

#define AP_FW_EXPOSED_TFTP_IF		BR_IF_VAR_TFTP_10
#define AP_FW_EXPOSED_TFTP_IF_BTM	BR_IF_BOT_VAR_TFTP_10
#define AP_FW_EXPOSED_TFTP_IF_TOP	BR_IF_TOP_VAR_TFTP_10

#define AP_FW_EXPOSED_DAP1_MAP		BR_IF_VAR_DAP1_MAP_3
#define AP_FW_EXPOSED_DAP1_MAP_BTM	BR_IF_BOT_VAR_DAP1_MAP_3
#define AP_FW_EXPOSED_DAP1_MAP_TOP	BR_IF_TOP_VAR_DAP1_MAP_3

#define AP_FW_EXPOSED_DAP1_FS		BR_IF_VAR_DAP1_FS_1
#define AP_FW_EXPOSED_DAP1_FS_BTM	BR_IF_BOT_VAR_DAP1_FS_1
#define AP_FW_EXPOSED_DAP1_FS_TOP	BR_IF_TOP_VAR_DAP1_FS_1

/* CRC and MD5 */
#define AP_FW_CRC16			0x0000
#define AP_FW_MD5			{ 0, 0, 0, 0 }

#endif /* _COMPONENT_INTERFACE_H */
