#!/bin/sh
LC_ALL=C
# Generate image files for flash preloading and IMT uploading
set -x
if [ $# -lt 4 ]; then
echo Usage:
echo genflash_img.sh [bootloader] [apfw] [MTFW] [version]
exit 1
else
BOOT=$1
APFW=$2
MTFW=$3
VERSION=$4
fi


# combine bootloader and apfirmware.img
/opt/uclinux_tools_1.6.0.0/bin/objcat -b apflash.img ${BOOT} 512 0xff ${APFW} 512 0xff

#split apflash.img into two parts
dd if=apflash.img of=mt-1-2.img skip=512
dd if=apflash.img of=mt-2.img count=512

#combine mt-1-2.img and MTFW
cp ${MTFW} ./mt-1.img
dd if=mt-1-2.img of=mt-1.img seek=512

rm mt-1-2.img
mv mt-1.img WET54GV2_${VERSION}_flash.img
mv mt-2.img WET54GV2_${VERSION}_IMT.img
