/*
 *      IMPORTANT--READ CAREFULLY: The use, reproduction, modification, and
 *      creation of derivative works of this Source Code ("Document") is
 *      governed by a TECHNOLOGY LICENSE AGREEMENT("Agreement"), a legal
 *      agreement between you (either an individual or a single entity) and
 *      No Wires Needed B.V. ("NWN").  By reproducing, modifying, creating
 *      derivative works, accepting, installing, viewing, accessing,
 *      transforming or otherwise using this Document, you agree to be bound
 *      by the terms of the Agreement.  If you do not agree to the terms of
 *      the Agreement, NWN is unwilling to license the rights to use,
 *      reproduce, modify, and create derivative works of this Document to you.
 *      In such event, you may not use, reproduce, modify, create derivative
 *      works, install, view, access, transport, transform or circulate this
 *      Document, and you should promptly contact NWN or the licensor from
 *      which you acquired this Document for instructions on returning or
 *      destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:  This Source
 *      Code software contains confidential, proprietary and trade secret
 *      information of No Wires Needed B.V. and should be treated in a
 *      confidential manner.  Furthermore, this Source Code software is
 *      protected by United States copyright laws and international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Copyright (C) 1994-2000 by No Wires Needed B.V. (NWN), The Netherlands,
 *      ALL RIGHTS RESERVED
 *
 */

#ifndef __BLOBSTUB_H__
#define __BLOBSTUB_H__

/*
 * Blob
 */

extern int blob_init( struct msg_init *init );
extern int blob_abort( void );
extern int blob_reset( void );
extern int blob_sleep( void );
extern int blob_conf( struct msg_conf *config );

extern int blob_reqs( void );
extern int blob_service( void );
#ifdef BLOB_V2
extern int blob_trap(struct msg_conf *trap);
#else
extern struct msg_conf *blob_trap( void );
#endif

extern void blob_watchdog( void );

/*
 * Device functions
 */

#ifdef BLOB_V2
extern int dev_start( int device, struct msg_start *start );
#else
extern int dev_start( int device, int mode );
#endif

extern int dev_run( int device );
extern int dev_halt( int device );
extern int dev_stop( int device );
extern int dev_conf( int device, struct msg_conf *config );
extern int dev_setup( int device, struct msg_setup *setup );

extern int dev_frame_add( int device, struct msg_frame *frame );
extern int dev_frame_tx( int device, struct msg_frame *frame );

extern int dev_write( int device, struct msg_data *data );


extern int dev_state( int device );
extern int dev_reqs( int device );
extern int dev_service( int device );
#ifdef BLOB_V2
extern int dev_trap( int device, struct msg_conf *trap );
#else
extern struct msg_conf *dev_trap( int device );
#endif

extern struct msg_frame *dev_frame_return( int device );
extern struct msg_frame *dev_frame_rx( int device );

extern struct msg_data *dev_data( int device );

extern void dev_watchdog( int device );

#endif /* __BLOBSTUB_H__ */
