/*  $Header: //depot/Software/include/identification/components.h#10 $
 *
 *  Copyright (C) 2002 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _COMPONENTS_H
#define _COMPONENTS_H

/*----------------------------------------------*
 | Component ID's uniquely identify components. |
 *----------------------------------------------*/

/*=====================*
 | SOFTWARE COMPONENTS |
 *=====================*/

#define   BR_COMP_ID_BOOT   0x544F4F42   /*    "BOOT": Boot code                             */
#define   BR_COMP_ID_DAP1   0x31504144   /*    "DAP1": Dual Band AP FW                       */
#define   BR_COMP_ID_DBCO   0x4F434244   /*    "DBCO": DuetteAPDK combined image             */
#define   BR_COMP_ID_DBO1   0x314F4244   /*    "DBO1": Dual Band Bootloader                  */
#define   BR_COMP_ID_DFS1   0x31534644   /*    "DFS1": Dual Band File Set                    */
#define   BR_COMP_ID_DMT1   0x31544D44   /*    "DMT1": Dual Band Manufacturing and Test FW   */
#define	  BR_COMP_ID_DUMM   0x4D4D5544   /*    "DUMM": Dummy Micro AP FW                     */
#define	  BR_COMP_ID_FA90   0x30394146   /*    "FA90": 3890 full mac AP FW                   */
#define	  BR_COMP_ID_FC90   0x30394346   /*    "FC90": 3890 full mac client FW               */
#define   BR_COMP_ID_ICL1   0x314C4349   /*    "ICL1": Indigo Client FW                      */
#define   BR_COMP_ID_IMT1   0x31544D49   /*    "IMT1": Indigo Manufacturing and Test FW      */
#define   BR_COMP_ID_ITM1   0x314D5449   /*    "ITM1": Indigo Micro AP FW                    */
#define   BR_COMP_ID_LCL1   0x314C434C   /*    "LCL1": Liberty Client FW (Duette)            */
#define   BR_COMP_ID_LDV1   0x3176444C   /*    "LDv1": 3.X Manufacturing and Test FW         */
#define	  BR_COMP_ID_LM86   0x36384D4C   /*    "LM86": 3886 LMAC                             */
#define   BR_COMP_ID_LTM1   0x314D544C   /*    "LTM1": Liberty Micro AP FW (Duette)          */
#define   BR_COMP_ID_LMT1   0x31544D4C   /*    "LMT1": Liberty Manufacturing and Test FW     */
#define   BR_COMP_ID_MVC1   0x3143564D   /*    "MVC1": MVC                                   */
#define   BR_COMP_ID_RESC   0x43534552   /*    "RESC": Rescue System                         */
#define   BR_COMP_ID_SYST   0x54535953   /*    "SYST": uClinux System                        */

/*=====================*
 | HARDWARE COMPONENTS |
 *=====================*/

#define   BR_COMP_ID_ISL36356A   0x41566303   /* Intersil 36356A Reference Design (AP Builder's Kit and AP Developer's Kit) */
#define   BR_COMP_ID_ISL37704C   0x43047703   /* Intersil 37704C Reference Design (Indigo Cardbus and MiniPCI)              */
#define   BR_COMP_ID_ISL39000    0x00009003   /* Intersil 39000C and 39000M Reference Design (Liberty Cardbus and MiniPCI)  */
#define   BR_COMP_ID_ISL39300A   0x41009303   /* Intersil 39300A Reference Design (Dual Band AP)                            */



#endif /* _COMPONENTS_H */
