/*  $Header: //depot/Software/include/identification/customer.h#4 $
 *
 *  Copyright (C) 2002 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _CUSTOMER_H
#define _CUSTOMER_H

// Contains OEM and Product names.
//=========
// OEM ID's
//=========
// To ensure that OEM ID's are unique, the SMI enterprise number must be used as OEM ID here.

#define OEM_ID_INTERSIL				937
#define OEM_ID_OEMNAME				937	// Replace the number by the SMI Enterprise Number of the OEM.


//=========
// Products
//=========
// This uniquely identifies a product for a specific OEM.

#define PRODTYPE_APDK_REF_DESIGN	1	// AP Developer's Kit

// the DBAP product variants
#define PRODTYPE_DBAP_REF_DESIGN	1	// Duette APDK


//=========
// VARIANTS
//=========

//--------------
// OEM Variants
//--------------

// Variants for interface BR_IF_ID_OEM_IF
// Select one of the following sets of defines.
// Either these ...
// These defines create a product capable to upload OEM firmware AND Intersil reference firmware.
#define BR_IF_VAR_OEM_1			OEM_ID_OEMNAME
#define BR_IF_BOT_VAR_OEM_1			OEM_ID_INTERSIL
#define BR_IF_TOP_VAR_OEM_1			OEM_ID_INTERSIL

// Or these ...
// These defines create a product capable to upload OEM specific firmware.
//#define BR_IF_VAR_OEM_1			OEM_ID_OEMNAME
//#define BR_IF_BOT_VAR_OEM_1			OEM_ID_OEMNAME
//#define BR_IF_TOP_VAR_OEM_1			OEM_ID_OEMNAME


//-----------------
// Product Variants
//-----------------

// Variants for interface BR_IF_ID_PRODUCT_IF
#define BR_IF_VAR_PRODUCT_1			PRODTYPE_APDK_REF_DESIGN
#define BR_IF_BOT_VAR_PRODUCT_1			BR_IF_VAR_PRODUCT_1
#define BR_IF_TOP_VAR_PRODUCT_1			BR_IF_VAR_PRODUCT_1

#define BR_IF_VAR_PRODUCT_2			PRODTYPE_DBAP_REF_DESIGN
#define BR_IF_BOT_VAR_PRODUCT_2			BR_IF_VAR_PRODUCT_2
#define BR_IF_TOP_VAR_PRODUCT_2			BR_IF_VAR_PRODUCT_2

#endif /* _CUSTOMER_H */
