/*  $Header: //depot/Software/include/identification/hardware_variants.h#5 $
 *
 *  Copyright (C) 2002 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _HARDWARE_VARIANTS_H
#define _HARDWARE_VARIANTS_H

//------------------------------------------
// Variants for interface BR_IF_ID_ISL36356A
//------------------------------------------
#define BR_IF_VAR_ISL36356A_1		1	// Compatible with Rev E
#define BR_IF_BOT_VAR_ISL36356A_1		BR_IF_VAR_ISL36356A_1
#define BR_IF_TOP_VAR_ISL36356A_1		BR_IF_VAR_ISL36356A_1

//------------------------------------------
// Variants for interface BR_IF_ID_ISL37704C
//------------------------------------------
#define BR_IF_VAR_ISL37704C_1		1	// Ext. IF VCO, ext. RF VCO
#define BR_IF_BOT_VAR_ISL37704C_1		BR_IF_VAR_ISL37704C_1
#define BR_IF_TOP_VAR_ISL37704C_1		BR_IF_VAR_ISL37704C_1

#define BR_IF_VAR_ISL37704C_2		2	// Int. IF VCO, ext. RF VCO
#define BR_IF_BOT_VAR_ISL37704C_2		BR_IF_VAR_ISL37704C_2
#define BR_IF_TOP_VAR_ISL37704C_2		BR_IF_VAR_ISL37704C_2

#define BR_IF_VAR_ISL37704C_3		3	// Ext. IF VCO, int. RF VCO
#define BR_IF_BOT_VAR_ISL37704C_3		BR_IF_VAR_ISL37704C_3
#define BR_IF_TOP_VAR_ISL37704C_3		BR_IF_VAR_ISL37704C_3

#define BR_IF_VAR_ISL37704C_4		4	// Int. IF VCO, int. RF VCO
#define BR_IF_BOT_VAR_ISL37704C_4		BR_IF_VAR_ISL37704C_4
#define BR_IF_TOP_VAR_ISL37704C_4		BR_IF_VAR_ISL37704C_4


//-----------------------------------------
// Variants for interface BR_IF_ID_ISL39000
//-----------------------------------------
#define BR_IF_VAR_ISL39000_1		1	// Dual modulus prescaler
#define BR_IF_BOT_VAR_ISL39000_1		BR_IF_VAR_ISL39000_1
#define BR_IF_TOP_VAR_ISL39000_1		BR_IF_VAR_ISL39000_1

#define BR_IF_VAR_ISL39000_2		2	// Triple modulus prescaler
#define BR_IF_BOT_VAR_ISL39000_2		BR_IF_VAR_ISL39000_2
#define BR_IF_TOP_VAR_ISL39000_2		BR_IF_VAR_ISL39000_2

#define BR_IF_VAR_ISL39000_3		3	// Frisbee ZIF
#define BR_IF_BOT_VAR_ISL39000_3		BR_IF_VAR_ISL39000_3
#define BR_IF_TOP_VAR_ISL39000_3		BR_IF_VAR_ISL39000_3


//------------------------------------------
// Variants for interface BR_IF_ID_ISL39300A
//------------------------------------------
#define BR_IF_VAR_ISL39300A_1		1	// 
#define BR_IF_BOT_VAR_ISL39300A_1		BR_IF_VAR_ISL39300A_1
#define BR_IF_TOP_VAR_ISL39300A_1		BR_IF_VAR_ISL39300A_1

#endif /* _HARDWARE_VARIANTS_H */
