/*  $Header: //depot/Software/include/identification/interfaces.h#7 $
 *
 *  Copyright (C) 2002 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _INTERFACES_H
#define _INTERFACES_H

//----------------
// Interface Roles
//----------------
// The interface Role can be client or server */
#define BR_IF_ROLE_SERVER		0x0000
#define BR_IF_ROLE_CLIENT		0x8000

//---------------
// Interface ID's
//---------------
// The interface ID is a unique identification of a specific interface.
// The following values are reserved: 0x0000, 0x0002
//					0x0000	Reserved
#define BR_IF_ID_ISL36356A		0x0001	// Interface between BR_COMP_ID_ISL36356A <-> Firmware
//					0x0002	Reserved
#define BR_IF_ID_MVC			0x0003	// MAC Virtual Coprocessor
#define BR_IF_ID_SNMP_IF		0x0004	// SNMP Interface between Application <-> Firmware
#define BR_IF_ID_SNWNMP_IF		0x0005	// SNWNMP Interface between Application <-> Firmware
#define BR_IF_ID_HTTP_IF		0x0006	// HTTP Interface between Application <-> Firmware
#define BR_IF_ID_MANUF_TST_IF	        0x0007	// Manufacturing and Test Interface between Application <-> Firmware
#define BR_IF_ID_DEBUG_IF		0x0008	// PolDebug Interface between Application <-> Firmware
// The PRODUCT and OEM interface are conceptual interfaces for product differentiation
#define BR_IF_ID_PRODUCT_IF		0x0009
#define BR_IF_ID_OEM_IF			0x000A
#define BR_IF_ID_PCIHOST_IF		0x000B  // Host PCI Interface
#define BR_IF_ID_PCI3877_IF		BR_IF_ID_PCIHOST_IF	// 3877 <-> Host PCI Interface
#define BR_IF_ID_DAP1_MAP		BR_IF_ID_PCIHOST_IF	// Interface between BR_COMP_ID_DAP1 <-> Micro AP Firmware
#define BR_IF_ID_ISL37704C		0x000C	// Interface between BR_COMP_ID_ISL37704C <-> Firmware
#define BR_IF_ID_ISL37700M		BR_IF_ID_ISL37704C	// Interface between BR_COMP_ID_ISL37700M <-> Firmware
#define BR_IF_ID_TFTP			0x000D	// TFTP Interface Application <-> Firmware
#define BR_IF_ID_STFTP			0x000E	// STFTP Interface between Application <-> Firmware
#define BR_IF_ID_ISL39000		0x000F  // Interface between BR_COMP_ID_ISL39000 <-> Firmware
#define BR_IF_ID_ISL39000M              BR_IF_ID_ISL39000  // Interface between BR_COMP_ID_ISL39000M <-> Firmware
#define BR_IF_ID_ISL39300A              0x0010  // Interface between BR_COMP_ID_ISL39300A <-> Firmware
#define BR_IF_ID_BOOT_IF		0x0011  // Interface of bootloader and remaining firmware
#define BR_IF_ID_DBO1                   BR_IF_ID_BOOT_IF  // Interface between BR_COMP_ID_DBO1 <-> Firmware
//					0x0012  Reserved
#define BR_IF_ID_FS_IF			0x0013	// File set interface (size, format, etc)
#define BR_IF_ID_DAP1_FS		BR_IF_ID_FS_IF	// Interface between BR_COMP_ID_DAP1 <-> File Set
//					0x0014  Reserved
//					0x0015  Reserved
#define BR_IF_ID_ISL37700_UAP_IF        0x0016	// Interface between ISL37700 uAP firmware <-> Firmware
#define BR_IF_ID_ISL39000_UAP_IF        0x0017  // Interface between ISL39000 uAP firmware <-> Firmware
// The Primary PRODUCT and Primary OEM interface are conceptual interfaces for product differentiation
#define BR_IF_ID_PRIMARY_PRODUCT_IF     0x0018
#define BR_IF_ID_PRIMARY_OEM_IF         0x0019
#define BR_IF_ID_LMAC_IF		0x001A	// Interface exposed by LMAC, see doc. 553265


#endif /* _INTERFACES_H */
