/*  $Header: //depot/Software/include/identification/software_variants.h#12 $
 *
 *  Copyright (C) 2002 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _SOFTWARE_VARIANTS_H
#define _SOFTWARE_VARIANTS_H

//------------------------------------
// Variants for interface BR_IF_ID_MVC
//------------------------------------
// Refer to 553091 for details
#define BR_IF_VAR_MVC_1				1	//
#define BR_IF_BOT_VAR_MVC_1				BR_IF_VAR_MVC_1
#define BR_IF_TOP_VAR_MVC_1				BR_IF_VAR_MVC_1

#define BR_IF_VAR_MVC_2				2	// Added SSN + Neighboring BSS
#define BR_IF_BOT_VAR_MVC_2				BR_IF_VAR_MVC_1
#define BR_IF_TOP_VAR_MVC_2				BR_IF_VAR_MVC_2

#define BR_IF_VAR_MVC_3				3	// Added Reassociate trap + generec obj_stastat
#define BR_IF_BOT_VAR_MVC_3				BR_IF_VAR_MVC_1
#define BR_IF_TOP_VAR_MVC_3				BR_IF_VAR_MVC_3

//----------------------------------------
// Variants for interface BR_IF_ID_SNMP_IF
//----------------------------------------
// Every change in the MIB implementation requires a new variant
#define BR_IF_VAR_SNMP_1			1	// Stones uCLinux System interface variant
#define BR_IF_BOT_VAR_SNMP_1			BR_IF_VAR_SNMP_1
#define BR_IF_TOP_VAR_SNMP_1			BR_IF_VAR_SNMP_1

#define BR_IF_VAR_SNMP_2			2	// Added SSN support to Stones
#define BR_IF_BOT_VAR_SNMP_2			BR_IF_VAR_SNMP_1
#define BR_IF_TOP_VAR_SNMP_2			BR_IF_VAR_SNMP_2

#define BR_IF_VAR_SNMP_16			0x0010	// DuetteAPDK until beta 2
#define BR_IF_BOT_VAR_SNMP_16			BR_IF_VAR_SNMP_16
#define BR_IF_TOP_VAR_SNMP_16			BR_IF_VAR_SNMP_16

#define BR_IF_VAR_SNMP_17			0x0011	// DuetteAPDK beta 3
#define BR_IF_BOT_VAR_SNMP_17			BR_IF_VAR_SNMP_16
#define BR_IF_TOP_VAR_SNMP_17			BR_IF_VAR_SNMP_17

#define BR_IF_VAR_SNMP_18			0x0012	// DuetteAPDK beta 4
#define BR_IF_BOT_VAR_SNMP_18			BR_IF_VAR_SNMP_16
#define BR_IF_TOP_VAR_SNMP_18			BR_IF_VAR_SNMP_18

#define BR_IF_VAR_SNMP_1000			1000	// Rescue System interface variant
#define BR_IF_BOT_VAR_SNMP_1000			BR_IF_VAR_SNMP_1000
#define BR_IF_TOP_VAR_SNMP_1000			BR_IF_VAR_SNMP_1000

//------------------------------------------
// Variants for interface BR_IF_ID_SNWNMP_IF
//------------------------------------------
#define BR_IF_VAR_SNWNMP_1			1
#define BR_IF_BOT_VAR_SNWNMP_1			BR_IF_VAR_SNWNMP_1
#define BR_IF_TOP_VAR_SNWNMP_1			BR_IF_VAR_SNWNMP_1

//----------------------------------------
// Variants for interface BR_IF_ID_HTTP_IF
//----------------------------------------
#define BR_IF_VAR_HTTP_1			1	// Stones uCLinux System HTTP interface variant
#define BR_IF_BOT_VAR_HTTP_1			BR_IF_VAR_HTTP_1
#define BR_IF_TOP_VAR_HTTP_1			BR_IF_VAR_HTTP_1

//---------------------------------------------
// Variants for interface BR_IF_ID_MANUF_TST_IF
//---------------------------------------------
// There are three different mtfw's, so there may be a need for more interfaces and variants to be defined.
#define BR_IF_VAR_MANUF_TST_1		1
#define BR_IF_BOT_VAR_MANUF_TST_1		BR_IF_VAR_MANUF_TST_1
#define BR_IF_TOP_VAR_MANUF_TST_1		BR_IF_VAR_MANUF_TST_1

//-----------------------------------------
// Variants for interface BR_IF_ID_DEBUG_IF
//-----------------------------------------
#define BR_IF_VAR_DEBUG_1			1
#define BR_IF_BOT_VAR_DEBUG_1			BR_IF_VAR_DEBUG_1
#define BR_IF_TOP_VAR_DEBUG_1			BR_IF_VAR_DEBUG_1

//-------------------------------------------
// Variants for interface BR_IF_ID_PCI3877_IF
//-------------------------------------------
#define BR_IF_VAR_PCI3877_1			1
#define BR_IF_BOT_VAR_PCI3877_1			BR_IF_VAR_PCI3877_1
#define BR_IF_TOP_VAR_PCI3877_1			BR_IF_VAR_PCI3877_1


//-------------------------------------------
// Variants for interface BR_IF_ID_TFTP
//-------------------------------------------
#define BR_IF_VAR_TFTP_1			1	// Rescue
#define BR_IF_BOT_VAR_TFTP_1			BR_IF_VAR_TFTP_1
#define BR_IF_TOP_VAR_TFTP_1			BR_IF_VAR_TFTP_1
#define BR_IF_VAR_TFTP_10			10	// System
#define BR_IF_BOT_VAR_TFTP_10			BR_IF_VAR_TFTP_10
#define BR_IF_TOP_VAR_TFTP_10			BR_IF_VAR_TFTP_10

//-------------------------------------------
// Variants for interface BR_IF_ID_DBO1
//-------------------------------------------
#define BR_IF_VAR_DBO1_1			0x0001	// Initial variant
#define BR_IF_BOT_VAR_DBO1_1			BR_IF_VAR_DBO1_1
#define BR_IF_TOP_VAR_DBO1_1			BR_IF_VAR_DBO1_1

//-------------------------------------------
// Variants for interface BR_IF_ID_DAP1_MAP
//-------------------------------------------
#define BR_IF_VAR_DAP1_MAP_1		0x0001	// Support for Indigo Micro AP
#define BR_IF_BOT_VAR_DAP1_MAP_1		BR_IF_VAR_DAP1_MAP_1
#define BR_IF_TOP_VAR_DAP1_MAP1_1		BR_IF_VAR_DAP1_MAP_1

#define BR_IF_VAR_DAP1_MAP_2		0x0002  // Support for Prism Duette/GT Micro AP
#define BR_IF_BOT_VAR_DAP1_MAP_2		BR_IF_VAR_DAP1_MAP_2
#define BR_IF_TOP_VAR_DAP1_MAP_2		BR_IF_VAR_DAP1_MAP_2

#define BR_IF_VAR_DAP1_MAP_3		0x0003  // Support for X-Bow/SoftMac uAP
#define BR_IF_BOT_VAR_DAP1_MAP_3		BR_IF_VAR_DAP1_MAP_3
#define BR_IF_TOP_VAR_DAP1_MAP_3		BR_IF_VAR_DAP1_MAP_3

//-------------------------------------------
// Variants for interface BR_IF_ID_DAP1_FS
//-------------------------------------------
#define BR_IF_VAR_DAP1_FS_1			0x0001	// Initial variant
#define BR_IF_BOT_VAR_DAP1_FS_1			BR_IF_VAR_DAP1_FS_1
#define BR_IF_TOP_VAR_DAP1_FS_1			BR_IF_VAR_DAP1_FS_1

//-----------------------------------------------
// Variants for interface BR_IF_ID_ISL37700_UAP_IF
//-----------------------------------------------
#define BR_IF_VAR_ISL37700_UAP_IF_1		0x0001	// Initial variant
#define BR_IF_BOT_ISL37700_VAR_IF_1		BR_IF_VAR_ISL37700_VAR_IF_1
#define BR_IF_TOP_ISL37700_VAR_IF_1		BR_IF_VAR_ISL37700_VAR_IF_1

//-----------------------------------------------
// Variants for interface BR_IF_ID_ISL39000_UAP_IF
//-----------------------------------------------
#define BR_IF_VAR_ISL39000_UAP_IF_1		0x0001	// Initial variant
#define BR_IF_BOT_ISL39000_VAR_IF_1		BR_IF_VAR_ISL39000_VAR_IF_1
#define BR_IF_TOP_ISL39000_VAR_IF_1		BR_IF_VAR_ISL39000_VAR_IF_1

//-----------------------------------------------
// Variants for interface BR_IF_ID_LMAC_IF
//-----------------------------------------------
#define BR_IF_VAR_LMAC_IF_1			0x0001	// Initial variant, see version 1.1 of document 553265
#define BR_IF_BOT_LMAC_IF_1			BR_IF_VAR_LMAC_IF_1
#define BR_IF_TOP_LMAC_IF_1			BR_IF_VAR_LMAC_IF_1


#endif /* _SOFTWARE_VARIANTS_H */
