
/*
 * arp.h
 */

#ifndef ARP_H
#define ARP_H

#define ARP_OK   0
#define ARP_FREE 1
#define ARP_USED 2
#define ARP_COLL 3
#define ARP_ERR  4

#include <net/ethernet.h>
#include <sys/types.h>

#include "if.h"

#define MAC_BCAST_ADDR	"\xff\xff\xff\xff\xff\xff"

struct arpMsg {
	struct ether_header ethhdr;	 		/* Ethernet header */
	u_short  	htype;				/* hardware type (must be ARPHRD_ETHER) */
	u_short  	ptype;				/* protocol type (must be ETH_P_IP) */
	u_char   	hlen;				/* hardware address length (must be 6) */
	u_char   	plen;				/* protocol address length (must be 4) */
	u_short  	operation;			/* ARP opcode */
	u_char   	sHaddr[6];			/* sender's hardware address */
	in_addr_t	sInaddr;			/* sender's IP address */
	u_char  	tHaddr[6];			/* target's hardware address */
	in_addr_t	tInaddr;			/* target's IP address */
	u_char   	pad[18];			/* pad for min. Ethernet payload (60 bytes) */
} __attribute__ ((__packed__));


#endif

int send_arp(in_addr_t inaddr, struct ifinfo *ifbuf);
int recv_arp(in_addr_t inaddr, struct ifinfo *ifbuf, long timeout, int send_new_arp);

      
