/*
 * if.c
 *
 * Mostly ripped from dhcpd, Yoichi Hariguchi.
 *
 */

#include <stdio.h>
#include <linux/if_ether.h>
#include <linux/sockios.h>
#include <netinet/in.h>
#include <stdio.h>
#include <string.h>
#include <syslog.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <errno.h>
#include <net/if_arp.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <unistd.h>

#include "if.h"

struct ifinfo ifbuf;

void logSysRet(char *msg)
{
	syslog(LOG_INFO, "DBG : %s\n", msg);
}

void logSysExit(char *msg)
{
	logSysRet(msg);
	exit(0);
}

void logQuit()
{
}

	
void
if_gethwaddr(char *ifname)
{
	int s;
	struct ifreq ifr;

	bzero((char *)&ifbuf, sizeof(ifbuf));

	strncpy(ifbuf.ifname, ifname, sizeof(ifbuf.ifname));
	strncpy(ifr.ifr_name, ifname, sizeof(ifr.ifr_name));

	if ( (s = socket(AF_PACKET, SOCK_PACKET, 0)) < 0 ) {
		syslog(LOG_INFO, "socket : %s", strerror(errno));
		exit(1);
	}
	if ( ioctl(s, SIOCGIFHWADDR, &ifr) < 0 ) {
		syslog(LOG_INFO, "SIOCGIFHWADDR : %s", strerror(errno));
		exit(1);
	}
	if ( ifr.ifr_hwaddr.sa_family != ARPHRD_ETHER ) {
		syslog(LOG_INFO, "Interface is not ethernet");
		exit(1);
	}

	// save hardware address of the interface

	bcopy(ifr.ifr_hwaddr.sa_data, ifbuf.haddr, sizeof(ifbuf.haddr));

	close(s);
}

void if_config(struct ifinfo * ifinfo)
{
	int			s;
	struct ifreq		ifr;
	struct sockaddr_in	*p;

	strncpy(ifr.ifr_name, ifinfo->ifname, sizeof(ifr.ifr_name));

	if ( (s = socket(AF_INET, SOCK_DGRAM, 0)) < 0 ) {
		logSysExit("socket (ifConfig)");
	}

	// configure interface

	p = (struct sockaddr_in *)&(ifr.ifr_addr);
	p->sin_family = AF_INET;
	p->sin_addr.s_addr = ifinfo->addr;
	if ( ioctl(s, SIOCSIFADDR, &ifr) < 0 ) {
		logSysExit("ioctl SIOCSIFADDR (ifConfig)");
	}
	p->sin_addr.s_addr = ifinfo->bcast;
	if ( ioctl(s, SIOCSIFBRDADDR, &ifr) < 0 ) {
		logSysExit("ioctl SIOCSIFBRDADDR (ifConfig)");
	}

	p->sin_addr.s_addr = ifinfo->mask;
	if ( ioctl(s, SIOCSIFNETMASK, &ifr) < 0 ) {
		logSysExit("ioctl SIOCSIFNETMASK (ifConfig)");
	}

	ifr.ifr_flags = ifinfo->flags;
	if ( ioctl(s, SIOCSIFFLAGS, &ifr) < 0 ) {
		logSysExit("ioctl SIOCSIFFLAGS (ifConfig)");
	}

	close(s);
}

void if_down(struct ifinfo * ifinfo)
{
	int			s;
	struct ifreq	ifr;

	strncpy(ifr.ifr_name, ifinfo->ifname, sizeof(ifr.ifr_name));

	if ( (s = socket(AF_INET, SOCK_DGRAM, 0)) < 0 ) {
		logSysExit("socket (ifDown)");
	}

	/* down interface
	 */
	ifr.ifr_flags = 0;

	if ( ioctl(s, SIOCSIFFLAGS, &ifr) < 0 ) {
	logSysExit("ioctl SIOCSIFFLAGS (ifDown)");
	}
	close(s);
}

	