/* 
 * if.h
 */
 
#ifndef IF_H
#define IF_H

#ifdef EMBED
#define in_addr_t uint32_t
#endif

#include <net/if.h>
#include <netinet/in.h>

#define isClassA(_addr)	(!(_addr & htonl(0x80000000)))
#define isClassB(_addr)	((_addr & htonl(0xc0000000)) == htonl(0x80000000))
#define isClassC(_addr)	((_addr & htonl(0xe0000000)) == htonl(0xc0000000))
#define isAutoIP(_addr) ((_addr & htonl(IN_CLASSB_NET)) == htonl(AUTOIP_NET))

struct ifinfo {
	char 		ifname[IFNAMSIZ];
	in_addr_t	addr;
	in_addr_t	mask;
	in_addr_t	bcast;
	u_char		haddr[6];
	short		flags;
};

/* global variables in if.c
 */
extern struct ifinfo Ifbuf;


/* function prototypes
 */
void	if_gethwaddr(char *ifname);
void	if_config(struct ifinfo *ifbuf);
void	if_down(struct ifinfo *ifbuf);

#endif
