#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <aplog_defs.h>


/*
#define LOGFILE "/var/log/aplog.log"
#define MAX_MSG_LEN 128

struct log_header_t {
	unsigned long current_number;
	int head_slot;
	int tail_slot;
	int num_slots;
};
        
struct log_entry_t {
	unsigned long number;
	time_t firsttime;
	time_t lasttime;	
	unsigned int count;
	unsigned int eventid;
	char msg[MAX_MSG_LEN];
};
*/

static FILE *f;
static struct aplog_header_t header;
static struct aplog_entry_t entry;

int
aplogview_main(int argc, char **argv)
{
	unsigned long curnum;
	int max;
	unsigned long index;
	int i;

	f=fopen(APLOGFILE, "r");

	if(f==NULL) {
		fprintf(stderr, "Error opening %s : %s", APLOGFILE, strerror(errno));
		exit(1);
	}

	fread(&header, sizeof(header), 1, f);

	curnum  = header.current_number;
	max     = header.num_slots;

	if(argc == 2) {
		index = atol(argv[1]);
	
		if(index > curnum) {
			printf("Record number %d not yet in log\n", index);
			exit(1);
		}

		if(index <= (curnum - max)) {
			printf("Record number %d no longer in log\n", index);
			return(1);
		}
		
		
		showrecord(index);
		return(0);
	} 

	i=curnum-max+1;
	if(i<1) i=1;	

	for(; i<=curnum; i++) {
		showrecord(i);
	}


	fclose(f);
}


static int
showrecord(unsigned long index)
{
	int fptr;
	struct tm *tm1;
	int entrynum;
	int h1,m1,s1;
	int h2,m2,s2;

	entrynum = (index % header.num_slots);

	fptr = sizeof(header) + entrynum * sizeof(entry);
	
	fseek(f, fptr, 0);
	fread(&entry, sizeof(entry), 1, f);
	
	if(entry.firsttime != 0) {
		tm1 = localtime(&entry.firsttime);
		h1 = tm1->tm_hour;	
		m1 = tm1->tm_min;
		s1 = tm1->tm_sec;
		tm1 = localtime(&entry.lasttime);
		h2 = tm1->tm_hour;	
		m2 = tm1->tm_min;
		s2 = tm1->tm_sec;

		printf(	"%5ld [%02dm %02dd %02d:%02d:%02d-%02d:%02d:%02d] %2d %08x %s\n",
	
			entry.number, 
	
			tm1->tm_mon + 1,
			tm1->tm_mday,

			h1, m1, s1,
			h2, m2, s2,

			entry.count,
	        entry.eventid,
			entry.msg
		);

	}
	
}
