# $Header$
#
# busybox - multi functional toolbox
# Copyright (C) 2001 Intersil Americas Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
# Busybox all in one makefile
#
include $(ROCKBASE)/make_include/base_defs.mk

include applet_source_list

BB_APP_EXEC_NAME = $(APPLET_SOURCES:.c=)

LINK_LIST = $(subst _, , $(BB_APP_EXEC_NAME))


.EXPORT_ALL_VARIABLES:

.PHONY : all
all: applet_source_list make_exec make_links

applet_source_list: busybox.allinone.sh $(ROCKBASE)/appbuild/busybox/Config.h
		(echo -n "APPLET_SOURCES := "; $(SHELL) $^ ) > applet_source_list
		cp applet_source_list applet_source_list_allinone

.PHONY: make_exec
make_exec:
	make -f Makefile.busybox halfclean 
	make -f Makefile.busybox all CFLAGS_EXTRA+=-DBB_ALL_IN_ONE APP_EXEC_NAME=busybox

.PHONY: make_links
make_links:
	for i in $(LINK_LIST); \
	do ln -s -f busybox $(EXECDIR)/$$i; \
	done

.PHONY: halfclean
halfclean:
	make -f Makefile.busybox halfclean APP_EXEC_NAME=busybox
	
.PHONY: clean
clean:
	make -f Makefile.busybox clean APP_EXEC_NAME=busybox
	for i in $(LINK_LIST); \
	do rm -f $(EXECDIR)/$$i; \
	done

	
	
	

	
