# $Header$
#
# busybox - multi functional toolbox
# Copyright (C) 2001 Intersil Americas Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
# Busybox standalone makefile
#
include $(ROCKBASE)/make_include/base_defs.mk

include applet_source_list
include applet_source_list_c

BB_APP_EXEC_NAME = $(APPLET_SOURCES:.c=)
BB_APP_EXEC_NAME_C = $(APPLET_SOURCES_C:.C=)

.EXPORT_ALL_VARIABLES:

.PHONY : all
all: applet_source_list applet_source_list_c make_exec 

applet_source_list: busybox.standalone.sh $(ROCKBASE)/appbuild/busybox/Config.h 
		(echo -n "APPLET_SOURCES := "; $(SHELL) $^ $(BB_SRC_DIR)) > $@

applet_source_list_c: busybox.standalone.sh $(ROCKBASE)/appbuild/busybox/Config.h 
		(echo -n "APPLET_SOURCES_C := "; $(SHELL) $^ $(BB_SRC_DIR)) | tr a-z A-Z > $@

.PHONY: make_exec
make_exec:
	for i in $(BB_APP_EXEC_NAME_C); \
	do make -f Makefile.busybox halfclean; \
	make -f busybox.standalone_c.mk all BB_APP_EXEC_NAME_C=$$i ; \
	done  	

.PHONY: halfclean
halfclean:
	make -f Makefile.busybox halfclean
		
.PHONY: clean
clean:
	for i in $(BB_APP_EXEC_NAME); \
	do make -f Makefile.busybox clean APP_EXEC_NAME=$$i; \
	make -f busybox.standalone_l.mk clean applet_sources=$$i; \
	done
	
