# $Header$
#
# busybox - multi functional toolbox
# Copyright (C) 2001 Intersil Americas Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
-include applet_source_list_l

TEST=false
KILLALL_IS_TRUE = false

# Extra test if nfsmount is defined.
ifneq ($(BB_APP_EXEC_NAME_C),MOUNT)
else
ifeq ($(findstring nfsmount.c, $(APPLET_SOURCES)),nfsmount.c) 
applet_sources_extra=nfsmount.c
endif
endif

# Extra test if ifconfig status is defined.
ifneq ($(BB_APP_EXEC_NAME_C),IFCONFIG)
else
ifeq ($(findstring interface.c, $(APPLET_SOURCES)),interface.c) 
applet_sources_extra=interface.c
endif
endif

# Test BB_APP_EXEC_NAME_C for non-applets names.

# interface
ifeq ($(BB_APP_EXEC_NAME_C),INTERFACE)
$(filter-out INTERFACE,$(BB_APP_EXEC_NAME_C))
endif

# nfsmount
ifeq ($(BB_APP_EXEC_NAME_C),NFSMOUNT)
$(filter-out NFSMOUNT,$(BB_APP_EXEC_NAME_C))
endif


all: make_exec check_killall make_link

.PHONY: make_exec
make_exec: 
	make -f Makefile.busybox all CFLAGS_EXTRA+=-DBB_$(BB_APP_EXEC_NAME_C) APPLET_SOURCES=$(applet_sources) \
	APP_EXEC_NAME=$(applet_sources:.c=) APPLET_SOURCES+=$(applet_sources_extra); 
	

# Not sure if killall is selected, pretend it is.
ifeq ($(applet_sources:.c=), kill)
KILLALL_IS_TRUE = true
endif

.PHONY: check_killall
check_killall:
	@if $(KILLALL_IS_TRUE); then \
	ln -s -f kill $(EXECDIR)/killall; \
	fi;

LINK_NAME = $(subst _, , $(applet_sources))
CONTAINS_UNDERSCORE = $(findstring _, $(applet_sources))

ifeq ($(CONTAINS_UNDERSCORE), _) 
TEST =true
endif

#
#  STILL NEEDS TEST FOR PIVOT_ROOT, which is one command.
#


.PHONY: make_link
make_link:
	@if $(TEST); then \
	for i in $(LINK_NAME:.c=); \
	do ln -s -f $(applet_sources:.c=) $(EXECDIR)/$$i; \
	done; \
	fi;

.PHONY: clean
clean:
	@if $(TEST); then \
	for i in $(LINK_NAME:.c=); \
	do rm -f $(EXECDIR)/$$i; \
	done; \
	fi;
	@if $(KILLALL_IS_TRUE); then \
	rm -f $(EXECDIR)/killall; fi;
