#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>

#include <sys/socket.h>
#include <sys/ioctl.h> 
#include <net/if.h>
#include <sys/signal.h>

#include <prismoids.h>

int randomseed_main(int argc, char **argv)
{
	char rnddata[256];
	int i;
	int r;
	FILE *f;

	r = get_prismoid("eth0", BLOB_OID_RANDOMDATA, rnddata, 256);
	if ( r<0 ) {
		fprintf(stderr, "PRISMIOCTL BLOB_OID_RANDOMDATA returned %d. (do you have the latest blob installed ?)\n",r);
		return(-1);
	}

	if(argc > 1) {
	
		for(i=0; i<256; i++) {
			if((i%16)==0) {
			printf("\n%04X  ", i);
			}
			printf("%02X ", (int)rnddata[i]);
		}
		printf("\n\n");
	}
	
	f=fopen("/dev/urandom", "w");
	
	if(f==NULL) {
		fprintf(stderr, "Can't write to /dev/random : %s\n", strerror(errno));
		return(-1);
	}
	
	if(fwrite(rnddata, 1, 256, f) != 256) {
		fprintf(stderr, "Can't write 256 bytes of data to /dev/random : %s\n", strerror(errno));
		return(-1);
	}
		
	
	return(0);
}

