#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

char buf[1024];


static int opensock(char *fname)
{
	int fd;
	struct sockaddr_un unix_addr;
	int r;
				

	fd = socket(AF_UNIX, SOCK_STREAM, 0);

	if(fd<0) {
		fprintf(stderr, "Error opening socket : %s\n", strerror(errno));
		exit(1);
	}

	memset(&unix_addr, 0, sizeof(unix_addr));
	unix_addr.sun_family=AF_UNIX;
	strncpy(unix_addr.sun_path, fname, sizeof(unix_addr.sun_path));

	r = connect(fd, (struct sockaddr *)&unix_addr, sizeof(unix_addr));

	if(r<0) {
		fprintf(stderr, "Can't connect : %s\n", strerror(errno));
		exit(1);
	}

	return(fd);
}


int unc_main(int argc, char **argv) 
{
	int fd;
	fd_set fds;
	int r;

	if(argc != 2) {
		printf("Usage: %s <sockname>\n", argv[0]);
		exit(1);
	}

	fd = opensock(argv[1]);


	while(42) {
		
		FD_ZERO(&fds);
		FD_SET(0, &fds);
		FD_SET(fd, &fds);
	
		r = select(fd+1, &fds, NULL, NULL, NULL);
	
		if(FD_ISSET(0, &fds)) {
			r = read(0, buf, sizeof(buf));
			if(r==0) exit(0);
			write(fd, buf, r);
		}
	
		if(FD_ISSET(fd, &fds)) {
			r = read(fd, buf, sizeof(buf));
			if(r==0) exit(0);
			write(0, buf, r);
		}
	}

}


// eof..
