#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <sys/ioctl.h>
#include <sys/mount.h>

#include <linux/mtd/mtd.h>

int main(int argc,char *argv[])
{
   mtd_info_t meminfo;
   int Fd;
   int count;
   int i, offset, ret;
   unsigned char *buf;

   if (argc < 3)
   {
      fprintf(stderr,"Usage: %s <device> <offset in bytes> [<number of bytes to read>]\n", argv[0]);
      return 16;
   }

   offset = atoi(argv[2]);

   if (argc == 4)
   {
      count = atoi(argv[3]);
   }
   else
   {
      count = 1;
   }

   buf = malloc(count);
   if (buf == 0)
   {
      return -1;
   }

   // Open and size the device
   if ((Fd = open(argv[1],O_RDWR)) < 0)
   {
      fprintf(stderr,"File open error\n");
      return 8;
   }


   if ( (ret = lseek(Fd, offset, SEEK_SET)) < 0)
   {
      return ret;
   }
   else
   {
      if ( (ret = read(Fd, buf, count)) < 0 )
      {
         return ret;
      }
      else
      {
         for (i = 0; i < count; i++)
            printf("Data at offset 0x%x = 0x%x\n", offset + i, buf[i]);
      }
   }
   return 0;
}

