#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <time.h>
#include <sys/ioctl.h>
#include <sys/mount.h>

#include <linux/mtd/mtd.h>

int main(int argc,char *argv[])
{
   mtd_info_t meminfo;
   int Fd;
   int count;

   if (1 >= argc)
   {
      fprintf(stderr,"Erase a number of sectors of an MTD device\n");
      fprintf(stderr,"Usage: %s <mtd device> <start address> <number of sectors to erase>\n", argv[0]);
      return 16;
   }

   // Open and size the device
   if ((Fd = open(argv[1],O_RDWR)) < 0)
   {
      fprintf(stderr,"File open error\n");
      return 8;
   }

   if (ioctl(Fd,MEMGETINFO,&meminfo) == 0)
   {
      erase_info_t erase;

      erase.length = meminfo.erasesize;
      printf("Erase Unit Size 0x%lx, ", meminfo.erasesize);

      if (argc > 2)
	  erase.start = atoi(argv[2]);
      else
	  erase.start = 0;

      if (argc > 3)
	  count = atoi(argv[3]);
      else
	  count = 1;

      printf("Erase Total %d Units\n", count);

      for (; count > 0; count--) {
	  printf("\rPerforming Flash Erase of length %lu at offset 0x%lx",
		 erase.length, erase.start);
	  fflush(stdout);

	  if (ioctl(Fd,MEMERASE,&erase) != 0)
	      {
		  perror("\nMTD Erase failure");
		  close(Fd);
		  return 8;
	      }
	  erase.start += meminfo.erasesize;
      }
      printf(" done\n");
   }
   return 0;
}
