/*
 * imginstall.h - image installer program header
 *
 * Copyright (C) 2002 by Intersil Corp.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */
#ifndef _IMGINSTALL_H
#define _IMGINSTALL_H

#include <stdio.h>
#include <rockhopper.h>
#include <flash_layout.h>
#include <image.h>

/* defines */
#define SECTOR_SIZE	( 0x10000 )	/* how images are aligned */
#define REBOOT_TIME     5               /* seconds to wait before reboot */

/* STATUS defines */
#define STATUS_INITIALIZING				(0001)
#define STATUS_INSTALLING_APFIRMWARE                    (1000)
#define STATUS_INSTALLING_UAPFIRMWARE                   (2000)
#define STATUS_INSTALLING_WEBFILESET                    (3000)

#define STATUS_REBOOT                                   (9999)

/* Use (STATUS_ERROR_OFFSET + STATUS_INSTALLING_xxx) to report error
 * in installing xxx
 */
#define STATUS_ERROR_OFFSET                             (10000)

#define STATUS_ERROR_MALLOC                             (10001)
#define STATUS_ERROR_CHANGE_WORKINGDIR_FAILED           (10002)
#define STATUS_ERROR_NO_VALID_IMAGES_INSTALLED          (10003)
#define STATUS_ERROR_UNSUPPORTED_OEM			(10004)
#define STATUS_ERROR_UNSUPPORTED_PRODUCT		(10005)
#define STATUS_ERROR_UNSUPPORTED_HARDWARE		(10006)
#define STATUS_ERROR_INCOMPATIBLE_IMAGES		(10007)
#define STATUS_ERROR_IMAGE_TOO_BIG			(10008)

typedef enum {
   image_nok = 0,
   image_apfirmware,
   image_uapfirmware,
   image_webfileset
} image_type_t;

/* function prototypes */
void imginstall_write_status(int status);

#endif _IMGINSTALL_H

