/*  $Header$
 *  
 *  sdhcp - simple dhcp server
 *  Copyright (C) 2001 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef _DEBUG_H
#define _DEBUG_H

#include <stdio.h>
#include <sys/types.h>

#include "sdhcpd.h"

/*
 * DEBUG levels
 */
#define DBL_NONE	0
#define DBL_ERROR	1
#define DBL_WARNING	2
#define DBL_NOTICE	3
#define DBL_DEBUG	4
#define DEBUG DBL_NOTICE

/*
 * log syslog messages on stderr and/or syslog
 * undefine to disable
 */
/* #define DBL_SYSLOG */
#define DBL_LOCAL

#define LP fprintf(stderr, "FUNC: %s, FILE: %s, LINE: %d\n", __FUNCTION__, __FILE__, __LINE__);

/* function prototypes */
void error (char *, ...);
void warn (char *, ...);
void note (char *, ...);
void debug (char *, ...);

void print_leases();
char *print_hw_addr( const unsigned char *data, int len);
char *print_client_state( const client_state_t state );


#endif /* _DEBUG_H */

