/*
 *  util_funcs.h:  utilitiy functions for extensible groups.
 */
#ifndef _MIBGROUP_UTIL_FUNCS_H
#define _MIBGROUP_UTIL_FUNCS_H

#ifdef IN_UCD_SNMP_SOURCE
#include "struct.h"
#else
#include <ucd-snmp/struct.h>
#endif

void Exit (int);
int shell_command (struct extensible *);
int exec_command (struct extensible *);
int get_exec_output (struct extensible *);
int get_exec_pipes (char *cmd, int *fdIn, int *fdOut, int *pid);
WriteMethod clear_cache;
RETSIGTYPE restart_doit (int);
WriteMethod restart_hook;
void print_mib_oid (oid *, size_t);
void sprint_mib_oid (char *, oid *, size_t);
int header_simple_table (struct variable *, oid *,  size_t *, int,  size_t *, WriteMethod **write_method, int);
int header_generic (struct variable *,oid *,  size_t *, int,  size_t *, WriteMethod **);
int checkmib (struct variable *, oid *,  size_t *, int,  size_t *, WriteMethod **write_method, int);
int header_double_indexed_table(struct variable *vp, oid *name, size_t *length,
 				 int exact, size_t *var_len, WriteMethod **write_method,
 				 long (*idx1_getfirstfunc) (void),
 				 long (*idx1_getnextfunc) (long),
 				 long (*idx2_getfirstfunc) (long),
 				 long (*idx2_getnextfunc) (long, long));

int header_indexed_table(struct variable *vp, oid *name, size_t *length,
 				 int exact, size_t *var_len, WriteMethod **write_method,
 				 int *table_row, oid index_table[],
 				 int index_table_M, int index_table_N);




char *find_field (char *, int);
int parse_miboid (const char *, oid *);
void string_append_int (char *, int);
void wait_on_exec (struct extensible *);

#define     satosin(x)      ((struct sockaddr_in *) &(x))
#define     SOCKADDR(x)     (satosin(x)->sin_addr.s_addr)
#ifndef MIB_STATS_CACHE_TIMEOUT
#define MIB_STATS_CACHE_TIMEOUT 5
#endif

typedef void * mib_table_t;
typedef int(RELOAD)( mib_table_t );
typedef int(COMPARE)(const void*, const void* );
mib_table_t Initialise_Table( int, int, RELOAD, COMPARE);
int  Search_Table( mib_table_t, void*, int);
int  Add_Entry( mib_table_t, void*);
void *Retrieve_Table_Data( mib_table_t, int*);

u_long marker_uptime( marker_t pm );
u_long marker_tticks( marker_t pm );
u_long timeval_uptime( struct timeval *tv );
u_long timeval_tticks( struct timeval *tv );

/* Generic row status handler for snmp tables */
int HandleGenericRowStatus (int 	*CurrentRowStatus,
	  		    int  	 ActionRowStatus,
			    int        (*RowSpecFunc) (int, int),
			    int 	index);

/* Defines for arguments in RowSpecFunc for HandleGenericRowStatus function */
#define SNMP_GEN_ROW_DELETE	1
#define SNMP_GEN_ROW_VALIDATE	2

#define address_fprintf(s,a)  (fprintf(stderr, "%s %2.2x-%2.2x-%2.2x-%2.2x-%2.2x-%2.2x\n", s, a[0], a[1], a[2], a[3], a[4], a[5]))
#endif /* _MIBGROUP_UTIL_FUNCS_H */
