/* files.h */
#ifndef _FILES_H
#define _FILES_H

/* Defines for writing out the snmp file. Needed for STATE_CLIENT_XXX
 * Must match the defines in ucd-snmp/agent/mibgroup/snmpGen/dhcpServer.h
 */
#define STATE_CLIENTNOTINUSE      0
#define STATE_CLIENTACTIVE        1
#define STATE_CLIENTEXPIRED       2
#define STATE_CLIENTCONFIGURED    3
#define STATE_CLIENTREFUSED       4
#define STATE_REFUSEDBYCLIENT     5


struct config_keyword {
    char keyword[20];
    int (*handler) (char *line, void *var);
    void *var;
    char def[40];
};


int read_config(char *file, int read_defaults);
void write_leases(int dummy);
void write_temp_leases(int dummy);
int read_static_snmp_leases(char *file);
int read_static_leases(char *file);
void read_leases(char *file, char *static_file);
int check_config();
int check_outstanding(u_int32_t addr, struct dhcpOfferedAddr *lease);
void cmp_file_time();

#endif
