/*  $Header$
 *
 *  upgraded - specialized tftp upgrade daemon
 *  Copyright (C) 2001 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include <stdlib.h>
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <inl_misc.h>

#include "confparse.h"
#include "inl_debug.h"

/******************************************************************************
 * local defines
 *****************************************************************************/
#define LOCAL_BUF_SIZE 128

/*****************************************************************************
 * NAME:
 *	get_lock_status
 *
 * DESCRIPTION:
 *	Read the current lock status of the AP.
 *
 * PARAMETERS:
 *	filename
 *
 * RETURN:
 *	-1 on error
 *	 0 if AP is not locked
 *	 1 if AP is locked
 *****************************************************************************/
int get_lock_status(const char *filename)
{
//TODO: determine lockstatus (easily...)

    return 0;
}

/*****************************************************************************
 * NAME:
 *	get_password
 *
 * DESCRIPTION:
 *	Read the write_community_string for use as password
 *
 * PARAMETERS:
 *	filename
 *
 * RETURN:
 *	password, NULL in case of error
 *****************************************************************************/
char *
get_password(void)
{
    static char passwd[LOCAL_BUF_SIZE];

    if(snmp_get_wcs(passwd, LOCAL_BUF_SIZE) < 0) {
  	warn("Failed to get SNMP password\n");
  	return NULL;
    }

    return passwd;
}


