/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2003 Intersil Americas Inc. All Rights Reserved.
 */

#include <assert.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include "aplog.h"

static char errorbuf[160];

int datastore_assert(char* expr, char* file, char* func, int line) {
	FILE* fp;
	
	snprintf(errorbuf, sizeof(errorbuf), "Assertion failed (assert(%s)) in function %s in %s:%i", expr, func, file, line);

	fp = fopen("/usr/etc/assert.log", "a");
	setvbuf(fp, NULL, _IONBF, 0);
	fprintf(fp, "%s\n", errorbuf);
	fclose(fp);

	fprintf(stderr, "%s\n", errorbuf);	
	
	/* log to aplog. If syslog or snmptrap hosts are defined, the assert 
	 * message will be sent to these hosts*/
	aplog(EV_SNMP_GENERAL_ERROR, errorbuf, NULL);

	fp = fopen("/usr/etc/datastore.dat", "r");
	if (fp) {
		/* only reboot if the datastore.dat file was present. This prevent endless rebooting */
		unlink("/usr/etc/datastore.dat");
		fclose(fp);
		sleep(5); /* sleep for a while to let all syslog/snmp messages get sent */
		system("/bin/reboot");
	}
	fclose(fp);
	exit(1);
	return (1);
		
}
