/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#include "types.h"

/** @file config.c
 *
 * @brief Definition of all modules of the datastore.
 *
 * The array modulelist, which is defined in this file, defines the
 * modules that should be loaded in the datastore. The order in the
 * array is the order in which the modules are started. Be sure to
 * end the array with a 'NULL'
 *
 */

extern struct moddescr_t mod_eventlog;
extern struct moddescr_t mod_eventcontrol;
extern struct moddescr_t mod_eventfacility;
extern struct moddescr_t mod_system;
extern struct moddescr_t mod_mibII_interfaces;
extern struct moddescr_t mod_mibII_snmp;
extern struct moddescr_t mod_mibII_ip;
extern struct moddescr_t mod_mibII_icmp;
extern struct moddescr_t mod_mibII_ifMIB_ifStackTable;
extern struct moddescr_t mod_dot11smt_sc;
extern struct moddescr_t mod_mibII_tcp;
extern struct moddescr_t mod_mibII_udp;
extern struct moddescr_t mod_dot11smt_aa;
extern struct moddescr_t mod_dot11smt_priv;
extern struct moddescr_t mod_dot11mac_op;
extern struct moddescr_t mod_dot11mac_count;
extern struct moddescr_t mod_isl_prism_identification;
extern struct moddescr_t mod_portforward;
extern struct moddescr_t mod_dot11phy_op;
extern struct moddescr_t mod_dot11phy_ir;
extern struct moddescr_t mod_dot11phy_txpower;
extern struct moddescr_t mod_dot11phy_antenna;
extern struct moddescr_t mod_dot11phy_antennalist;
extern struct moddescr_t mod_dot11phy_dsss;
extern struct moddescr_t mod_dot11phy_ofdm;
extern struct moddescr_t mod_dot11phy_fhss;
extern struct moddescr_t mod_dot11phy_hrdss;
extern struct moddescr_t mod_dot11phy_txdatarates;
extern struct moddescr_t mod_dot11phy_rxdatarates;
extern struct moddescr_t mod_dot11phy_domsup;
extern struct moddescr_t mod_dot11res;
extern struct moddescr_t mod_dot11ExtAPObjs_security;
extern struct moddescr_t mod_web;
extern struct moddescr_t mod_dhcp_cfg;
extern struct moddescr_t mod_dhcp_client;
extern struct moddescr_t mod_isl_standardext_generic_snmp;
extern struct moddescr_t mod_snmp_trapdst;
extern struct moddescr_t mod_isl_standardext_generic_wan;
extern struct moddescr_t mod_wds_MACTable;
extern struct moddescr_t mod_dns;
extern struct moddescr_t mod_dot11extsmt;
extern struct moddescr_t mod_dot1X;
extern struct moddescr_t mod_ulauth;
extern struct moddescr_t mod_paed_cfg;
extern struct moddescr_t mod_bridge_base;
extern struct moddescr_t mod_bridge_stp;
extern struct moddescr_t mod_bridge_dot1dTp;
extern struct moddescr_t mod_ipCidrRoute;
extern struct moddescr_t mod_mibII_ifMIB_ifStackTable;
extern struct moddescr_t mod_isl_standardext_generic_radius;
extern struct moddescr_t mod_isl_dot11ext2_iapp;
extern struct moddescr_t mod_dot11ext2_phySupportTable;
extern struct moddescr_t mod_dot11ext2_smtCountrySupport;
extern struct moddescr_t mod_dot11ext2_smtChannelSetTable;
extern struct moddescr_t mod_isl_standardext_generic_firewall;
extern struct moddescr_t mod_isl_dot11ext2_bssTable;
extern struct moddescr_t mod_isl_dot11ext2_clientTable;
extern struct moddescr_t mod_isl_standardext_generic_wlan;

struct moddescr_t *modulelist[] = {
	&mod_isl_prism_identification,
	&mod_system,
	&mod_mibII_interfaces,
	&mod_mibII_snmp,

	&mod_snmp_trapdst,
	&mod_mibII_ip,
	&mod_dot11phy_antenna,
	&mod_dot11phy_antennalist,
	&mod_dot11phy_hrdss,
	&mod_dot11phy_rxdatarates,
	&mod_dot11phy_txdatarates,
	&mod_dot11phy_domsup,
	&mod_dot11smt_aa,
	&mod_dot11smt_priv,
	&mod_dot11mac_op,
	&mod_dot11ExtAPObjs_security,
	&mod_dot11mac_count,
	&mod_dot11res,
	&mod_web,
	&mod_eventlog,
	&mod_eventcontrol,
	&mod_eventfacility,
	&mod_portforward,
	&mod_wds_MACTable,
	&mod_dns,
	&mod_dot1X,
	&mod_mibII_tcp,
	&mod_mibII_icmp,
	&mod_mibII_udp,
	&mod_ulauth,
	&mod_paed_cfg,
	
	
	&mod_ipCidrRoute,
	&mod_mibII_ifMIB_ifStackTable,
	&mod_dot11ext2_smtCountrySupport,
	&mod_dot11ext2_smtChannelSetTable,
	&mod_dot11ext2_phySupportTable,
	&mod_dot11phy_dsss,
	&mod_dot11phy_ofdm,
	&mod_isl_standardext_generic_radius,
	&mod_isl_dot11ext2_iapp,
	&mod_bridge_base,
	&mod_bridge_stp,
	&mod_bridge_dot1dTp,
	&mod_isl_standardext_generic_firewall,
	&mod_isl_standardext_generic_wan,
	&mod_isl_standardext_generic_wlan,
	&mod_dhcp_client,
	&mod_isl_standardext_generic_snmp,
	&mod_dhcp_cfg,
	&mod_isl_dot11ext2_bssTable,
	&mod_isl_dot11ext2_clientTable,
	/* mod_dot11smt depend on mod_dot11phy_dsss & mod_dot11phy_ofdm */
	&mod_dot11extsmt, /* should be before mod_dot11phy_op */
	&mod_dot11phy_op, /* should be after dot11phy_domsup */
	&mod_dot11smt_sc,
	&mod_dot11phy_txpower,
	NULL
};
