/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */


#include <stdio.h>
#include <string.h>

#include "types.h"
#include "handler.h"
#include "debug.h"

extern struct moddescr_t *modulelist[];


int modules_init(void)
{
	int i;
	struct moddescr_t *mod;
	struct handler_t *hnd_get=NULL;
	struct handler_t *hnd_set=NULL;
	struct handler_t *hnd_chk=NULL;
	char *p1, *p2;
	char oid[MAX_OID_LENGTH];

	/* Call the Init functions from all modules */	
	i = 0;
	while(modulelist[i]) {
		mod = modulelist[i];

		if(mod->fn_ini)	{ 
			dbg(DBG_MODULE, "calling module %s's init function", mod->name);
			mod->fn_ini();
		}
		
		i++;
	}
	
	/* Call the Get functions */
	i = 0;
	while(modulelist[i]) {
		mod = modulelist[i];
		
		if(mod->fn_get)	{ 
			dbg(DBG_MODULE, "calling module %s's get function", mod->name);
			mod->fn_get();
		}
		
		i++;
	}
	
	i = 0;	
	/* Call the Set functions */
	while(modulelist[i]) {
		mod = modulelist[i];
		
		if(mod->fn_set)	{ 
			dbg(DBG_MODULE, "calling module %s's set function", mod->name);
			mod->fn_set();
		}
		
		i++;
	}
	
	i = 0;
	/* Call the post Init functions */
	while(modulelist[i]) {
		mod = modulelist[i];
		
		if(mod->fn_pin)	{ 
			dbg(DBG_MODULE, "calling module %s's post init function", mod->name);
			mod->fn_pin();
		}
		
		i++;
	}

	i = 0;
	/* Register the handlers for the modules */
	while(modulelist[i]) {
		mod = modulelist[i];

		if(mod->fn_get)	hnd_get = handler_add(H_GET, mod->fn_get);
		if(mod->fn_set)	hnd_set = handler_add(H_SET, mod->fn_set);
		if(mod->fn_chk)	hnd_chk = handler_add(H_CHK, mod->fn_chk);
	
		p1 = p2 =  mod->oidlist;
	
		while(p2 && *p1) {
			int len;
			
			p2 = strchr(p1, ' ');
			len = p2 - p1;
	
			if(len > 0) {
				strncpy(oid, p1, len);
				oid[len] = 0;
			} else {
				strcpy(oid, p1);
			}
	
			if(mod->fn_get) handler_connect(hnd_get, oid);
			if(mod->fn_set) handler_connect(hnd_set, oid);
			if(mod->fn_chk) handler_connect(hnd_chk, oid);

	
			p1 = p2 + 1;
		}
		
		
		i++;
	}

	return(0);
}

// eot
