#include <unistd.h>
#include <assert.h>
#include <string.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "dsmoduleapi.h"

////////////////////////////

static int set(struct schent_t *bogussch, char *oid)
{
	int *sport;
	int *dport;
	int *proto;
	in_addr_t *addr;

	ds_table *tbl;
	ds_row *row;

	ds_object_set(".1.3.6.1.2.1.1.4.0", ds_chr2os("Blaat"));

	tbl = ds_table_get(".1.3.6.1.4.1.937.6.2.2.3.1.1");
	
	row = ds_table_firstrow(tbl);

 	while(row) {

		ds_table_getrow(row, NULL, &sport, &dport, &proto, &addr, NULL);

		if(sport && dport && proto && addr) {	
	
	 		printf("iptables -t nat -A PREROUTING -j DNAT --sport %d --to-destination %s:%d\n",
 				*sport,
 				addr2asc(*addr),
 				*dport);
 		}
 	
 		row = ds_table_nextrow(tbl);
 	}

	return(0);

}



ds_module mod_portforwarding = {

	__FILE__,
	NULL,
	NULL,
	set,
	NULL,
	".1.3.6.1.4.1.937.6.2.2.3.1.1"
};


/*

The following schema entries are provided by this module :

O .1.3.6.1.4.1.937.6.2.2.3.1.1
L portForwardingEntry
T TABLE

	O .1.3.6.1.4.1.937.6.2.2.3.1.1.1
	L portForwardingIndex
	T INTEGER32
	I 1

	O .1.3.6.1.4.1.937.6.2.2.3.1.1.2
	L portForwardingFromPort
	T INTEGER32
	A C
	R 0/65535

	O .1.3.6.1.4.1.937.6.2.2.3.1.1.3
	L portForwardingToPort
	T INTEGER32
	A C
	R 0/65535

	O .1.3.6.1.4.1.937.6.2.2.3.1.1.4
	L portForwardingProtocol
	T INTEGER
	A C
	R 1,2,3

	O .1.3.6.1.4.1.937.6.2.2.3.1.1.5
	L portForwardingLocalAddress
	T IPADDR
	A C

	O .1.3.6.1.4.1.937.6.2.2.3.1.1.6
	L portForwardingRowStatus
	T ROWSTAT
	A C
	R 1,2,3,4,5,6

*/
