/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */
#ifndef _DATASTORE_DEBUG_H_
#define _DATASTORE_DEBUG_H_
/** @file debug.h
 *
 * Functions for structured debugging output
 */

#define DBG_NETWORK	(1 <<  0)
#define DBG_OBJECT	(1 <<  1)
#define DBG_MODULE	(1 <<  2)
#define DBG_TABLE	(1 <<  3)
#define DBG_CFGFILE	(1 <<  4)
#define DBG_JOURNAL	(1 <<  5)
#define DBG_RANGE	(1 <<  6)
#define DBG_HANDLER	(1 <<  7)
#define DBG_SCHEMA	(1 <<  8)

extern int debugcolor;


/** Print a debugline if the given DBG_... flag is set with dbg_initflags */
void dbg(int flag, char *fmt, ...);

/** Enable debugging for the given flags */
void dbg_initflags(char *flags);

/** Print a list of known debug flags */
void dbg_showflags(void);

#endif
