/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */
#ifndef _DATASTORE_DSMODULEAPI_H_
#define _DATASTORE_DSMODULEAPI_H_
/** @file dsmoduleapi.h
 *
 * Various functions to handle objects in the data store for use in MIB modules.
 * These functions try to hide as much as possible from the underlying data structures
 * and SNMP dependencies, so that the MIB modules can be coded cleanly, without the
 * need to handle SNMP specific cases.
 *
 */
#include "types.h"
#include "object.h"

/** table handling struct */

struct ds_table_t {
    struct schent_t *sch;
    struct table_t *tbl_row;
};


typedef struct ds_table_t ds_table;
typedef struct table_t ds_row;
typedef struct octetstr_t ds_octetstr;
typedef struct moddescr_t ds_module;

ds_table *ds_table_get(char *oid);
int ds_table_done(ds_table *dst);

int ds_table_checktypes(ds_table *dst, char *fmt);

int ds_table_done(ds_table *dst);

int ds_table_delete(ds_table *dst);

ds_row *ds_table_firstrow(ds_table *dst);
ds_row *ds_table_nextrow(ds_table *dst);

ds_row *ds_table_addrow(ds_table *dst, ...);
int ds_table_fillrow(ds_row *row, ...);

int ds_table_getrow(ds_row *row, ...);

int ds_table_getcell(ds_row *row, int column, ...);
int ds_table_setcell(ds_row *row, int column, ...);


ds_octetstr *ds_chr2os(char *str);

char *ds_os2chr(ds_octetstr *os);

#endif /* _DSTORE_API_H_ */

