/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */
#ifndef _DATASTORE_SCHEMA_H_
#define _DATASTORE_SCHEMA_H_
/** @file schema.h
 *
 *  functions to handle schema objects and read the schema from file
 */

#include "types.h"

/** Initialize the schema AVL tree */
int schema_inittree(void);

/** Read the schema from the given definition file from disk */
int schema_read(char *fname);

/** Get a pointer to a schent_t by the given oid, or NULL if not found */
struct schent_t *schema_get(char *oid);

/** Get a pointer to the first 'parent' schent_t of the given OID, or NULL if not found */
struct schent_t *schema_find_schent_for_oid(char *oid);

/** Returns a pointer to the first row of a schema entry. Return NULL is this
 * schent is not a table entry or if no rows are present. This function ensures
 * that the rows contain valid data by calling the get handlers if needed */
struct row_t *schema_get_first_row(struct schent_t* sch);

/** Dump an ASCII representation of the complete schema in the tree */
void schema_dump(void);

/** Returns TRUE is both schema entries have the same parent (table) */
int schema_are_related(struct schent_t* sch1, struct schent_t* sch2);

#endif
