/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2003 Intersil Americas Inc. All Rights Reserved.
 */

#include <stdio.h>
#include <string.h>
#include "iface_snmp_hexstring.h"

/*
 * These functions encode and decode strings that contain non-printable characters
 * for transmission over the network
 */


/*
 * Return 1 if this string contains non-printable characters
 */

int string_needs_encode(unsigned char *in, int inlen, u_char flags)
{
	int i;

	for(i=0; i<inlen; i++) {
		if((in[i] < 32) 
		   || (in[i] > 127) 
		   || ((in[i] == 0x20) && ((flags & HEXSTRING_FLAGS_NOSPACES) == HEXSTRING_FLAGS_NOSPACES ))
		) {
			return(1);
		}
	}
	return(0);
}

// Encode a string to "HEX:...." format

int string_encode(char *in, int inlen,  char *out, int maxoutlen)
{
	char *list = "0123456789ABCDEF";
	char *p;
	int i;
	int l;

	l=0;
	p=out;

	p += sprintf(out, "HEX:");

	for(i=0; i<inlen; i++) {
		if((p-out) > (maxoutlen-1)) break;
		p += sprintf(p, "%c%c", list[(in[i]>>4)&0xf], list[in[i]&0xf]);
	}

	return(p-out);	
}

// decode "HEX:...." format to a string

int string_decode(char *in, char *out, int maxoutlen)
{
	char *p, *q;
	int a;
	int j;

	if(strncmp(in, "HEX:", 4) != 0) {
		strncpy(out, in, maxoutlen);
		return(strnlen(out, maxoutlen));
	}

	p = out;
	q = in+4;

	while(*q && *q+1 && (p-out < maxoutlen-1)) {
		*p=0;
		for(j=0; j<2; j++) {
			a=0;
			if((*q >= '0') && (*q<='9')) a = (*q) - '0';
			else if((*q >= 'A') && (*q<='F')) a = *q - 'A' + 10;
			else if((*q >= 'a') && (*q<='f')) a = *q - 'a' + 10;
			*p = (*p<<4) + a;
			q++;
		}
		p++;
	}
	
	*p=0;

	return(p-out);
}
