/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include <assert.h>
#include <stdio.h>
#include <sys/wait.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <sys/stat.h>

#include "table.h"
#include "misc.h"
#include "objdata.h"
#include "mod_mibII_interfaces.h"
#include "cfg_file_lib.h"
#include "schema.h"
#include "object.h"
#include "objflag.h"
#include "lib_calls.h"
#include <net/if.h>
#include <aplog_defs.h>
#include <aplog.h>

#define CFGNAME "udhcpd"
#define CFGNAME_RESERVATION "dhcpServer"
#define RESOLV "/etc/resolv.conf"

#ifndef MAX_IPADDR_STR
#define MAX_IPADDR_STR 16
#endif

#ifndef UDHCPD_PID_FILE
#define UDHCPD_PID_FILE "/var/run/udhcpd.pid"
#endif 

char* get_dns_from_mib( char* dnsbuf,int i)
{
	char dns[MAX_IPADDR_STR];
	struct in_addr *dnsaddr;
	int counter=0;

	struct schent_t *sch;
	struct row_t *row;
	struct object_t *obj;
		
	sch = schema_get(".1.3.6.1.4.1.937.2.1.11.2.14.1");
	assert(sch);

	row = sch->rowlist;
	while(row) 
	{
		counter++;
		dns[0]='\0';
		
		obj = row_get_obj(row, 1);
		dnsaddr=object_get_ipaddr(obj);
		
		strncpy(dns, inet_ntoa(*dnsaddr), sizeof(dns));

		if(strlen(dns)>0 && counter == i)
		{
			strcpy(dnsbuf,dns);
			return dnsbuf;			

		}	
		row = row->next;
	}
	return NULL;
	
}

char* get_dns_from_resolv(char* filename, char* dnsbuf,int i)
{
	FILE* file;
	char dns[MAX_IPADDR_STR];
	char temp[256];
	int counter=0;


	file = fopen(filename,"r");
	if(file == NULL)
	{
		return NULL;
	}

	while(fgets(temp, sizeof(temp), file))
	{
		dns[0]='\0';
		sscanf(temp,"nameserver %s\n",dns);
		if(strlen(dns)>0 && ++counter == i)
		{
			strcpy(dnsbuf,dns);
				
		}		
	}
	fclose(file);	
	return dnsbuf;			
}

static int set(void)
{
	struct object_t *obj;
	int enable=3;
	int verifyfirst;
	int trustclient;
	struct in_addr *subnet;
	struct in_addr *mask;
	struct in_addr *minaddr;
	struct in_addr *maxaddr;
	struct in_addr *router;
	int leasetime;
	FILE* fp;
	struct in_addr *res_ipaddr;
	struct string_t *res_macaddr;
	struct schent_t *sch;
	struct row_t *row;
	FILE* resfp;
	int rowstat;

	char ipvalue[32];
	char macaddress[32];
	char macvalue[32];
	struct index_t *index;
	
	char dns1[MAX_IPADDR_STR];
	char dns2[MAX_IPADDR_STR];
	char dns3[MAX_IPADDR_STR];
	dns1[0]='\0';
	dns2[0]='\0';
	dns3[0]='\0';
	
	obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.1.0");
	assert(obj);
	enable = object_get_int(obj);
	object_flag_clear(obj, OF_DIRTY);

	unlink("/var/respawnd/fatal/udhcpd");
	system("/bin/killall udhcpd");
	
	if(enable==1)
	{
		fp = create_cfg_file(CFGNAME);
		
		
		obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.3.0");
		assert(obj);
		verifyfirst= object_get_int(obj);
		if(verifyfirst == 1)
		{
			write_cfg_line_str(fp,"arpping\t\t","yes");
		}
		else
		{
			write_cfg_line_str(fp,"arpping\t\t","no");
		}
		object_flag_clear(obj, OF_DIRTY);

		obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.7.0");
		assert(obj);
		minaddr=object_get_ipaddr(obj);
		write_cfg_line_str(fp,"start\t\t", inet_ntoa(*minaddr));
		object_flag_clear(obj, OF_DIRTY);

		obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.8.0");
		assert(obj);
		maxaddr=object_get_ipaddr(obj);
		write_cfg_line_str(fp,"end\t\t",inet_ntoa(*maxaddr));
		object_flag_clear(obj, OF_DIRTY);

		obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.10.0");
		assert(obj);
		leasetime = object_get_uint(obj);
		write_cfg_line_int(fp,"lease\t\t",leasetime);
		object_flag_clear(obj, OF_DIRTY);

		obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.4.0");
		assert(obj);
		trustclient= object_get_int(obj);
		object_flag_clear(obj, OF_DIRTY);
	
		obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.5.0");
		assert(obj);
		subnet=object_get_ipaddr(obj);
		write_cfg_line_str_tab(fp,"server_subnet",inet_ntoa(*subnet));
		object_flag_clear(obj, OF_DIRTY);

//		obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.2.0");
//		assert(obj);
//		intidx= object_get_int(obj);

		write_cfg_line_str_tab(fp,"interface","br0:0");
		object_flag_clear(obj, OF_DIRTY);
			
		obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.6.0");
		assert(obj);
		mask=object_get_ipaddr(obj);
		write_cfg_line_str_tab(fp,"opt\tsubnet",inet_ntoa(*mask));
		object_flag_clear(obj, OF_DIRTY);

		obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.9.0");
		assert(obj);
		object_flag_clear(obj, OF_DIRTY);
		
		router=object_get_ipaddr(obj);
		if(router->s_addr != 0) {
			write_cfg_line_str_tab(fp,"opt\trouter",inet_ntoa(*router));
		}
		
		write_cfg_line_int_tab(fp,"opt\tlease",leasetime);
		object_flag_clear(obj, OF_DIRTY);
		
		get_dns_from_resolv(RESOLV,(char*)dns1,1);
		get_dns_from_resolv(RESOLV,(char*)dns2,2);
		get_dns_from_resolv(RESOLV,(char*)dns3,3);
		

		if(strlen(dns1)>0)
		{
			write_cfg_token(fp,"opt\tdns\t");
			write_cfg_value_tab(fp,dns1);

			if(strlen(dns2)>0)
			{
				write_cfg_value_tab(fp,dns2);
			}
			if(strlen(dns3)>0)
			{
				write_cfg_value_tab(fp,dns3);
			}
			write_cfg_value(fp,"\n");			
		}
		
		close_cfg_file(fp);
	}


	sch = schema_get(".1.3.6.1.4.1.937.2.1.11.2.12.1");
	assert(sch);
	resfp = create_cfg_file(CFGNAME_RESERVATION);
		
	row = sch->rowlist;
	while(row) 
	{
		index = index_get(row);
	
		obj = row_get_obj(row, 3);
		rowstat = object_get_rowstat(obj);
			
		if(rowstat == 1)
		{

			obj = row_get_obj(row, 1);
			res_ipaddr=object_get_ipaddr(obj);
			sprintf(ipvalue,"%d %s",object_get_uint(index->obj[0]),inet_ntoa(*res_ipaddr));
			write_cfg_line_str(resfp,"reservationIpAddress",ipvalue);
			object_flag_clear(obj, OF_DIRTY);
				
			obj = row_get_obj(row, 2);
			res_macaddr=object_get_string(obj);
			strncpy(macaddress,res_macaddr->data,res_macaddr->len);
			sprintf(macvalue,"%d %02x:%02x:%02x:%02x:%02x:%02x",object_get_uint(index->obj[0]),
									res_macaddr->data[0],
									res_macaddr->data[1],
									res_macaddr->data[2],
									res_macaddr->data[3],
									res_macaddr->data[4],
									res_macaddr->data[5]);

			
			write_cfg_line_str(resfp,"reservationMacAddress",macvalue);
			object_flag_clear(obj, OF_DIRTY);
		}
		
		index_done(index);
		
		row = row->next;
	}
	
	close_cfg_file(resfp);

	
	if(enable==1)
	{
		FILE *fp;
		
		/* create respawn file (first in /tmp to prevent respawnd from
		 * starting an unfinished file */
		fp = fopen("/tmp/udhcpd", "w+");
		assert(fp);
		fprintf(fp, "#!/bin/sh\n");
		fprintf(fp, "/bin/udhcpd");

		/* Be sure to run it in the background */
		fprintf(fp, " &\n");
		
		/* set read & execute bit on this file */
		fchmod(fp->fd,   S_IRUSR | S_IXUSR );
			
		fclose(fp);
		rename("/tmp/udhcpd", "/var/respawnd/fatal/udhcpd");
	}
		
	return(0);
}

int check(void)
{
	unsigned long minaddr_h;
	unsigned long maxaddr_h;
	unsigned long routeraddr_h;
	unsigned long subnetaddr_h;
	unsigned long maskaddr_h;	
	struct schent_t* sch;
	struct object_t *obj;
	struct in_addr *minaddr, *maxaddr,*mask,*subnet,*router;
	int enable;
	int maxtbllen;
	
	/* check MAX reservations */
	obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.11.0");
	assert(obj);
	maxtbllen = object_get_uint(obj);
		
	sch = schema_get(".1.3.6.1.4.1.937.2.1.11.2.12.1");
	assert(sch);
	if(table_count(sch) > maxtbllen) {
		return R_CHECKFAILED;
	}
	
	obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.5.0");
	assert(obj);
	subnet=object_get_ipaddr(obj);
	
	obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.6.0");
	assert(obj);
	mask=object_get_ipaddr(obj);
		
	obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.7.0");
	assert(obj);
	minaddr=object_get_ipaddr(obj);
	
	obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.8.0");
	assert(obj);
	maxaddr=object_get_ipaddr(obj);
	
	obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.9.0");
	assert(obj);
	router=object_get_ipaddr(obj);
	
	
	/******************************/
	/* CHECK IF DHCP IS DISBABLED */
	/******************************/
	obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.1.0");
	assert(obj);
	enable = object_get_int(obj);

	/* network byteorder to host byteorder */
	minaddr_h = ntohl(minaddr->s_addr);
	maxaddr_h = ntohl(maxaddr->s_addr);
	routeraddr_h = ntohl(router->s_addr);
	subnetaddr_h = ntohl(subnet->s_addr);
	maskaddr_h = ntohl(mask->s_addr);	
	
	if(enable == 2 )
	{
		/* 2 && not dirty  || 2 && dirty*/
		/* All addresses should unequal 0.0.0.0., (except router) */
		if (maskaddr_h == 0 || subnetaddr_h == 0 || minaddr_h == 0 || maxaddr_h == 0 )
		{   
       			return R_CHECKFAILED;		        		
		}
		/* Minimum, maximum address, and gateway address must be class A, B, or C. 
		 */
		if ( !( IN_CLASSA(minaddr_h)|| IN_CLASSB(minaddr_h)|| IN_CLASSC(minaddr_h)) ||
     		     !( IN_CLASSA(maxaddr_h)|| IN_CLASSB(maxaddr_h)|| IN_CLASSC(maxaddr_h)) ||
		     !( IN_CLASSA(routeraddr_h) || IN_CLASSB(routeraddr_h) || IN_CLASSC(routeraddr_h))  )
		{
			return R_CHECKFAILED;
    		}	
		return R_NOERR;

	}	
	else
	{
		/* 1 && not dirty*/
		if(!(object_flag_isset(obj, OF_DIRTY))) 
		{
			return R_CHECKFAILED;
		}
		else 	/* 1 &&  dirty*/
		{
			/* All addresses should unequal 0.0.0.0.*/
			if (maskaddr_h == 0 || subnetaddr_h == 0 || minaddr_h == 0 || maxaddr_h == 0)
    			{   
        			return R_CHECKFAILED;		        		
    			}
			/* Minimum, maximum address, and gateway address must be class A, B, or C */
			if ( !( IN_CLASSA(minaddr_h) || IN_CLASSB(minaddr_h)|| IN_CLASSC(minaddr_h) ) ||
     		   	  !( IN_CLASSA(maxaddr_h)    || IN_CLASSB(maxaddr_h)|| IN_CLASSC(maxaddr_h) ) ||
		    	  !( IN_CLASSA(routeraddr_h)     || IN_CLASSB(routeraddr_h) || IN_CLASSC(routeraddr_h) ))
			{
				return R_CHECKFAILED;
    			}

			/* Check if end address is greater than start address.*/
			if(minaddr_h > maxaddr_h)
			{
				return R_CHECKFAILED;
			}
			
			/* Check if addresses in subnetaddr_h */
			if(
			!(
			   ((minaddr_h & maskaddr_h) == (subnetaddr_h & maskaddr_h))&&
 			   ((maxaddr_h & maskaddr_h) == (subnetaddr_h & maskaddr_h))
			))
			{
			   return R_CHECKFAILED;
			}
			
			/* check router */
			if((routeraddr_h != 0) && !((routeraddr_h & maskaddr_h) == (subnetaddr_h & routeraddr_h))) 
			{
			  return R_CHECKFAILED;
		        }			
				
			return R_NOERR;
		}
		
	}
		
	
}


struct moddescr_t mod_dhcp_cfg = {

	name:		__FILE__,
	fn_set:		set,
	fn_chk:		check,
	oidlist:	".1.3.6.1.4.1.937.2.1.11.2.1 .1.3.6.1.4.1.937.2.1.11.2.2 .1.3.6.1.4.1.937.2.1.11.2.3 .1.3.6.1.4.1.937.2.1.11.2.4 .1.3.6.1.4.1.937.2.1.11.2.5 .1.3.6.1.4.1.937.2.1.11.2.6 .1.3.6.1.4.1.937.2.1.11.2.7 .1.3.6.1.4.1.937.2.1.11.2.8 .1.3.6.1.4.1.937.2.1.11.2.9 .1.3.6.1.4.1.937.2.1.11.2.10 .1.3.6.1.4.1.937.2.1.11.2.11 .1.3.6.1.4.1.937.2.1.11.2.12.1"

};





/*

The following schema entries are provided by this module :
O .1.3.6.1.4.1.937.2.1.11.2.1
L serverEnabled
T INTEGER
A RW
R 1,2

O .1.3.6.1.4.1.937.2.1.11.2.2
L serverInterfaceIndex
T INTEGER
A RW
R 1/2147483647

O .1.3.6.1.4.1.937.2.1.11.2.3
L serverVerifyFirst
T INTEGER
A RW
R 1,2
D 1

O .1.3.6.1.4.1.937.2.1.11.2.4
L serverTrustClient
T INTEGER
A RW
R 1,2
D 1

O .1.3.6.1.4.1.937.2.1.11.2.5
L serverSubnet
T IPADDR
A RW
R 4
D HEX:c0a80100

O .1.3.6.1.4.1.937.2.1.11.2.6
L serverSubnetmaskaddr_h
T IPADDR
A RW
R 4
D HEX:ffffff00

O .1.3.6.1.4.1.937.2.1.11.2.7
L serverSubnetMinAddress
T IPADDR
A RW
R 4
D HEX:c0a80101

O .1.3.6.1.4.1.937.2.1.11.2.8
L serverSubnetmaxaddr_hess
T IPADDR
A RW
R 4
D HEX:c0a801fd

O .1.3.6.1.4.1.937.2.1.11.2.9
L serverRouterAddress
T IPADDR
A RW
R 4
D HEX:c0a801fe

O .1.3.6.1.4.1.937.2.1.11.2.10
L serverLeaseTime
T UNSIGNED32
A RW

O .1.3.6.1.4.1.937.2.1.11.2.11

O .1.3.6.1.4.1.937.2.1.11.2.12
*/
