/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#include <assert.h>
#include <stdio.h>

#include "object.h"
#include "objdata.h"
#include "serialize.h"
#include "table.h"
#include "objflag.h"
#include "schema.h"
#include <string.h>
#include <unistd.h>

const char cfg_name_resolv_stat[]=	"/var/etc/resolv.conf.stat";
const char cfg_name_resolv_ppp[]=	"/var/etc/resolv.conf.ppp";
const char cfg_name_resolv_dhcp[]=	"/var/etc/resolv.conf.dhcp";
const char cfg_name_resolv[]=		"/var/etc/resolv.conf";

void create_resolv_link()
{
	FILE* fp = NULL;

	unlink(cfg_name_resolv);
	if ((fp = fopen(cfg_name_resolv_stat,"r"))!=NULL)				
	{
		fclose(fp);
		symlink(cfg_name_resolv_stat,cfg_name_resolv);
	}
	else if ((fp = fopen(cfg_name_resolv_ppp,"r"))!=NULL)
	{
		fclose(fp);
		symlink(cfg_name_resolv_ppp,cfg_name_resolv);
	}
	else if((fp = fopen(cfg_name_resolv_dhcp,"r"))!=NULL)
	{
		fclose(fp);
		symlink(cfg_name_resolv_dhcp,cfg_name_resolv);
	}
}


static int set(void)
{
	struct object_t *obj;
	struct object_t *objentry;
	int rowstat;
	int create = 0;
	FILE* file = NULL;
	char oidbuf[MAX_OID_LENGTH];
		
	objentry = object_get_next(".1.3.6.1.4.1.937.2.1.11.2.14.1.2");		
	assert(objentry);

	while(strcmp(objentry->sch->oid,".1.3.6.1.4.1.937.2.1.11.2.14.1.2")==0)
	{
		rowstat = object_get_rowstat(row_get_obj(objentry->row,2));
		if(rowstat == 1)
		{
			if (create == 0) {
				create = 1;
				file = fopen(cfg_name_resolv_stat, "w");
				assert(file);
			}
	
			obj = row_get_obj(objentry->row, 1);
			fprintf(file, "nameserver %s\n", inet_ntoa(*(object_get_ipaddr(obj))));
		}
		
		object_get_oid(oidbuf, sizeof(oidbuf), objentry);
		objentry = object_get_next(oidbuf);
	
	}

	
	if (create == 1) {
		fclose(file);
	}
	else
	{
		unlink(cfg_name_resolv_stat);
	}
	
	create_resolv_link();
	
	return(0);
}



static int check(void)
{
	struct object_t *obj;
	int enable;
	int maxdnsentries=0;
	int dnsentries=0;
	struct schent_t *sch;
	struct row_t *row;

	sch = schema_get(".1.3.6.1.4.1.937.2.1.11.2.14.1");
	assert(sch);

	row = sch->rowlist;
	while(row) 
	{
		dnsentries++;
		row = row->next;	
	}

	
	obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.13.0");
	assert(obj);
	maxdnsentries = object_get_uint(obj);

	
	obj = object_get(".1.3.6.1.4.1.937.2.1.11.2.1.0");
	assert(obj);
	enable = object_get_int(obj);
		
	if((enable == 2 || object_flag_isset(obj, OF_DIRTY))&& maxdnsentries >= dnsentries)
	{
		return R_NOERR;
	}
	else
	{
		return R_CHECKFAILED;
	}
	
	
}

struct moddescr_t mod_dns = {

	name:		__FILE__,
	fn_set:		set,
	fn_chk:	        check,
	oidlist:	".1.3.6.1.4.1.937.2.1.11.2.14.1"

};




