/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#include <unistd.h>
#include <string.h>
#include <assert.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>

#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <aplog_defs.h>

#include "table.h"
#include "misc.h"
#include "objdata.h"
#include "easyprism.h"

#include "regulatory.h"

static int init(void)
{
	struct schent_t *sch, *sc_sch;
	struct index_t *idx;
	struct row_t *row, *sc_row;
	int ifnum;
	struct object_t* obj;
	
	int index;
	int regdomain;
	struct country_domain_t* cd;
	
	regulatory_init();	
	
	sch = schema_get(".1.2.840.10036.4.7.1");
	assert(sch);
	
	/* TODO Where to get information for other interfaces ? 
	 * For now, use the info in regulatory_XXX for all wireless
	 * interfaces.
	 * What to do if supported domains/countries don't match */
	 
	/* rowlist should still be emtpy */
	assert(!sch->rowlist);
	
	/* Create rows for every wireless device defined in the 
	 * station config table
	 */
	sc_sch = schema_get(".1.2.840.10036.1.1.1");
	assert(sc_sch);
	
	sc_row = sc_sch->rowlist;
	while(sc_row) {
		cd = regulatory_get_country_domains();
		
		/* get the interface nr for this row */
		idx = index_get(sc_row);
		assert(idx);
		obj = index_get_obj(idx, 0);
		assert(obj);
		assert(obj->flags & OF_DATAPRESENT);
		ifnum = object_get_int(obj);
		index_done(idx);

		index = 1;		

		while(cd) {
			if (cd->type == REGULATORY_TYPE_DOMAIN) {
				idx = index_new(sch);
				assert(idx);

				object_set_int(index_get_obj(idx, 0), ifnum);
				object_set_int(index_get_obj(idx, 1), index);
				index++;

				row = row_create_by_index(idx);
				assert(row);

				index_done(idx);

				regdomain = regulatory_domainid2value(cd->id);
				object_set_int(row_get_obj(row,1), regdomain);
			}

			cd = cd->next;
		}

		sc_row = sc_row->next;
	}
	
	return(0);
}

struct moddescr_t mod_dot11phy_domsup = {

	name:		__FILE__,
	fn_ini:		init,
	oidlist:	".1.2.840.10036.4.7.1"

};


/*

The following schema entries are provided by this module :

O .1.2.840.10036.4.7.1
L dot11RegDomainsSupportEntry
T TABLE

	O .1.2.840.10036.4.7.1.1
	L dot11RegDomainsSupportIndex
	T INTEGER32
	I 2

	O .1.2.840.10036.4.7.1.2
	L dot11RegDomainsSupportValue
	T INTEGER
	A R
	R 16,32,48,49,50,64

*/
