/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#include <unistd.h>
#include <string.h>
#include <assert.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <aplog_defs.h>
#include "mod_mibII_interfaces.h"
#include "table.h"
#include "misc.h"
#include "objdata.h"
#include "easyprism.h"

static int get(void)
{
	struct schent_t *sch;
	struct row_t *row;
	struct index_t *index;

	char *ifname;


	int ifnum = 0;
			
	sch = schema_get(".1.2.840.10036.4.12.1");
	assert(sch);

	row = sch->rowlist;
	
	while(row) {

		// Get the indices of this row. ifnum is a the numeric 
		// index from the iftable
	
		index = index_get(row);
		ifnum = object_get_int(index_get_obj(index, 0));
		ifname = ifindex2ifname(ifnum);

		index_done(index);

		// Put the ifname in the global...
	
		prism_set_ifname(ifname);
		
                //FIXED value.
                object_set_int(row_get_obj(row, 4), 20);
		
		row = row->next;
	}

	return(10);
}


static int set(void)
{
	return(0);
}


struct moddescr_t mod_dot11phy_hrdss = {

	name:		__FILE__,
	fn_get:		get,
	fn_set:		set,
	oidlist:	".1.2.840.10036.4.12.1"

};





/*

The following schema entries are provided by this module :
O .1.2.840.10036.4.12.1
L dot11PhyHRDSSSEntry
T TABLE

	O .1.2.840.10036.4.12.1.1
	L dot11ShortPreambleOptionImplemented
	T INTEGER
	A R
	R 1,2

	O .1.2.840.10036.4.12.1.2
	L dot11PBCCOptionImplemented
	T INTEGER
	A R
	R 1,2

	O .1.2.840.10036.4.12.1.3
	L dot11ChannelAgilityPresent
	T INTEGER
	A R
	R 1,2

	O .1.2.840.10036.4.12.1.4
	L dot11ChannelAgilityEnabled
	T INTEGER
	A R
	R 1,2

	O .1.2.840.10036.4.12.1.5
	L dot11HRCCAModeSupported

	T INTEGER
	A R
	R 1/31


*/


