/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#include <unistd.h>
#include <string.h>
#include <assert.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <aplog_defs.h>
#include "mod_mibII_interfaces.h"
#include "table.h"
#include "misc.h"
#include "objdata.h"
#include "easyprism.h"
#include <pda.h>

/* Get the manufacturer product version number from the identification componentTable. */
static struct string_t *get_dot11_man_prod_version(void)
{
    struct schent_t *sch;
    struct row_t *row;
    struct object_t *obj;

    struct string_t *string = NULL;
    
    sch = schema_get(".1.3.6.1.4.1.937.2.3.2.1.1"); /* componentTable */
    assert(sch);
    
    row = sch->rowlist;
    
    while(row) {

        obj = row_get_obj(row,1);
        assert(obj);

        string = object_get_objectid(obj);
        
        if (strncmp("1.3.6.1.4.1.937.1.27.7", string->data, string->len) == 0)
        {
            obj = row_get_obj(row, 2);
            assert(obj);
            string = object_get_string(obj);
            return string;
        }
        
        row = row->next;

    }

    return NULL;
}

static int init(void)
{
	return(0);
}

static int get(void)
{
	struct schent_t *sch;
	struct row_t *row;
        struct Pdr_Struct *pdrPtr;
        struct string_t *prod_ver;

	sch = schema_get(".1.2.840.10036.3.1.2.1");
	assert(sch);

	row = sch->rowlist;
	
	while(row) {

		object_set_string(row_get_obj(row,0),pdaGetMacAddress(),3);

                pdrPtr = pda_Find_Pdr(PDR_OEM_NAME, PDR_START);
                if (pdrPtr) {
                   object_set_string(row_get_obj(row,1), pdrPtr->PdrData, strlen(pdrPtr->PdrData));
                }
                
                pdrPtr = pda_Find_Pdr(PDR_PRODUCT_NAME, PDR_START);
                if (pdrPtr) {
		   object_set_string(row_get_obj(row,2), pdrPtr->PdrData , strlen(pdrPtr->PdrData));				
                }
                
                //dot11ManufacturerProductVersion
                prod_ver = get_dot11_man_prod_version();
                if (prod_ver != NULL) {
                    object_set_string(row_get_obj(row, 3), prod_ver->data, prod_ver->len);
                }
                
		row = row->next;
	}

	return(0); // Fixed values, will not change.
}

struct moddescr_t mod_dot11res = {

	name:		__FILE__,
	fn_ini:		init,
	fn_get:		get,
	oidlist:	".1.2.840.10036.3.1.1 .1.2.840.10036.3.1.2.1"

};


/*
O .1.2.840.10036.3.1.1
L dot11ResourceTypeIDName
T OCTETSTR
A R
R 4
D RTID

O .1.2.840.10036.3.1.2.1
L dot11ResourceInfoEntry
T TABLE
I .1.3.6.1.2.1.2.2.1.1

	O .1.2.840.10036.3.1.2.1.1
	L dot11manufacturerOUI
	T OCTETSTR
	A R
	R 3

	O .1.2.840.10036.3.1.2.1.2
	L dot11manufacturerName
	T OCTETSTR
	A R
	R 0/128

	O .1.2.840.10036.3.1.2.1.3
	L dot11manufacturerProductName
	T OCTETSTR
	A R
	R 0/128

	O .1.2.840.10036.3.1.2.1.4
	L dot11manufacturerProductVersion
	T OCTETSTR
	A R
	R 0/128

*/

