/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#include <unistd.h>
#include <string.h>
#include <assert.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <aplog_defs.h>
#include "mod_mibII_interfaces.h"
#include "table.h"
#include "misc.h"
#include "objdata.h"
#include "easyprism.h"
#include "objflag.h"
#include <aplog.h>


static int set(void)
{
	struct schent_t *sch;
	struct row_t *row;
	struct index_t *index;
	char* ifname;
	int	authalgenable;
	static long authvar=0;
	struct object_t *obj;

	int ifnum = 0;
	int idx = 9;			

	sch = schema_get(".1.2.840.10036.1.2.1");
	assert(sch);


	row = sch->rowlist;
	while(row) {

		// Get the indices of this row. ifnum is a the numeric 
		// index from the iftable
	
		index = index_get(row);
		ifnum = object_get_int(index_get_obj(index, 0));
		ifname = ifindex2ifname(ifnum);

		index_done(index);

		// Put the ifname in the global...
	
		prism_set_ifname(ifname);
		obj = row_get_obj(row, 0);
		idx = object_get_int(obj);
		
		obj = row_get_obj(row, 2);
		if(object_flag_isset(obj, OF_DIRTY)) {
			authalgenable = object_get_int(obj);
			if(idx == 1)
			{
				if( authalgenable == 1)
				{
		    			authvar |= DOT11_AUTH_OS;
				}
				else if ( authalgenable == 2)
        			{
		    			authvar &= ~DOT11_AUTH_OS;
	        		}
			}
			else if(idx == 2)
			{
        			if( authalgenable == 1)
	        		{
		    			authvar |= DOT11_AUTH_SK;
	       			}
        			else if ( authalgenable== 2)
	        		{
		    			authvar &= ~DOT11_AUTH_SK;
  	       			}
			}
			else
			{
				aplog(EV_SNMP_GENERAL_ERROR,"SMT: Wrong index",NULL);
			}
		}
		
		prism_set_long(DOT11_OID_AUTHENABLE, authvar);
		/* Stardate 10310.22 Max Yin
			After authentication type changed, adhoc network
			cannot be created. So, trig sysd to reset WLAN
			interface.
		*/
		system("/bin/killall -ALRM sysd");
		row = row->next;
	}

	
	return(0);

}


struct moddescr_t mod_dot11smt_aa = {

	name:		__FILE__,
	fn_set:		set,
	oidlist:	".1.2.840.10036.1.2.1"

};


/*

The following schema entries are provided by this module :
O .1.2.840.10036.1.2.1
L dot11AuthenticationAlgorithmsEntry
T TABLE

	O .1.2.840.10036.1.2.1.1
	L dot11AuthenticationAlgorithmsIndex
	T INTEGER32
	I 2

	O .1.2.840.10036.1.2.1.2
	L dot11AuthenticationAlgorithm
	T INTEGER
	A R
	R 1,2

	O .1.2.840.10036.1.2.1.3
	L dot11AuthenticationAlgorithmsEnable
	T INTEGER
	A RW
	R 1,2


*/
