/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#include <unistd.h>
#include <string.h>
#include <assert.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <aplog_defs.h>
#include "mod_mibII_interfaces.h"
#include "table.h"
#include "misc.h"
#include "objdata.h"
#include "easyprism.h"
#include "objflag.h"

#define MAX_RATES 6


static int get(void)
{
	struct schent_t *sch;
	struct row_t *row;
	struct index_t *index;

	char *ifname;
	
	int ifnum = 0;
	int icverr = 0;
	int exclcount = 0;
		
	sch = schema_get(".1.2.840.10036.1.5.1");
	assert(sch);

	row = sch->rowlist;
	
	while(row) {

		// Get the indices of this row. ifnum is a the numeric 
		// index from the iftable
	
		index = index_get(row);
		ifnum = object_get_int(index_get_obj(index, 0));
			
		ifname = ifindex2ifname(ifnum);

		index_done(index);
		
		// Put the ifname in the global...
	
		prism_set_ifname(ifname);
	
		icverr = prism_get_long(DOT11_OID_PRIVRXFAILED);
		object_set_counter(row_get_obj(row, 4),icverr);
		
		exclcount = prism_get_long(DOT11_OID_PRIVRXPLAIN);
		object_set_counter(row_get_obj(row, 5),exclcount);
		
		row = row->next;
	}

	return(10);
}

struct moddescr_t mod_dot11smt_priv = {

	name:		__FILE__,
	fn_get:		get,
	oidlist:	".1.2.840.10036.1.5.1"

};



/*

The following schema entries are provided by this module :
O .1.2.840.10036.1.5.1
L dot11PrivacyEntry
T TABLE

	O .1.2.840.10036.1.5.1.1
	L dot11PrivacyInvoked
	T INTEGER
	A RW
	R 1,2

	O .1.2.840.10036.1.5.1.2
	L dot11WEPDefaultKeyID
	T INTEGER
	A RW
	R 0/3

	O .1.2.840.10036.1.5.1.3
	L dot11WEPKeyMappingLength
	T UNSIGNED32
	A RW
	R 10/4294967295

	O .1.2.840.10036.1.5.1.4
	L dot11ExcludeUnencrypted
	T INTEGER
	A RW
	R 1,2

	O .1.2.840.10036.1.5.1.5
	L dot11WEPICVErrorCount
	T COUNTER
	A R

	O .1.2.840.10036.1.5.1.6
	L dot11WEPExcludedCount
	T COUNTER
	A R


*/



