/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#include <unistd.h>
#include <string.h>
#include <assert.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <aplog_defs.h>
#include "mod_mibII_interfaces.h"
#include "table.h"
#include "misc.h"
#include "objdata.h"
#include "easyprism.h"
#include "hardconfig.h"
#include "cfg_file_lib.h"

#define CFGNAME "ssn"

static int get(void)
{
	struct row_t* row;
	struct schent_t* sch;
	char* ifname;
	struct index_t *index;
	int ifnum = 0;
	
	/* check if regdomain is supported */
	sch = schema_get(".1.3.6.1.4.1.937.2.2.3.9.1");
	assert(sch);

	row = sch->rowlist;
	while(row) 
	{
		index = index_get(row);
		ifnum = object_get_int(index_get_obj(index, 0));
			
		ifname = ifindex2ifname(ifnum);

		index_done(index);

		// Put the ifname in the global...
	
		prism_set_ifname(ifname);
		
		row = row->next;
	}
	
	return 10;
	
}

static int set(void)
{
	struct row_t* row;
	struct schent_t* sch;
	struct object_t *obj;
	int reauthtime;
	int rekeying;
	int rekeyingtime;
	int rekeyingpackets;
	int grouprekeying;
	int grouprekeyingtime;
	int grouprekeyingpackets;
	int groupkeystrictupdate;
	int usepreshared;
	int interfaceindex;
	char interfacename[256];
	
	FILE* fp;
//	int ifnum = 0;
	sch = schema_get(".1.3.6.1.4.1.937.2.2.3.9.1");
	assert(sch);
	

	
	row = sch->rowlist;
	fp = create_cfg_file(CFGNAME);
	while(row) 
	{
		obj = row_get_obj(row, 0);
		assert(obj);
		interfaceindex = object_get_int(obj);
		strncpy(interfacename,ifindex2ifname(interfaceindex),256);
		obj = row_get_obj(row, 1);
		reauthtime= object_get_uint(obj);
		write_cfg_value(fp, interfacename);
		write_cfg_line_int(fp, "dot11Ext2Dot1XReauthenticationTime", reauthtime);
		obj = row_get_obj(row, 2);
		rekeying= object_get_int(obj);			
		write_cfg_value(fp, interfacename);
		write_cfg_line_int(fp, "dot11Ext2Dot1XRekeying",reauthtime );
		obj = row_get_obj(row, 3);
		rekeyingtime= object_get_uint(obj);
		write_cfg_value(fp, interfacename);
		write_cfg_line_int(fp, "dot11Ext2Dot1XRekeyingTime",rekeyingtime );
		obj = row_get_obj(row, 4);
		rekeyingpackets= object_get_uint(obj);
		write_cfg_value(fp, interfacename);
		write_cfg_line_int(fp, "dot11Ext2Dot1XRekeyingPackets",rekeyingpackets );
		obj = row_get_obj(row, 5);
		grouprekeying= object_get_int(obj);
		write_cfg_value(fp, interfacename);
		write_cfg_line_int(fp, "dot11Ext2Dot1XSSNGroupRekeying", grouprekeying);
		obj = row_get_obj(row, 6);
		grouprekeyingtime= object_get_uint(obj);
		write_cfg_value(fp, interfacename);
		write_cfg_line_int(fp, "dot11Ext2Dot1XSSNGroupRekeying",grouprekeyingtime );
		obj = row_get_obj(row, 7);
		grouprekeyingpackets= object_get_uint(obj);
		write_cfg_value(fp, interfacename);
		write_cfg_line_int(fp, "dot11Ext2Dot1XSSNGroupRekeyingPackets", grouprekeyingpackets);
		obj = row_get_obj(row, 8);
		groupkeystrictupdate= object_get_int(obj);
		write_cfg_value(fp, interfacename);
		write_cfg_line_int(fp, "dot11Ext2Dot1XSSNGroupKeyStrictUpdate", groupkeystrictupdate);
		obj = row_get_obj(row, 9);
		usepreshared= object_get_int(obj);
		write_cfg_value(fp, interfacename);
		write_cfg_line_int(fp, "dot11Ext2Dot1XSSNUsePreSharedKey", usepreshared);
	

		row = row->next;
	}
	close_cfg_file(fp);
	return 0;
	
}

struct moddescr_t mod_dot1X = {
	name:		__FILE__,
	fn_get:		get,
	fn_set:		set,
	oidlist:	".1.3.6.1.4.1.937.2.2.3.9.1"

};




