/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#include <unistd.h>
#include <string.h>
#include <assert.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <linux/sockios.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <sys/un.h>
#include <net/ethernet.h>
#include <errno.h>
#include <signal.h>
#include <time.h>
#include <aplog_defs.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "table.h"
#include "misc.h"
#include "objdata.h"
#include "objflag.h"
#include "object.h"
#include "easyprism.h"
#include "aplog.h"
#include "cfg_file_lib.h"
#include "lib_calls.h"
#include "mod_isl_standardext_generic_snmp.h"

#define WLANIF  "eth1"

static int set(void)
{
	
	struct object_t *obj;
	int fd;
	struct string_t * wlanmac;
	int cloneMethod=0; //0->disable, 1->static clone, 2->auto clone
	char buf[64];
	
        /* WAN MAC address */
	obj = object_get(".1.3.6.1.4.1.937.2.1.7.1.0");
//        printf("In standardext_generic_wlan module...\n");
	assert(obj);
	if (object_flag_isset(obj, OF_DIRTY) ) {
		struct ifreq ifr;
		unsigned char ifup = B_FALSE;

		wlanmac = object_get_string(obj);
		/*
                printf("wlanMACAddress: reveived %02x:%02x:%02x:%02x:%02x:%02x\n",
                       wlanmac->data[0],wlanmac->data[1],wlanmac->data[2],
                       wlanmac->data[3],wlanmac->data[4],wlanmac->data[5]);
		*/
		if(memcmp(&wlanmac->data[0], "\0\0\0\0\0\0", ETH_ALEN) == 0) {
			/* get the MAC address from the LAN port */
			obj = object_get(".1.3.6.1.2.1.2.2.1.6.2");
			assert(obj);
			assert(obj->flags & OF_DATAPRESENT);
			wlanmac = object_get_string(obj);
			cloneMethod = 0; // disalbe MAC clone
		}
		else if(memcmp(&wlanmac->data[0], "\xff\xff\xff\xff\xff\xff", ETH_ALEN) == 0) {
		    cloneMethod = 2; // auto-clone
		}
		else
		    cloneMethod = 1; // static clone
#if 0
		/* Stardate 10310.1
		    Use newly designed MAC clone
		*/
		/* The new MAC address can only be set if the interface 
		 * is down. 
		 */

		/* get the present state and save it */
		strncpy(ifr.ifr_name, WLANIF, IF_NAMESIZE);
		IfIoctl(SIOCGIFFLAGS, &ifr);
		ifup = (ifr.ifr_flags & IFF_UP) ? B_TRUE: B_FALSE;
                printf("wlanMACAddress: bring interface down\n");			
		/* bring interface down */
		ifr.ifr_flags &= ~IFF_UP;
		IfIoctl(SIOCSIFFLAGS, &ifr);
                
		/* Get the old MAC address struct */			
		IfIoctl(SIOCGIFHWADDR, &ifr);
                printf("wlanMACAddress: Get the old MAC address: %02x:%02x:%02x:%02x:%02x:%02x\n",
                       ifr.ifr_hwaddr.sa_data[0],
                       ifr.ifr_hwaddr.sa_data[1],
                       ifr.ifr_hwaddr.sa_data[2],
                       ifr.ifr_hwaddr.sa_data[3],
                       ifr.ifr_hwaddr.sa_data[4],
                       ifr.ifr_hwaddr.sa_data[5]);
		/* Set the new MAC address */						
		memcpy(&ifr.ifr_hwaddr.sa_data, &wlanmac->data[0], ETH_ALEN);
		strncpy(ifr.ifr_name, WLANIF, IF_NAMESIZE);
		IfIoctl(SIOCSIFHWADDR, &ifr);
#endif
		if(cloneMethod !=2){
		    snprintf(buf, 60, "/bin/echo 0 > /proc/net/macnat/enable_MAC_clone");
		    system(buf); // disable MAC clone
		    snprintf(buf, 60, "/bin/echo \"%02x:%02x:%02x:%02x:%02x:%02x\" >\ /proc/net/macnat/cloned_MAC",
	       wlanmac->data[0],wlanmac->data[1],wlanmac->data[2],
	       wlanmac->data[3],wlanmac->data[4],wlanmac->data[5]);
		    printf("%s(): cmd: %s\n", __PRETTY_FUNCTION__, buf);
		    system(buf);
		    set_prismoid(WLANIF, GEN_OID_MACADDRESS, &wlanmac->data[0], ETH_ALEN);
#if 0
		    /* Return interface in old state */
		    if(ifup) {
			ifr.ifr_flags |= IFF_UP;
			IfIoctl(SIOCSIFFLAGS, &ifr);
		    }
#endif
		}
		snprintf(buf, 60, "/bin/echo %d > /proc/net/macnat/enable_MAC_clone", cloneMethod);
		system(buf);
		object_flag_clear(obj, OF_DIRTY);
		/* Auto-cloned MAC address will be set to MVC by sysd */
		/* Stardate 10405.27 Max Yin
                        Restart WPA supplicant to re-authenticate       
                */
                system("rm -rf /log/stop_flag");
                system("/bin/testa");
	}
	return R_NOERR;
}


static int init(void) {
        return R_NOERR;
}

struct moddescr_t mod_isl_standardext_generic_wlan = {

	name:		__FILE__,
	fn_set:		set,
	fn_ini:		init,
	oidlist:	".1.3.6.1.4.1.937.2.1.7.1"

};

	
/*

*/
	


