/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#include <unistd.h>
#include <string.h>
#include <assert.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <aplog_defs.h>
#include <asm/types.h>
#include <linux/netlink.h>
#include "table.h"
#include "misc.h"
#include "objdata.h"
#include "easyprism.h"
#include "object.h"

#define MAX_RATES 6



static struct
{
	int inmsgs;
	int inerr;
	int indestunreach;
	int intimex;
	int parmprob;
	int insrcquen;
	int inredir;
	int inecho;
	int ineachrep;
	int ints;
	int intsrep;
	int inaddrmask;
	int inaddrmaskrep;
	int outmsg;
	int outerr;
	int outdestunreach;
	int outtimex;
	int outparmprob;
	int outsrcquen;
	int outredir;
	int outecho;
	int outechorep;
	int outts;
	int outtsrep;
	int outaddrmask;
	int outaddrmaskrep;

} icmp_stats;

static int get_icmp_stats()
{
	FILE* fp;
	char buf[1024];
	const char proc[]="/proc/net/snmp";
	int ret;
	fp = fopen(proc,"r");
	while(fgets(buf,sizeof(buf),fp))
	{
		if(strncmp(buf,"Icmp:",5)==0)
		{
			fgets(buf,sizeof(buf),fp);
			sscanf(buf,"Icmp: %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
				&icmp_stats.inmsgs,
				&icmp_stats.inerr,
				&icmp_stats.indestunreach,
				&icmp_stats.intimex,
				&icmp_stats.parmprob,
				&icmp_stats.insrcquen,
				&icmp_stats.inredir,
				&icmp_stats.inecho,
				&icmp_stats.ineachrep,
				&icmp_stats.ints,
				&icmp_stats.intsrep,
				&icmp_stats.inaddrmask,
				&icmp_stats.inaddrmaskrep,
				&icmp_stats.outmsg,
				&icmp_stats.outerr,
				&icmp_stats.outdestunreach,
				&icmp_stats.outtimex,
				&icmp_stats.outparmprob,
				&icmp_stats.outsrcquen,
				&icmp_stats.outredir,
				&icmp_stats.outecho,
				&icmp_stats.outechorep,
				&icmp_stats.outts,
				&icmp_stats.outtsrep,
				&icmp_stats.outaddrmask,
				&icmp_stats.outaddrmaskrep
				);
		}
	}
	ret = fclose(fp);
	return ret;
}


static int get(void)
{
//	int sock_fd;
//	struct sockaddr_nl address;
//	sock_fd = socket(AF_NETLINK,SOCK_RAW,NETLINK_ROUTE);			
//	bind(sock_fd,(struct sockaddr*)&address,sizeof(address));

	struct object_t *obj;

	get_icmp_stats();

	obj=object_get(".1.3.6.1.2.1.5.1.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.inmsgs);
	obj=object_get(".1.3.6.1.2.1.5.2.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.inerr);					
	obj=object_get(".1.3.6.1.2.1.5.3.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.indestunreach);					
	obj=object_get(".1.3.6.1.2.1.5.4.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.intimex);					
	obj=object_get(".1.3.6.1.2.1.5.5.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.parmprob);					
	obj=object_get(".1.3.6.1.2.1.5.6.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.insrcquen);					
	obj=object_get(".1.3.6.1.2.1.5.7.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.inredir);					
	obj=object_get(".1.3.6.1.2.1.5.8.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.inecho);					
	obj=object_get(".1.3.6.1.2.1.5.9.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.ineachrep);
	obj=object_get(".1.3.6.1.2.1.5.10.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.ints);					
	obj=object_get(".1.3.6.1.2.1.5.11.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.intsrep);					
	obj=object_get(".1.3.6.1.2.1.5.12.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.inaddrmask);					
	obj=object_get(".1.3.6.1.2.1.5.13.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.inaddrmaskrep);					
	obj=object_get(".1.3.6.1.2.1.5.14.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.outmsg);					
	obj=object_get(".1.3.6.1.2.1.5.15.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.outerr);					
	obj=object_get(".1.3.6.1.2.1.5.16.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.outdestunreach);					
	obj=object_get(".1.3.6.1.2.1.5.17.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.outtimex);					
	obj=object_get(".1.3.6.1.2.1.5.18.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.outparmprob);					
	obj=object_get(".1.3.6.1.2.1.5.19.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.outsrcquen);					
	obj=object_get(".1.3.6.1.2.1.5.20.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.outredir);					
	obj=object_get(".1.3.6.1.2.1.5.21.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.outecho);					
	obj=object_get(".1.3.6.1.2.1.5.22.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.outechorep);					
	obj=object_get(".1.3.6.1.2.1.5.23.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.outts);					
	obj=object_get(".1.3.6.1.2.1.5.24.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.outtsrep);					
	obj=object_get(".1.3.6.1.2.1.5.25.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.outaddrmask);					
	obj=object_get(".1.3.6.1.2.1.5.26.0");
	assert(obj);
	object_set_counter(obj,icmp_stats.outaddrmaskrep);					
	

	return(10);
}


struct moddescr_t mod_mibII_icmp = {

	name:		__FILE__,
	fn_get:		get,
	oidlist:	".1.3.6.1.2.1.5.1 .1.3.6.1.2.1.5.2 .1.3.6.1.2.1.5.3 .1.3.6.1.2.1.5.4 .1.3.6.1.2.1.5.5 .1.3.6.1.2.1.5.6 .1.3.6.1.2.1.5.7 .1.3.6.1.2.1.5.8 .1.3.6.1.2.1.5.9 .1.3.6.1.2.1.5.10 .1.3.6.1.2.1.5.11 .1.3.6.1.2.1.5.12 .1.3.6.1.2.1.5.13 .1.3.6.1.2.1.5.14 .1.3.6.1.2.1.5.15 .1.3.6.1.2.1.5.16 .1.3.6.1.2.1.5.17 .1.3.6.1.2.1.5.18 .1.3.6.1.2.1.5.19 .1.3.6.1.2.1.5.20 .1.3.6.1.2.1.5.21 .1.3.6.1.2.1.5.22 .1.3.6.1.2.1.5.23 .1.3.6.1.2.1.5.24 .1.3.6.1.2.1.5.25 .1.3.6.1.2.1.5.26"

};





