/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <stdlib.h>

#include "types.h"
#include "object.h"
#include "aplog.h"
#include "objflag.h"
#include "objdata.h"
#include "misc.h"

static int init(void)
{
	struct object_t *obj;
	obj = object_create(".1.3.6.1.2.1.11.1.0");
	obj = object_create(".1.3.6.1.2.1.11.3.0");
	obj = object_create(".1.3.6.1.2.1.11.4.0");
	obj = object_create(".1.3.6.1.2.1.11.5.0");
	obj = object_create(".1.3.6.1.2.1.11.6.0");
	obj = object_create(".1.3.6.1.2.1.11.31.0");
	obj = object_create(".1.3.6.1.2.1.11.32.0");
	
	return(R_NOERR);
}


static int set(void)
{
//	struct object_t *obj;
	
//	obj = object_get(".1.3.6.1.2.1.11.30");
//	assert(obj);
	
//	if(object_flag_isset(obj, OF_DIRTY)) 
//	{
//
//		object_flag_clear(obj, OF_DIRTY);
//	}
	
	return(0);

}

static int get(void)
{
	FILE* fp;
	char buf[80];
	char *part[2];
	int parts;
	struct object_t *obj;
	char *p;
	
	fp = fopen("/var/log/snmp_stats", "r");
	if (!fp) {
		/* file does not exist (yet). Do nothing */
		return(2);
	}
	
	while(fgets(buf, sizeof(buf), fp)) {
		
		/* chomp */
		p = strchr(buf, '\n');
		if(p) *p=0;

		parts = split(buf, ' ', part, 2);
		
		if (parts != 2) {
			aplog(EV_SNMP_GENERAL_ERROR, "Error parsing /var/log/snmp_stats", NULL);
			return(2);
		}
		
		obj = NULL;
				
		if (strncmp(part[0], "SNMPINPKTS", sizeof(buf)) == 0) {
			obj = object_get(".1.3.6.1.2.1.11.1.0");
		}
		else if (strncmp(part[0], "SNMPINBADVERSIONS", sizeof(buf)) == 0) {
			obj = object_get(".1.3.6.1.2.1.11.3.0");
		}
		else if (strncmp(part[0], "SNMPINASNPARSEERRORS", sizeof(buf)) == 0) {
			obj = object_get(".1.3.6.1.2.1.11.6.0");
		}
		else if (strncmp(part[0], "SNMPSILENTDROPS", sizeof(buf)) == 0) {
			obj = object_get(".1.3.6.1.2.1.11.31.0");
		}
		else if (strncmp(part[0], "SNMPPROXYDROPS", sizeof(buf)) == 0) {
			obj = object_get(".1.3.6.1.2.1.11.32.0");
		}
		else {
			aplog(EV_SNMP_GENERAL_ERROR, "Error parsing /var/log/snmp_stats", NULL);
			return(2);
		}
		if(obj) {
			object_set_counter(obj, atoi(part[1]));
		}
	}
	
	fclose(fp);
	
	return(2);
}


struct moddescr_t mod_mibII_snmp = {

	name:		__FILE__,
	fn_set:		set,
	fn_get:		get,
	fn_ini:		init,
	oidlist:	".1.3.6.1.2.1.11.1 .1.3.6.1.2.1.11.3 .1.3.6.1.2.1.11.4 .1.3.6.1.2.1.11.5 .1.3.6.1.2.1.11.6 .1.3.6.1.2.1.11.30 .1.3.6.1.2.1.11.31 .1.3.6.1.2.1.11.32"

};


/*

O .1.3.6.1.2.1.11.1
L snmpInPkts
T COUNTER
A R
R 0/4294967295

O .1.3.6.1.2.1.11.3
L snmpInBadVersions
T COUNTER
A R
R 0/4294967295

O .1.3.6.1.2.1.11.4
L snmpInBadCommunityNames
T COUNTER
A R
R 0/4294967295

O .1.3.6.1.2.1.11.5
L snmpInBadCommunityUses
T COUNTER
A R
R 0/4294967295

O .1.3.6.1.2.1.11.6
L snmpInASNParseErrs
T COUNTER
A R
R 0/4294967295

O .1.3.6.1.2.1.11.30
L snmpEnableAuthenTraps
T INTEGER
A RW
R 1,2

O .1.3.6.1.2.1.11.31
L snmpSilentDrops
T COUNTER
A R
R 0/4294967295

O .1.3.6.1.2.1.11.32
L snmpProxyDrops
T COUNTER
A R
R 0/4294967295


*/
