/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#include <unistd.h>
#include <string.h>
#include <assert.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "misc.h"
#include "types.h"
#include "schema.h"
#include "table.h"
#include "objdata.h"
#include "object.h"

#define IPTABLES_FLUSH "iptables -t nat -F PREROUTING"
#define IPTABLES_ADDFW "iptables -t nat -i ! br0 -A PREROUTING -j DNAT -p %s --dport %d --to-destination %s:%d -s %s/%s"

#ifndef MAX_IPADDR_STR 
#define MAX_IPADDR_STR 16
#endif

static int set(void)
{	
	struct row_t *row;
	struct schent_t *sch;

	int proto, sport, dport;
	struct in_addr *dhost;
	struct in_addr *dnetm;
	struct in_addr *shost;	
	int rstat;

	char cmd[256];
	char ip_shost[MAX_IPADDR_STR];
	char ip_dhost[MAX_IPADDR_STR];
	char ip_dnetm[MAX_IPADDR_STR];

	sch = schema_get(".1.3.6.1.4.1.937.2.1.3.14.1");
	assert(sch);
	row = sch->rowlist;

	system(IPTABLES_FLUSH);

	while(row) {
		/* first get rowstatus to check if this is a active row */
		rstat = object_get_rowstat( row_get_obj(row, 7));

		if(rstat == RS_ACTIVE) {
			
			dport = object_get_uint(     row_get_obj(row, 3));
			sport = object_get_uint(     row_get_obj(row, 6));
			proto = object_get_int(     row_get_obj(row, 4));
			dhost = object_get_ipaddr(  row_get_obj(row, 1));
			
			shost = object_get_ipaddr(  row_get_obj(row, 5));
			dnetm = object_get_ipaddr(  row_get_obj(row, 2));
			strncpy(ip_shost, inet_ntoa(*shost), sizeof(ip_shost));
			strncpy(ip_dhost, inet_ntoa(*dhost), sizeof(ip_dhost));
			strncpy(ip_dnetm, inet_ntoa(*dnetm), sizeof(ip_dnetm));								
			
			if(proto & 1) {
				snprintf(cmd, sizeof(cmd), IPTABLES_ADDFW, "udp", dport, ip_shost, sport, ip_dhost,ip_dnetm); 
				system(cmd);
			}

			if(proto & 2) {
				snprintf(cmd, sizeof(cmd), IPTABLES_ADDFW, "tcp", dport, ip_shost, sport,ip_dhost,ip_dnetm); 
				system(cmd);
			}

		}

		row = row->next;
		
	}

	return(0);
}

// Check whether the new entry can be added to the table.
// The table may not contain more than a maximum number of entries
static int check(void)
{
	struct schent_t *sch;
	struct row_t *row;
	int num = 0;
	long maxentries=0;
	
	sch = schema_get(".1.3.6.1.4.1.937.2.1.3.14.1");
	assert(sch);

	num = table_count(sch);
	
	maxentries = object_get_uint(object_get(".1.3.6.1.4.1.937.2.1.3.13.0"));

	if(num>maxentries)
	{
		return R_CHECKFAILED;
	}
	else
	{
		return R_NOERR;
	}
}

struct moddescr_t mod_portforward = {

	name:		__FILE__,
	fn_set:		set,
	fn_chk:		check,
	oidlist:	".1.3.6.1.4.1.937.2.1.3.14.1"

};

