/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#include <assert.h>
#include <stdio.h>

#include "object.h"
#include "objflag.h"
#include "table.h"
#include "objdata.h"
#include "schema.h"
#include "cfg_file_lib.h"

static int set(void)
{
	write_config_aplog();	
	return(0);
}

static int check(void)
{
	struct schent_t* sch;
	struct object_t* obj;
	
	
	sch = schema_get(".1.3.6.1.4.1.937.2.1.2.4.1");
	assert(sch);
	
	obj = object_get(".1.3.6.1.4.1.937.2.1.2.3.0");
	assert(obj);
	assert(obj->flags & OF_DATAPRESENT);
	
	if(table_count(sch) > object_get_int(obj)) {
		return (R_CHECKFAILED);
	}
	
	return (R_NOERR);
}

struct moddescr_t mod_snmp_trapdst = {

	name:		__FILE__,
	fn_set:		set,
	fn_chk:		check,
	oidlist:	".1.3.6.1.4.1.937.2.1.2.4.1"

};

/*


O .1.3.6.1.4.1.937.2.1.2.4.1
L snmpTrapDstEntry
T TABLE
I .1.3.6.1.4.1.937.2.1.2.4.1.1

	O .1.3.6.1.4.1.937.2.1.2.4.1.1
	L snmpTrapDstIndex
	T INTEGER
	A -
	R 1/256

	O .1.3.6.1.4.1.937.2.1.2.4.1.2
	L snmpTrapDstIpAddress
	T IPADDR
	A C
	R 4

	O .1.3.6.1.4.1.937.2.1.2.4.1.3
	L snmpTrapDstType
	T INTEGER
	A C
	R 1,2,3

	O .1.3.6.1.4.1.937.2.1.2.4.1.4
	L snmpTrapDstRowStatus
	T ROWSTAT
	A C
	R 1,2,3,4,5,6

*/
