/*
 *      $Header$
 *
 *      IMPORTANT--READ CAREFULLY:
 *      Right, including without limitation, use, reproduction, modification,
 *      and creation of derivative works, pertaining to this Source Code
 *      ("Document") are governed by a legal Agreement ("Agreement") between
 *      you (either an individual or a single entity) and Intersil Americas
 *      Inc ("Intersil") and/or its licensee (both hereinafter called
 *      Licensor).
 *      By reproducing, modifying, creating derivative works, accepting,
 *      installing, viewing, accessing, transforming or otherwise using this
 *      Document, you agree to be bound by the terms of the Agreement. If you
 *      do not agree to the terms of the Agreement, Licensor is unwilling to
 *      license rights to this Document to you. In such event, you may not
 *      use, reproduce, modify, create derivative works, install, view,
 *      access, transport, transform or circulate this Document, and you
 *      should promptly contact Licensor from which you acquired this Document
 *      for instructions on returning or destroying this Document.
 *
 *      CONFIDENTIAL, PROPRIETARY AND TRADE SECRET INFORMATION:
 *      This Document contains confidential, proprietary and trade secret
 *      information of Intersil Americas Inc. and should be treated in a
 *      confidential manner.
 *      Furthermore, this Document is protected by national copyright laws and
 *      international treaties.
 *      Unauthorized use, reproduction, modification, creation of derivative
 *      works or circulation is strictly prohibited.
 *
 *      Intersil  is a registered trademark of Intersil Americas Inc.
 *
 *      Copyright  2002 Intersil Americas Inc. All Rights Reserved.
 */

#include <unistd.h>
#include <string.h>
#include <assert.h>
#include <stdio.h>
#include <sys/utsname.h>

#include "types.h"
#include "schema.h"
#include "table.h"
#include "objdata.h"
#include "object.h"
#include "device_config.h"
#include "apinfo.h"

static time_t start_time;

static int init(void)
{
	struct object_t *obj;
	char buf[256];
	struct utsname u;

	/* sysDescr */
	uname(&u);
	snprintf(buf, sizeof(buf), "%s %s %s %s %s", u.sysname, u.nodename, u.release, u.version, u.machine);
	obj = object_get(".1.3.6.1.2.1.1.1.0");
	assert(obj);
	object_set_string(obj, buf, strlen(buf));
	
	
        /* sysObjectId */
        obj = object_get(".1.3.6.1.2.1.1.2.0");
        assert(obj);
        object_set_objectid(obj, apinfo_get_SysObjectID()); 

	/* Initialize start_time */
	start_time = time(NULL);
	return 0;
}


static int get(void)
{
	struct object_t *obj;
	unsigned int sysUptime;
	
	/* sysUptime */
	obj = object_get(".1.3.6.1.2.1.1.3.0");
	sysUptime = (time(NULL) - start_time) * 100;
	object_set_ticks(obj, sysUptime);

	return(1); 
}

struct moddescr_t mod_system = {

	name: 		__FILE__,
	fn_ini: 	init,
	fn_get: 	get,
	oidlist: 	".1.3.6.1.2.1.1.1 .1.3.6.1.2.1.1.2 .1.3.6.1.2.1.1.3 .1.3.6.1.2.1.1.4 .1.3.6.1.2.1.1.5 .1.3.6.1.2.1.1.6 .1.3.6.1.2.1.1.7 .1.3.6.1.2.1.1.8 .1.3.6.1.2.1.1.9.1"
};


