/*
 *  apdpmod_apdp.c
 *  sysd
 *
 *  Created by Max Yin on Wed Sep 03 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */
#include <sys/ioctl.h>
#include <sys/time.h>
#include <stdio.h>
#include <netinet/in.h>
#include <net/if.h>
#include <string.h>
#include <stdlib.h>
#include "prismoids.h"
#include "apdpmod_apdp.h"
#include "datastore_if.h"
#include "supplicant_ext.h"  

#define LINKSYS_WET54GV2
#include "model_id.h"

extern unsigned int gw_mon_gwip;
//#define DEBUG

int IfIoctl(int ioctl_num, struct ifreq *ifr);

extern int authtype;
extern int ciphertype;
extern unsigned char passhash[64];


static int apdp_check(struct BMP_buf *buf)
{
    if(buf->hdr.opcode == APDP_REQUEST)
	return 0;
    else
	return -1;
}

static void *apdp_run(const struct BMP_buf *buf, int *ret_size)
{
    struct BMP_buf *apdp = (struct BMP_buf*)bmps_ret_buf;
    struct ifreq ifr;
    struct obj_ssid ssid;
    static char oid[64];
    static char data[128];
    int data_len = sizeof(data);
    int type, retval, i;
    int mvcdata_i, data_i;
    char community[128];
    int community_len = sizeof(community);
    struct timeval tv;
    //
    int wep_len;
    //Read Security Settings
    //authtype;//0=WEP 1=Radis 2=WPA-Radius 3=WPA-PSK
    //ciphertype;//0=WEP64 1=WEP128 1=TKIP
    read_supp_config();
    printf("\nauthtype::%ld  ciphertype:%ld  passhash:%s\n",authtype,ciphertype,passhash);   

    // read community out
    if(bmp_readSNMPCommunity(community, community_len)==-1){
	return NULL;
    }
    
    memset(bmps_ret_buf, 0, BMPS_RET_BUF_SIZE);
    // Header
    apdp->hdr.pid = APDP_PROTOCOL;
    apdp->hdr.opcode = APDP_RESPONSE;
    apdp->hdr.sequence = buf->hdr.sequence;
    // APDP content
    // APDP content
    //apdp->BMPs.apdp.security 0=Disable 1=WEP 2=Radius 3=WPA-Radius 4=WPA-PSK
    //apdp->BMPs.apdp.modelid.msize=0x02;
    if(check_security()==0x00)
        apdp->BMPs.apdp.security=0x00;
    else
        {
        apdp->BMPs.apdp.security=authtype+1;
        if(authtype==0x03)//Enable WPA-PSK
                {
		printf("\nEnable WPA-PSK  ");
                //apdp->BMPs.apdp.modelid.msize=0x02;
                //apdp->BMPs.apdp.security=4;//WPA-PSK
                apdp->BMPs.apdp.encrypt=0x00;//TKIP
                }
        else if(authtype==0x00)//Enable WEP
                {
		printf("\nEnable WEP  ");   
                //apdp->BMPs.apdp.modelid.msize=0x40;
                strcpy(oid, ".1.3.6.1.4.1.937.2.2.3.8.1.6.3") ;
                memset(data, 0, (data_len=sizeof(data)));
                type = T_OCTETSTR;
                retval = datastore_getoid(oid, community, strlen(community), data, &data_len, &type);
                if(retval == R_NOERR){
                wep_len=atoi(data);
                }
                else
                        wep_len=13;//128bits as default
                printf("\nWEP LEN:%ld\n",wep_len);
                if(wep_len==0x05)
                        apdp->BMPs.apdp.encrypt=0x00;//64bits
                else
                        apdp->BMPs.apdp.encrypt=0x01;//128bits
                }
        }

    // Source MAC
    memcpy(apdp->BMPs.apdp.s_mac, bmps_myhwaddr, 6);

    // Destination MAC
    memcpy(apdp->BMPs.apdp.d_mac, buf->BMPs.apdp.s_mac, 6);

    // Model ID
    apdp->BMPs.apdp.modelid.type = MODELID_TYPE;
    memcpy(apdp->BMPs.apdp.modelid.name, MODELID_NAME, sizeof(apdp->BMPs.apdp.modelid.name));
    apdp->BMPs.apdp.modelid.hardware_rev = MODELID_HWREV;
    apdp->BMPs.apdp.modelid.msize = MODELID_MEMSIZE;
    
    /* FIXME:
	Stardate 10309.4
	Here is some code related to WiSoC platform. It should be modulized to be
	extendable for other platforms
    */
    //SSID
    strcpy(oid, ".1.2.840.10036.1.1.1.9.3") ;
    memset(data, 0, (data_len=sizeof(data)));
    type = T_OCTETSTR;
    retval = datastore_getoid(oid, community, strlen(community), data, &data_len, &type);
    if(retval == R_NOERR){
    	if(strlen(data) == 0){
			get_prismoid(BMPS_WLANIF, DOT11_OID_SSID, &ssid, sizeof(ssid)) ;
			strncpy(apdp->BMPs.apdp.ssid, ssid.octets, ssid.length);
		}
		else
			strncpy(apdp->BMPs.apdp.ssid, data, strlen(data));
    }
    //get_prismoid(BMPS_WLANIF, DOT11_OID_SSID, &ssid, sizeof(ssid)) ;
    //memcpy(apdp->BMPs.apdp.ssid, ssid.octets, ssid.length);
#ifdef DEBUG
    printf("%s(): ssid: %s\n", __PRETTY_FUNCTION__, apdp->BMPs.apdp.ssid);
#endif

	// G-only/Mixed mode
	strcpy(oid, ".1.3.6.1.4.1.937.2.2.2.1.1.25.3") ;
    memset(data, 0, (data_len=sizeof(data)));
    type = T_OCTETSTR;
    retval = datastore_getoid(oid, community, strlen(community), data, &data_len, &type);
    if(retval == R_NOERR){
		data_i = strtol(data, NULL, 10);
#ifdef DEBUG
		printf("%s(): profile is: %s(%i)\n", __PRETTY_FUNCTION__,
			(data_i==3)?"G-only":"Mixed", data_i);
#endif
		apdp->BMPs.apdp.padding = (data_i==3)?1:0 ;
    }
    
    //Channel
    get_prismoid(BMPS_WLANIF, DOT11_OID_STATE, &data_i, 4) ;
#ifdef DEBUG
    printf("%s(): WLAN state: %d\n", __PRETTY_FUNCTION__, data_i);
#endif
    if(data_i == 5 || data_i==6){ // link state is stablized
    	get_prismoid(BMPS_WLANIF, DOT11_OID_CHANNEL, &(apdp->BMPs.apdp.ch), 1) ;
#ifdef DEBUG
		printf("%s(): WLAN channel: %d\n", __PRETTY_FUNCTION__, apdp->BMPs.apdp.ch);
#endif
	}
	else{
		strcpy(oid, ".1.2.840.10036.4.5.1.1.3") ;
    	memset(data, 0, (data_len=sizeof(data)));
	    type = T_OCTETSTR;
    	retval = datastore_getoid(oid, community, strlen(community), data, &data_len, &type);
	    if(retval == R_NOERR){
			data_i = strtol(data, NULL, 10);
#ifdef DEBUG
			printf("%s(): channel is: %i\n", __PRETTY_FUNCTION__,
				data_i);
#endif
			apdp->BMPs.apdp.ch = data_i ;
    	}
	}
	
    // WEP
    get_prismoid(BMPS_WLANIF, DOT11_OID_PRIVACYINVOKED, &mvcdata_i, sizeof(int));
#ifdef DEBUG
    printf("%s(): DOT11_OID_PRIVACYINVOKED: %d\n", __PRETTY_FUNCTION__, mvcdata_i);
#endif
    apdp->BMPs.apdp.wep = mvcdata_i;
    get_prismoid(BMPS_WLANIF, DOT11_OID_BSSTYPE, &mvcdata_i, sizeof(int));
#ifdef DEBUG
    printf("%s(): DOT11_OID_BSSTPYE: %d\n", __PRETTY_FUNCTION__, mvcdata_i);
#endif    
	/*if(mvcdata_i==1){
		// Infrastructure mode, channel number may not be correct
		//  always return 6
		apdp->BMPs.apdp.ch = 6;
	}*/
    apdp->BMPs.apdp.wep |= (mvcdata_i==2?0x0:0x10);
    strcpy(oid, ".1.3.6.1.4.1.937.2.1.2.7.0") ;
    memset(data, 0, (data_len=sizeof(data)));
    retval = datastore_getoid(oid, community, strlen(community), data, &data_len, &type);
    if(retval == R_NOERR){
		data_i = strtol(data, NULL, 10);
#ifdef DEBUG
		printf("%s(): from datastore, DHCP mode: %s->%d\n", __PRETTY_FUNCTION__,
			 data, data_i);
#endif
		apdp->BMPs.apdp.wep |= ((data_i==1)?0x80:0);
    }
#ifdef DEBUG
    else{
	printf("%s(): datastore_getoid failed to get dhcp mode: %d\n", __PRETTY_FUNCTION__, retval);
    }
#endif
#ifdef DEBUG
    printf("%s(): apdp->BMPs.apdp.wep: 0x%02x\n", __PRETTY_FUNCTION__, apdp->BMPs.apdp.wep);
#endif

    // name and length
    strcpy(oid, ".1.3.6.1.2.1.1.5.0") ;
    memset(data, 0, (data_len=sizeof(data)));
    retval = datastore_getoid(oid, community, strlen(community), data, &data_len, &type);
    if(retval == R_NOERR){
	strncpy(apdp->BMPs.apdp.device_name, data, sizeof(apdp->BMPs.apdp.device_name));
    }
#ifdef DEBUG
    else{
	printf("%s(): datastore_getoid err: %d\n", __PRETTY_FUNCTION__, retval);
    }
#endif
    apdp->BMPs.apdp.namelen=strlen(apdp->BMPs.apdp.device_name);
    
    // IP address
    memset(&ifr, 0, sizeof(ifr));
    strcpy(ifr.ifr_name, BMPS_IPIF);
    IfIoctl(SIOCGIFADDR, &ifr);
    apdp->BMPs.apdp.ip = ((struct sockaddr_in*)&ifr.ifr_addr)->sin_addr.s_addr;

    // Net mask
    memset(&ifr, 0, sizeof(ifr));
    strcpy(ifr.ifr_name, BMPS_IPIF);
    IfIoctl(SIOCGIFNETMASK, &ifr);
    apdp->BMPs.apdp.netmask = ((struct sockaddr_in*)&ifr.ifr_addr)->sin_addr.s_addr;

    // Gateway
    apdp->BMPs.apdp.gateway = gw_mon_gwip;

    // sync_counter
    gettimeofday(&tv, NULL);
    apdp->BMPs.apdp.sync_counter = htonl(tv.tv_sec*1000 + tv.tv_usec/1000) ;
#ifdef DEBUG
    printf("%s(): sync_counter: %08x\n", __PRETTY_FUNCTION__,
	   ntohl(apdp->BMPs.apdp.sync_counter));
#endif
    
    // Passphrase
    strcpy(oid, ".1.3.6.1.4.1.937.2.2.3.50.0") ;
    memset(data, 0, (data_len=sizeof(data)));
    retval = datastore_getoid(oid, community, strlen(community), data, &data_len, &type);
    if(retval == R_NOERR){
		memcpy(
			apdp->BMPs.apdp.passphrase, data, sizeof(apdp->BMPs.apdp.passphrase)
		);
#ifdef DEBUG
		printf("%s(): passphrase: %s\n", __PRETTY_FUNCTION__, 
			apdp->BMPs.apdp.passphrase);
#endif
    }
#ifdef DEBUG
    else{
	printf("%s(): datastore_getoid err: %d\n", __PRETTY_FUNCTION__, retval);
    }
#endif
#if 1
	// WEP key length
	strcpy(oid, ".1.3.6.1.4.1.937.2.2.3.8.1.6.3") ;
    memset(data, 0, (data_len=sizeof(data)));
    retval = datastore_getoid(oid, community, strlen(community), data, &data_len, &type);
    if(retval == R_NOERR){
    	data_i = strtol(data, NULL, 10);
#ifdef DEBUG
		printf("%s(): WEP key length: %d\n", __PRETTY_FUNCTION__, data_i);
#endif
    }
	// WEP key 1
    strcpy(oid, ".1.2.840.10036.1.3.1.2.3.1") ;
    memset(data, 0, (data_len=sizeof(data)));
    retval = datastore_getoid(oid, community, strlen(community), data, &data_len, &type);
    if(retval == R_NOERR){    	
#ifdef DEBUG
		for(i=0 ; i<data_i ; i++){
			printf("%02x ", data[i]);
		}
		printf("\n");
#endif
    	bmp_chkPasswd(data, data_i, buf->BMPs.pwmacs.d_mac);
		memcpy(
			apdp->BMPs.apdp.wepkey1, data, data_i
		);
		
		/*if((apdp->BMPs.apdp.wep&0x01)){
			apdp->BMPs.apdp.security = 1;
			if(data_i==5)
				apdp->BMPs.apdp.encrypt = 0;
			else
				apdp->BMPs.apdp.encrypt = 1;
		}
		else
			apdp->BMPs.apdp.security = 0;*/
    }
#ifdef DEBUG
    else{
	printf("%s(): datastore_getoid err: %d\n", __PRETTY_FUNCTION__, retval);
    }
#endif
#endif
    ret_size[0] = sizeof(struct BMP_hdr)+sizeof(APDP);
#ifdef DEBUG
    printf("%s(): ret_sieze: %u\n", __PRETTY_FUNCTION__,
	   ret_size[0]);
#endif
    
    return apdp;
}

struct BMP_mod apdpmod_apdp={
pid:	APDP_PROTOCOL,
check:	apdp_check,
errHandler: NULL,
run:	apdp_run
};


