/* $Id: arpping.h,v 1.1.1.1 2003/09/05 02:29:41 maxyin Exp $ */

/*
 * arpping .h
 */

#ifndef ARPPING_H
#define ARPPING_H

#define MAC_BCAST_ADDR	"\xff\xff\xff\xff\xff\xff"

#include <netinet/if_ether.h>
#include <net/if_arp.h>
#include <net/if.h>
#include <netinet/in.h>


struct arpMsg {
	struct ethhdr ethhdr;	 		/* Ethernet header */
	u_short htype;				/* hardware type (must be ARPHRD_ETHER) */
	u_short ptype;				/* protocol type (must be ETH_P_IP) */
	u_char  hlen;				/* hardware address length (must be 6) */
	u_char  plen;				/* protocol address length (must be 4) */
	u_short operation;			/* ARP opcode */
	u_char  sHaddr[6];			/* sender's hardware address */
	u_long  sInaddr;			/* sender's IP address */
	u_char  tHaddr[6];			/* target's hardware address */
	u_long  tInaddr;			/* target's IP address */
	u_char  pad[18];			/* pad for min. Ethernet payload (60 bytes) */
}__attribute__((packed));

struct ifinfo {
    char ifname[IFNAMSIZ];
    u_long addr;		/* network byte order */
    u_long mask;		/* network byte order */
    u_long bcast;		/* network byte order */
    u_char haddr[6];
    short flags;
};


/* function prototypes */
int arpping(u_int32_t yiaddr, char *yhwaddr, u_int32_t ip, char *hwaddr, char *interface);
#endif
