/*
led.c
	LED control procesures for WiSoC product
*/

/*
Stardate 10309.14 Max Yin
	Currently, only initialize the startup status.
	In the future, may need to control all LED pins
*/

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <net/if.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>

//#define DEBUG

int IfIoctl(int ioctl_num, struct ifreq *ifr);

static FILE *FILE_ledcontrol;
void led_init()
{
}

void led_cmd(char *cmd){
	FILE_ledcontrol = fopen("/proc/ledcontrol", "w");
	fwrite(cmd, strlen(cmd), 1, FILE_ledcontrol);
	fclose(FILE_ledcontrol);
}
void led_G_on()
{
 char cmd1[]="2 blink 0";
 char cmd2[]="2 on";
	led_cmd(cmd1);
	led_cmd(cmd2);
}
void led_G_off()
{
 char cmd1[]="2 blink 0";
 char cmd2[]="2 off";
	led_cmd(cmd1);
	led_cmd(cmd2);
}
void led_G_blink()
{
 char cmd1[]="2 blink 50";
	led_cmd(cmd1);
}

void led_G_disable()
{
 char cmd1[]="2 disable";
	led_cmd(cmd1);
}
void led_G_enable()
{
 char cmd1[]="2 enable";
	led_cmd(cmd1);
}

void led_A_on()
{
 char cmd1[]="3 blink 0";
 char cmd2[]="3 on";
	led_cmd(cmd1);
	led_cmd(cmd2);
}
void led_A_off()
{
 char cmd1[]="3 blink 0";
 char cmd2[]="3 off";
	led_cmd(cmd1);
	led_cmd(cmd2);
}
void led_A_blink()
{
 char cmd1[]="3 blink 50";
	led_cmd(cmd1);
}

void led_A_disable()
{
 char cmd1[]="3 disable";
	led_cmd(cmd1);
}
void led_A_enable()
{
 char cmd1[]="3 enable";
	led_cmd(cmd1);
}



void led_LAN_on()
{
}

void led_LAN_off()
{
}

void led_LAN_blink()
{
}
void led_PW_on()
{
 char cmd1[]="1 blink 0";
 char cmd2[]="1 on";
	led_cmd(cmd1);
	led_cmd(cmd2);
}
                                                                                
void led_PW_off()
{
}

struct ethact{
    char *ifname;
    int testRunning; // wlan does not have RUNNING flag
    void (*led_on)();
    void (*led_off)();
    void (*led_blink)();
    int txrx;
    int led_state;
};

static struct ethact eth0={
ifname: "eth0",
testRunning: 1,
led_on: led_LAN_on,
led_off: led_LAN_off,
led_blink: led_LAN_blink,
txrx: 0,
led_state: 1
};

static struct ethact eth1={
ifname: "eth1",
testRunning: 0,
led_on: led_G_on,
led_off: led_G_off,
led_blink: led_G_blink,
txrx: 0,
led_state: 1
};

static struct ethact *eths[] = {
    &eth0, &eth1, NULL
};

static int testETHact(const struct ethact *eth)
{
    char buf[128], *p, *dev;
    unsigned int tx, rx, txrx=0, tmp;
    int ifFound = 0;
    struct ifreq ifr;


    strcpy(ifr.ifr_name, eth->ifname);
    IfIoctl(SIOCGIFFLAGS, &ifr);
    if(eth->testRunning && !(ifr.ifr_flags & IFF_RUNNING) ){
	time_t ltime;
	time(&ltime);
	eth->led_off();
#ifdef DEBUG
	printf("%s not running\n", eth->ifname);
#endif
	if(strcmp(eth->ifname,"eth0")==0){ // LAN port not running
		if(ltime>=30){
			led_G_enable();
			led_PW_on();
		}
		else
			led_G_disable();
	}
	return -1; // interface is not running
    }
    else{
	if(strcmp(eth->ifname, "eth0")==0){//LAN port running
		led_G_enable();
		led_PW_on();
	}
    }
}
#include "prismoids.h"
int testChannel()
{
 int channel=0;
 int linkstate=-1;
 long t;
	time(&t);
	if(t<30){
#if 1
	 struct ifreq ifr;
		strcpy(ifr.ifr_name, "eth0");
		IfIoctl(SIOCGIFFLAGS, &ifr);
		if((ifr.ifr_flags & IFF_RUNNING)){
			led_cmd("1 blink 0");
			led_cmd("1 on");
		}
#else
		get_prismoid("eth0", GEN_OID_LINKSTATE, &linkstate, 4);
		//printf("eth0 linkstate: %x\n", linkstate);
		if(linkstate>0){ // eth0 is linked
			led_cmd("1 blink 0");
			led_cmd("1 on");
		}
#endif
		else
			return -2;
	}
	else{
		led_cmd("1 blink 0");
		led_cmd("1 on");
	}
	get_prismoid("eth1", GEN_OID_LINKSTATE, &linkstate, 4);
	if(linkstate<=0){ // link is down
		led_G_disable();
		led_A_disable();
		led_cmd("4 enable");
		led_cmd("4 blink 50");
		return -1;
	}
	get_prismoid("eth1", DOT11_OID_CHANNEL, &channel, 4);
	if(channel>0 && channel<15){ // G band
		led_cmd("4 disable");
		led_A_disable();
		led_G_enable();
	}
	else if(channel > 15){ // A band
		led_cmd("4 disable");
		led_A_enable();
		led_G_disable();
	}
	return 0;
}

void leds()
{
    int status;
    struct ethact *eth;
    int i=0;
    int abnormal=0;
	testChannel();
#if 0    
    while(eths[i]){
	status = testETHact(eths[i]);
	if(status==-1)
	    abnormal++;
	i++;
    }
    if(abnormal>1){
	printf("Both eth0 and eth1 go to -1\n");
    }
#endif
}
