#include <sys/types.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>
#include <prismoids.h> 
#include "apdp.h"
#include "datastore_if.h"
#include "led.h"

//#define DEBUG

unsigned int counter = 0;
unsigned int triggedss = 0;
void sysd_gw_mon();
void sysd_mac_autoclone();
void eth1mon(int signo);
int trigss(int on);

static void sigusr2_handler(int signo);
static void sigusr1_handler(int signo);

void sigusr2_handler(int signo){
#ifdef DEBUG
	printf("sysd: received SIGUSR2, prepare to reboot system\n");
#endif
	sleep(2);
	system("/bin/reboot");
}

void sigusr1_handler(int signo){
#ifdef DEBUG
	printf("sysd: received SIGUSR1, trigger site survey\n");
#endif
	trigss(1);
	triggedss = counter;
}
//=================================================
//For CyberSupplicant WPA Issue
//=================================================
char community[128];
int community_len = 128;
char current_ssid[64]; 
int current_ssid_len;
int eapol_wireless_get_ssid(char *device, char *ssid)
{
  unsigned int oid=0x10000002;//For SSID
  struct obj_ssid obj;
  unsigned char *p;
  int len=sizeof(struct obj_ssid);
  int ret,i;
  //
  memset(ssid,0x00,len);
  //
  prismoid_open();
  //Get OID
  ret = get_prismoid(device, oid, (void*)&obj,len );
  //sleep(1);
  p=(unsigned char *)&obj;
  if ( ret == 0 )
    {
    memcpy(ssid,obj.octets,obj.length);
    }
  else
    {
    }
  prismoid_close();
  return 0;
}
int prev_security_enable=99;
int security_enable=0x00;
int prev_network_type=99;
int network_type=0x00;//1=Infra 0=Adhoc
//
#define DEVICE "eth1"
int get_ssid_oid(char *ssid)
{
  unsigned int oid=0x10000002;//For SSID
  //int ret,i;
  struct obj_ssid obj;
  int len=sizeof(struct obj_ssid);
  memset(&obj,0x00,len);
  prismoid_open();
  //Get OID
  get_prismoid(DEVICE, oid,(void*)&obj,len );   
  //
  //obj.length=strlen(ssid);
  strcpy(ssid,obj.octets);
  prismoid_close();   
  //
  //printf("\nget_ssid_oid:%s_%ld\n",ssid,obj.length);
  return obj.length;//
}
//
void get_ssid()
{
    char ssid[64];
    char w_ssid[64];
    int w_ssid_len;
    static char oid[64];
    static char data[128];
    int data_len = sizeof(data);
    int type, ret;
    FILE *file;
    //Check Network Type Ad-hoc or Infra
    strcpy(oid, ".1.2.840.10036.1.1.1.10.3");
    memset(data, 0, (data_len=sizeof(data)));
    type = T_OCTETSTR;
    ret = datastore_getoid(oid, community, strlen(community), data, &data_len,&type);
    if(ret == R_NOERR){
        network_type=atoi(data);
    }
    //printf("\nNetwork Type:%ld\n",network_type);
    if(network_type!=prev_network_type)
        {
        if(network_type==0x01)//Enable Infra
                {
                printf("\nEnter Infra mode\n");
                file=fopen("/log/infra","w+");
                if(file<=0x00)
                        return;
                fputs("infra",file);
                fclose(file);
                }
        else//network_type==0x02 Adhoc
                {//Disable Infra==>Enable Adhoc
                printf("\nEnter Ad-Hoc\n");
                system("rm -rf /log/infra");
                }
        }
    prev_network_type=network_type;
    
    //Check if enable Security Setting
    strcpy(oid, ".1.3.6.1.4.1.937.2.2.3.8.1.5.3") ;
    memset(data, 0, (data_len=sizeof(data)));
    type = T_OCTETSTR;
    ret = datastore_getoid(oid, community, strlen(community), data, &data_len,&type);   
    if(ret == R_NOERR){
	security_enable=atoi(data);
	//printf("\nSecurity:%s_%ld_%ld\n",data,security_enable,prev_security_enable);
    }
    if(security_enable!=prev_security_enable)
	{
	if(security_enable==0x01)//Enable Security Settings
		{
		printf("\nEnable Security Settings\n");
		file=fopen("/log/security","w+");
	        if(file<=0x00)
	                return;
	        fputs("Security",file);
	        fclose(file);
		}
	else
		{//Disable Security Settings
		printf("\nDisable Security Settings\n");
		system("rm -rf /log/security");
		}
	}
    prev_security_enable=security_enable;
    //get_ssid_oid(ssid);    
    //SSID
    strcpy(oid, ".1.2.840.10036.1.1.1.9.3") ;
    memset(data, 0, (data_len=sizeof(data)));
    type = T_OCTETSTR;
    ret = datastore_getoid(oid, community, strlen(community), data, &data_len, &type);
    if(ret == R_NOERR){
		memset(ssid,0x00,sizeof(ssid));
                strncpy(ssid, data,
                        32);
    }
    ret=0x01;
    data_len=strlen(ssid);
    if((data_len<=0x00)||(ssid[0]<=0x00))
	{
	//Try again from OID
        data_len=get_ssid_oid(ssid);
	if((data_len<=0x00)||(ssid[0]<=0x00))
	        {
		//printf("\nRe-Call bmp_readSNMPCommunity\n");
		bmp_readSNMPCommunity(community, community_len);
		return;
		}
	}
    if(data_len==current_ssid_len) 
	{
	if(strncmp(ssid,current_ssid,current_ssid_len)==0x00)
		{}
	else
		{
		ret=0x00;//SSID is changed
		}
	}            
    else
	{
	ret=0x00;//SSID is changed
	} 
    if(ret==0x00)
	{//SSID is changed
	//printf("\nSSID is changed from %s to %s_%ld\n",current_ssid,ssid,data_len);  
	file=fopen("/log/ssid","w+");
	if(file<=0x00)
		return;
	fputs(ssid,file);
	fclose(file);
	}                
    memset(current_ssid,0x00,sizeof(current_ssid));
    memcpy(current_ssid,ssid,data_len);      
    current_ssid_len=data_len;      
    //printf("\nSSID:%s_%ld\n",ssid,data_len);
 
    file=fopen("/log/sysd","r");
    if(file<=0x00)
           {//and build it!
           file=fopen("/log/sysd","w+");
           if(file<=0x00)
                  {}
           else
         	  {fclose(file);}
           }
    else
	{
    	fclose(file);
	}                                                       
}
//=================================================

void main(int argc, char **argv)
{
    fd_set fds;
    int maxfd=-1;
    int bmp_sockfd;
    struct timeval t;

    // Initialize LED status
    led_init();
    
    // Initialization of file descriptors that needed
    bmp_sockfd = bmp_initSocket();
    if(maxfd < bmp_sockfd){
	maxfd = bmp_sockfd;
    }
    
    // Setup signal handler for USR1: trigger site survey
    signal(SIGUSR1, sigusr1_handler);
    // Setup signal handler for USR2: reboot system
    signal(SIGUSR2, sigusr2_handler);
    // Setup SIGALRM handler to monitor eth1
    signal(SIGALRM, eth1mon);
    //For Cybersupplicant wpa
    //Get SSID for CyberSupplicant  
    sleep(5);
    sleep(5);   
    sleep(5);   
    sleep(5);   
    //sleep(5);   
    //sleep(2);   
    if(bmp_readSNMPCommunity(community, community_len)==-1){
        return;
    }
    memset(current_ssid,0x00,sizeof(current_ssid));
    get_ssid(); 
    //    
    while(1){
	FD_ZERO(&fds);
	FD_SET(bmp_sockfd, &fds);
	t.tv_sec=0;
	t.tv_usec=50000;

	// Handle job(s) that is(are) releated to a file descriptor
#ifdef DEBUG
	printf("%s(): Handle file descriptor related job\n", __PRETTY_FUNCTION__);
#endif
	if(select(maxfd+1, &fds, NULL, NULL, &t)>0){
	    if(FD_ISSET(bmp_sockfd, &fds)){ // Test APDP protocol set
#ifdef DEBUG
		printf("%s(): received APDP request\n", __PRETTY_FUNCTION__);
#endif
		bmp_run(bmp_sockfd);
	    }
	    counter ++;
	    continue;
	}
	counter ++;

	// now, blink LEDs
	leds();
	//
	if((counter % 50) == 0){ //3 secs
            //Get SSID for CyberSupplicant
            get_ssid();
        }
	//	
	if((counter % 100) == 0){ //5 secs
	    // Now, handle gateway detection
#ifdef DEBUG
	    printf("%s(): process sysd_gw_mon\n", __PRETTY_FUNCTION__);
#endif
	    sysd_gw_mon();
	}
	if((counter % 10 ) == 0){ // 0.5 sec
		// Check auto clone
	    sysd_mac_autoclone();
	}
	
		// Site survey trigger
		if(triggedss){
			if((counter-triggedss)>100){
				trigss(0) ;
				triggedss = 0;
			}
		}
    }
}

// One supporting function
int IfIoctl(int ioctl_num, struct ifreq *ifr)
{
    int fd, ret;

    fd = socket(PF_INET, SOCK_DGRAM, 0);
    assert(fd > 0);

    ret = ioctl(fd, ioctl_num, ifr);
    close(fd);

    return ret;
}


