/*
 *  base64.c
 *  sysd
 *
 *  Created by Max Yin on Fri Sep 05 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */

#include "base64.h"

//***************************************************************************
// handle base64 encoding/decoding
//
// base 64 encoding is used, except for the following changes:
//   * the symbols . and _ are used instead of + and /
//   * the binary byte string is assumed to be a multiple of 3 bytes, so that
//     the base-64 string is a multiple of 4 characters. if it is not, it is
//     padded with 0's. no '=' symbols are used to mark the end of the encoded
//     string.

#if 0
static u16_t base64_chars_needed (u16_t length)
{
    return (((length-1) / 3) + 1) * 4;
}
#endif

static u8_t charToSixBits (u8_t c)
{
    if (c=='_') return 63;
    if (c >= 'A' && c <= 'Z') return c + 1 - 'A';
    if (c >= 'a' && c <= 'z') return c + 27 - 'a';
    if (c >= '0' && c <= '9') return c + 53 - '0';
    return 0;
}


// read base-64 encoded binary data from the 0-terminated string src,
// and return the resulting byte array in dest. no more than len
// bytes will be written to dest. invalid characters in the string will
// be interpreted as '.'.

void convertFromBase64 (u8_t *dest, s16_t len, u8_t *src)
{
    while (len > 0 && src[0] && src[1] && src[2] && src[3]) {
	u8_t s0 = charToSixBits (src[0]);
	u8_t s1 = charToSixBits (src[1]);
	u8_t s2 = charToSixBits (src[2]);
	u8_t s3 = charToSixBits (src[3]);
	dest[0] = (s0 << 2) | (s1 >> 4);
	if (len > 1) dest[1] = (s1 << 4) | (s2 >> 2);
	if (len > 2) dest[2] = (s2 << 6) | s3;
	src += 4;
	dest += 3;
	len -= 3;
    }
}
