#ifndef __DATASTORE_IF_H__
#define __DATASTORE_IF_H__

#define MAX_OID_LENGTH 128
#define MAX_DATA_LENGTH 256

#define T_UNKNOWN	0
#define	T_INTEGER 	1
#define T_UNSIGNED	2
//#define	T_STRING  	3	// not used any more
#define	T_IPADDR  	4
#define	T_TABLE   	5
#define T_ROWSTAT	6
#define T_OCTETSTR	7
#define T_COUNTER       8
#define T_COUNTER64     9
#define T_GAUGE        10
#define T_OBJECTID     11
#define T_OPAQUE       12
#define T_TICKS        13
#define T_NOTIFY       14  /* TBD: what to do with this ? */
#define T_BITS         15

#define H_GET     	1
#define H_SET     	2
#define H_CHK   	3

#define A_READ 		1
#define A_WRITE		2
#define A_CREATE	4
#define A_NOTIFY	8

#define R_NOERR		0
#define R_NOSUCHOID	1
#define R_NOACCESS	2
#define R_OUTOFRANGE	3
#define R_NONEXIST	4
#define R_WRONGTYPE     5
#define R_CHECKFAILED	6
#define R_ENDOFTREE     7

#define RS_ACTIVE	1
#define RS_NOTINSERVICE	2
#define RS_NOTREADY	3
#define RS_CREATEGO	4
#define RS_CREATEWAIT	5
#define RS_DESTROY	6

int split(char *str, char sep, char **part, int maxparts);
int datastore_getoid(char *oid, u_char *community, size_t community_len, char *data, int *data_len, int *type);
int datastore_getnextoid(char *oid, u_char *community, size_t community_len, char *data, int *data_len, int *type);
int datastore_setoid_begin (void);
int datastore_setoid_commit (void);
int datastore_setoid_rollback (void);
int datastore_setoid (char *oid, u_char* community, size_t community_len, char *data, int* data_len, int *type);

#endif

