#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <string.h>
#include <prismoids.h>

#define DEBUG
char buf[8192];
int trigss(int on)
{
 struct obj_scan objScan;
 struct obj_bsslist *pList;
 int i;

 	if(get_prismoid("eth1", DOT11_OID_SCAN, &objScan, sizeof(objScan))==0){
#ifdef DEBUG
		printf("scan.sweep: %d\n", objScan.sweep);
		printf("scan.type: %s\n", objScan.type==0?"passive scan":
				(objScan.type==1?"active scan":"selective scan"));
		printf("scan.min: %d\n", objScan.min);
		printf("scan.max: %d\n", objScan.max);
		printf("scan.interval: %d\n", objScan.interval);
		printf("scan.nr: %d\n", objScan.nr);
		for(i=0 ; i<objScan.nr ; i++){
			printf("scan.mhz[%d]: %d [%s]\n",i,
				objScan.mhz[i]&0x7FFF,
				(objScan.mhz[i]&0x8000)?"active":"passive");
		}
#endif
		objScan.min = objScan.max = 20;
		if(on==1)
				objScan.sweep = -1;
		else
				objScan.sweep = 0;
		
		for(i=0 ; i<objScan.nr ; i++){
			objScan.mhz[i] |= 0x8000 ;
		}
		objScan.interval=500;
		set_prismoid("eth1", DOT11_OID_SCAN, &objScan, sizeof(objScan));
	}
	else{
		printf("Cannot get data from DOT11_OID_SCAN!!!");
		return 1;
	}
#ifdef DEBUG
	if(get_prismoid("eth1", DOT11_OID_BSSLIST, buf, sizeof(buf))==0){
		pList = (struct obj_bsslist*)buf;
		printf("There is/are %ld APs found in the surrounding\n",
			pList->nr);
		for(i=0 ; i<pList->nr ; i++){
			printf("AP[%d]: SSID: %s(%d)\n", i,
					pList->bsslist[i].ssid+1,
					pList->bsslist[i].ssid[0]);
		}
	}
#endif
	return 0;
}
