/*
 *  eth1mon.c
 *  sysd
 *
 *  Created by Max Yin on Mon Sep 01 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */
/*
 Wireless interface monitor
 */
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <netinet/in.h>
#include <net/if.h>
#include <prismoids.h>
#include "led.h"

static volatile int eth1reup = 0;
#define ALARM_ADHOC	1
#define ALARM_INFRA	10

int IfIoctl(int ioctl_num, struct ifreq *ifr);


void eth1mon(int signo)
{
    long state;
    long mode;
    int ret;
    //pid_t pid, pid2;
    int alarm_duration=ALARM_ADHOC;
    struct ifreq ifr;
    strcpy(ifr.ifr_name, "eth1");
    ret = get_prismoid("eth1", 0x10000000, &mode, sizeof(mode));
    if(ret==0){
	if(mode == 1)// Infra
	    alarm_duration = ALARM_INFRA;
	else
	    alarm_duration = ALARM_ADHOC;
    }
    ret = get_prismoid("eth1", 0x10000003, &state, sizeof(state));
    //	printf("%s: eth1 state: %d\n", __PRETTY_FUNCTION__, state);
    if(ret == 0){
		if(state == 0 || eth1reup>1){
		    if(eth1reup==0){
				eth1reup = 1;
				printf("%s: eth1 is going to down...\n", __PRETTY_FUNCTION__);
		    }
		    else if(eth1reup==1){ // eth1 goes down
				IfIoctl(SIOCGIFFLAGS, &ifr);
				ifr.ifr_flags &= (~IFF_UP) ;
				IfIoctl(SIOCSIFFLAGS, &ifr);
				eth1reup = 2;
				alarm_duration = 1;
				printf("%s: eth1 is down\n", __PRETTY_FUNCTION__);
				led_G_off();
		    }
	    	else if(eth1reup == 2){
				IfIoctl(SIOCGIFFLAGS, &ifr);
				ifr.ifr_flags |= IFF_UP ;
				IfIoctl(SIOCSIFFLAGS, &ifr);
				eth1reup = 0;
				printf("%s: eth1 is up\n", __PRETTY_FUNCTION__);
				led_G_on();
		    }
	    	alarm(alarm_duration);
		}
		else{
	    	eth1reup = 0;
		    led_G_on();
		}
    }
}


