/*
 *  wlaninterface.c
 *  wifid
 *
 *  Created by Max Yin on Wed Apr 28 2004.
 *  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
 *
 */

#include <string.h>
#include <stdio.h>

#include <sys/socket.h>
#include <net/if.h>
#include <netinet/in.h>
#include <prismoids.h>
#include "wlaninterface.h"
#define WLAN	"eth1"

//#define DEBUG
static int wlan_ssid(int cmd, void *data, int len)
{
 char ssid[33];
	prismoid_open();	
	len = (len<=33)?len:33;
	switch(cmd){
		case INTERFACE_CMD_SET:
			set_prismoid(WLAN, DOT11_OID_SSID, data, len);
			break;
		case INTERFACE_CMD_GET:
			get_prismoid(WLAN, DOT11_OID_SSID, ssid, 33);
#ifdef DEBUG
			printf("%s(): ssid: %s\n", __PRETTY_FUNCTION__, ssid);
#endif
			memcpy(data, ssid, len);
			break;
	}
	prismoid_close();
	return len;
}

static int wlan_channel(int cmd, void *data, int len)
{
	prismoid_open();
	switch(cmd){
		case INTERFACE_CMD_SET:
			set_prismoid(WLAN, DOT11_OID_CHANNEL, data, 4);
			break;
		case INTERFACE_CMD_GET:
			get_prismoid(WLAN, DOT11_OID_CHANNEL, data, 4);
			break;
	}
	prismoid_close();
	len = 4;
	return len;
}

static int wlan_profile(int cmd, void *data, int len)
{
	prismoid_open();
	switch(cmd){
		case INTERFACE_CMD_SET:
			set_prismoid(WLAN, DOT11_OID_PROFILES, data, 4);
			break;
		case INTERFACE_CMD_GET:
			get_prismoid(WLAN, DOT11_OID_PROFILES, data, 4);
			break;
	}
	prismoid_close();
	len = 4;
	return len;
}

static int wlan_bsstype(int cmd, void *data, int len)
{
	prismoid_open();
	switch(cmd){
		case INTERFACE_CMD_SET:
			set_prismoid(WLAN, DOT11_OID_BSSTYPE, data, 4);
			break;
		case INTERFACE_CMD_GET:
			get_prismoid(WLAN, DOT11_OID_BSSTYPE, data, 4);
			break;
	}
	prismoid_close();
	len = 4;
	return len;
}

struct wlaninterface _wlan={
ssid	: wlan_ssid,
channel : wlan_channel,
profile : wlan_profile,
bsstype : wlan_bsstype
};

struct wlaninterface *wlan = &_wlan;


