/*  $Header$
 *
 *  Copyright (C) 2003 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef __FLASH_LAYOUT_H__
#define __FLASH_LAYOUT_H__

#include <rockhopper.h>

/* This file defines the flash layout. This is used in the kernel for the
 * partitioning of MTD devices (refer to drivers/mtd/maps/physmap.c).
 */

#define MTD_BOOTLOADER		"/dev/mtdr0"
#define MTD_APFIRMWARE		"/dev/mtd1"
#define MTD_USER_CONFIG_JFFS	"/dev/mtd2"

#define FILE_WEBFILESET		"/usr/etc/images/webfileset.img"
#define FILE_UAP_FIRMWARE	"/usr/etc/images/uapfirmware.img"

#ifdef __KERNEL__
#include <linux/mtd/partitions.h>

#define NUM_PARTITIONS 3

static struct mtd_partition partition_info[] = {
        { name: "Bootloader",
          size: 0x010000,
        },
        { name: "Access Point Firmware",
          size: (CONFIG_ROCKHOPPER_APFW_END_ADDR - CONFIG_ROCKHOPPER_APFW_START_ADDR),
        },
        { name: "Flash Filesystem",
          size: (CONFIG_ROCKHOPPER_JFFS_END_ADDR - CONFIG_ROCKHOPPER_JFFS_START_ADDR),
        },
};

#endif /* __KERNEL__ */

#endif /* __FLASH_LAYOUT_H__ */
