/*  $Header$
 *
 *  Copyright (C) 2001 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

/*
 * linux_mvc_oids.h  defines OIDs for the MVC driver in Linux
 */

#ifndef __LINUX_MVC_OIDS_H__
#define __LINUX_MVC_OIDS_H__

/* The MVC had OIDs of the format 0xAABBCCCC. "CCCC" is an
 * enumeration of the OID and "AA" is a group/device identifier.
 * "BB" is not used by the blob.
 * Under linux, We can use this to define our own OIDs. Below,
 * for each OID that is defined, the MVC OID that is used as
 * a basis is added in comment.
 */

/* GEN_OID_XXXX                                         0x00BB0000*/
#define GEN_OID_TRIGGER_WATCHDOG			0x00010000

#ifdef BLOB_V2
#define GEN_OID_BUTTONSTATE     			0x00010001
#define GEN_OID_LED_CLEAR         			0x00010002
#define GEN_OID_LED_SET          			0x00010003
#endif /* BLOB_V2 */

/* BLOB_OID_XXXX                                        0x80BB0000*/
/* BUTTONSTATE objects*/
#define BLOB_OID_BUTTONSTATE_RELEASED		0x80010000
#define BLOB_OID_BUTTONSTATE_PRESSED		0x80010002

/* BLOB_OID_LEDCLEAR */
/* This resets the LED to its default behavior */
#define BLOB_OID_LED_RESET				    0x80010003

/* Get the bootrecord of the extension card. */
#define BLOB_OID_EXT_CARD_BOOTREC           0x80010004

/* DOT11_OID_XXXX                                       0x18BB0000*/
/* DOT11_OID_ACL access control list oid */
#define DOT11_OID_ACL 					    0x18010001

#define BLOB_OID_TEST_1				        0x80010010
#define BLOB_OID_TEST_2				        0x80010011
#define BLOB_OID_TEST_3				        0x80010012
#define BLOB_OID_TEST_4				        0x80010013

#endif /* __LINUX_MVC_OIDS_H__ */








