/*
 *  virtual.c
 *  LEDKTask
 *
 *  Created by Max Yin on Sat Apr 17 2004.
 *  Copyright (c) 2004 Cybertan. All rights reserved.
 *
 */

#include "virtual.h"
#include "generic.h"
#ifndef __KERNEL__
#include <stdio.h>
#else
#ifdef MODULE
#include <linux/module.h>
#endif
#define printf	printk
#endif

static char LED_matrix[8]={0,0,0,0,0,0,0,0};

static void virtual_show_leds()
{
	int i;
	for(i=0 ; i<8 ; i++){
		printf(" %c ", LED_matrix[i]?'o':'_');
	}
	printf("\r");
#ifndef __KERNEL__
	fflush(stdout);
#endif
}

static void virtual_init()
{
}

static void virtual_led_on(const int index)
{
	LED_matrix[index] = 1;
	virtual_show_leds();
}

static void virtaul_led_off(const int index)
{
	LED_matrix[index] = 0;
	virtual_show_leds();
}


struct OEM_HW_LED   oem_hw_led = {
init:   virtual_init,
on:		virtual_led_on,
off:	virtaul_led_off
};

