/*
 *  wisoc_ws635.c
 *  LEDKTask
 *
 *  Created by Max Yin on Mon Apr 19 2004.
 *  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
 *
 */

#include <linux/module.h>
#include "../generic.h"
#include "wisoc_ws635.h"
// For WET54GV2 and WET55AG
// 0->DIAG(ORANGE), 1->POWER(GREEN), 2->WLAN G, 3-> WLAN A
// LAN LED is controled by MVC
//#define DEBUG

//static volatile unsigned long *GPIO3 = (volatile unsigned long *)0xc0000480;
static volatile unsigned long *GPIO3DR = (volatile unsigned long *)0xc0000480;
static volatile unsigned long *GPIO3DDR = (volatile unsigned long *)0xc0000488;

static unsigned long leds_mask[5]=
	{0x00000001, 0x00000010, 0x00000004, 0x00000004, 0x00000004};

static void ws635_init()
{
	unsigned long mask = leds_mask[0]|leds_mask[1]|leds_mask[2]|leds_mask[3];
	mask = (mask<<16)|mask;
#ifdef DEBUG
	printk("%s(): GPIO3DDR: 0x%08x, mask: 0x%08x\n", 
		   __PRETTY_FUNCTION__, *GPIO3DDR, mask);
#endif
	*GPIO3DDR |= mask ;
#ifdef DEBUG	
	printk("%s(): GPIO3DDR: 0x%08x\n", __PRETTY_FUNCTION__, *GPIO3DDR);
#endif
}

static void ws635_led_on(const int index)
{
	unsigned mask = leds_mask[index];
	mask = (mask<<16)|mask;
#ifdef DEBUG
	printk("%s(): GPIO3DR: 0x%08x, mask: 0x%08x\n", 
		   __PRETTY_FUNCTION__, *GPIO3DR, mask);
#endif
	*GPIO3DR = mask;
#ifdef DEBUG
	printk("%s(): GPIO3DR: 0x%08x\n", __PRETTY_FUNCTION__, *GPIO3DR);
#endif
}

static void ws635_led_off(const int index)
{
	unsigned mask = leds_mask[index];
	mask = (mask<<16);
#ifdef DEBUG
	printk("%s(): GPIO3DR: 0x%08x, mask: 0x%08x\n", 
		   __PRETTY_FUNCTION__, *GPIO3DR, mask);
#endif
	*GPIO3DR = mask;	
#ifdef DEBUG
	printk("%s(): GPIO3DR: 0x%08x\n", __PRETTY_FUNCTION__, *GPIO3DR);
#endif
}


struct OEM_HW_LED   oem_hw_led = {
init:   ws635_init,
on:		ws635_led_on,
off:	ws635_led_off
};
