/*
 *  ledstatus.h
 *  LEDKTask
 *
 *  Created by Max Yin on Sat Apr 17 2004.
 *  Copyright (c) 2004 Cybertan. All rights reserved.
 *
 */


#ifndef _LEDSTATUS_H_
#define _LEDSTATUS_H_

#include "generic.h"

struct LED_STATUS{
	unsigned int blink_period; 
	unsigned int blink_count; 
	unsigned char state;
	unsigned char enable;
	unsigned char index;
};

#define LED_STATUS_OFF		0
#define LED_STATUS_ON		1

void led_status_init(struct LED_STATUS *leds, const int nr_leds);
#define led_on(led)	{\
	if(led.enable){\
		led.state = LED_STATUS_ON;\
		oem_hw_led.on(led.index);\
	}\
}
#define led_off(led) {\
	if(led.enable){\
		led.state = LED_STATUS_OFF;\
		oem_hw_led.off(led.index);\
	}\
}
#define led_toggle(led) {\
	if(led.state == LED_STATUS_ON){\
		oem_hw_led.off(led.index);\
		led.state = LED_STATUS_OFF;\
	}\
	else if(led.state == LED_STATUS_OFF){\
		oem_hw_led.on(led.index);\
		led.state = LED_STATUS_ON;\
	}\
}
#define led_enable(led) {\
	led.enable = 1;\
	}
#define led_disable(led) {\
	led.blink_period = 0;\
	led_off(led);\
	led.enable = 0;\
	}

extern struct LED_STATUS	*leds_status;
extern int nr_leds;

#endif

