/*
 *  ledtimer.c
 *  LEDKTask
 *
 *  Created by Max Yin on Sat Apr 17 2004.
 *  Copyright (c) 2004 Cybertan. All rights reserved.
 *
 */

#include "ledtimer.h"
#include "generic.h"
#include "ledstatus.h"

#ifdef __KERNEL__
#include <linux/types.h>
#include <linux/timer.h>
extern unsigned long volatile jiffies;
void led_timer(unsigned long arg)
#else 
/* Use SIGALRM to simulate kernel timer */
void led_timer(int sig_no)
#endif
{
	int i;
	for(i=0 ; i<nr_leds ; i++){
		if(!leds_status[i].enable) continue;
		if(leds_status[i].blink_period>0){
			leds_status[i].blink_count ++;
			if(leds_status[i].blink_count >= leds_status[i].blink_period){
				leds_status[i].blink_count = 0;
				led_toggle(leds_status[i]);
			}
		}
		else{ /* output current state*/
			if(leds_status[i].state){
				led_on(leds_status[i]);
			}
			else{
				led_off(leds_status[i]);
			}
		}
			
	}
#ifdef __KERNEL__
	{
		struct timer_list *ledtimer = (struct timer_list*)arg;
		mod_timer(ledtimer, jiffies+1);
	}
#endif
}
