/*
 *  netiftimer.c
 *  LEDKTask
 *
 *  Created by Max Yin on Tue Apr 20 2004.
 *  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
 *
 */

#include "netiftimer.h"
#include "ledstatus.h"

struct led_netif *led_netifs=0;
int nr_netifs=0;

#ifdef __KERNEL__
#include <linux/netdevice.h>


void netif_timer(unsigned long arg)
#else 
/* Use SIGALRM to simulate kernel timer */
void netif_timer(int sig_no)
#endif
{
#ifdef __KERNEL__	
	struct net_device *netif;
	struct net_device_stats *netif_stats;
	int i;
	for(i=0 ; i<nr_netifs ; i++){
		netif = dev_get_by_name(led_netifs[i].ifname);
		if(netif == NULL) continue;
		// if interface is down, turn off the LED
		if(!(netif->flags & IFF_UP)){
			leds_status[led_netifs[i].ledindex].blink_period = 0;
			led_off(leds_status[led_netifs[i].ledindex]);
			dev_put(netif);
			continue;
		}
		netif_stats = netif->get_stats(netif);
		if(netif_stats!=NULL){
			unsigned long txrx_sum = netif_stats->rx_packets + 
				netif_stats->tx_packets;
			if(led_netifs[i].txrx_sum!=txrx_sum){
				// Had packets go out or come in
				// set blink period
				//printk("txrx_sum changed\n");
				leds_status[led_netifs[i].ledindex].blink_period = 
					led_netifs[i].blink_period;
				
			}
			else{ // otherwise, disable blink, and set state to on
				leds_status[led_netifs[i].ledindex].blink_period = 0;
				led_on(leds_status[led_netifs[i].ledindex]);
			}
			led_netifs[i].txrx_sum=txrx_sum;
			//printk("%s(): txrx_sum = %lu\n",__PRETTY_FUNCTION__,
			//	   txrx_sum);
		}
		dev_put(netif);
	}
	
	{//re-assign next timer callback
		struct timer_list *ledtimer = (struct timer_list*)arg;
		mod_timer(ledtimer, jiffies+led_netifs[0].blink_period);
	}
#endif
}

void netif_timer_init(const struct led_netif *netifs, const int nr)
{
	printk("%s(): check point\n", __PRETTY_FUNCTION__);
	led_netifs = netifs;
	nr_netifs = nr;
}