/*  $Header$
 *
 *  Copyright (C) 2002 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include "identification/bootrec.h"
#include "identification/interfaces.h"
#include "identification/components.h"
#include "component_version.h"

/*
 * System Bootrecord Definition
 */
const struct s_system_boot_record {
	struct s_bootrec_comp_id  component_id;
	struct s_bootrec_comp_ver component_version;
	struct s_bootrec_end  bootrecord_end;
} system_boot_record = {
	component_id:
	{
		{ BR_CODE_COMPONENT_ID, 1 },
		BR_COMP_ID_SYST
	},
	component_version:
	{
		{ BR_CODE_COMPONENT_VERSION, VER_STRING_SIZE },
		UCLINUX_VERSION_STRING
	},
	bootrecord_end:
	{
		{ BR_CODE_END_OF_BRA, 5 },	/* bootrec code, length */
		0,				/* CRC-16 */
		0,				/* padding */
		{ 0, 0, 0, 0 },			/* MD5 */
	}
};
/*****************************************************************/
