/*  $Header$
 *  
 *  Copyright (C) 2002 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include <asm/arch/blobcalls.h>

/*
 * This file contains the definition of the MVC interface. The macros that
 * are used here are defined in /include/asm/arch/blobcalls.h
 */

/*
 * Stubs for the BLOB device
 */
_blobcall_to_mvc1(int, blob_init, MSG_INIT, struct msg_init *)
_blobcall_to_mvc0(int, blob_abort, MSG_ABORT)
_blobcall_to_mvc0(int, blob_reset, MSG_RESET)
_blobcall_to_mvc0(int, blob_sleep, MSG_SLEEP)
_blobcall_to_mvc1(int, blob_conf, MSG_CONF, struct msg_conf *)

_blobcall_from_mvc0(int, blob_reqs, MSG_REQS)
_blobcall_from_mvc0(int, blob_service, MSG_SERVICE)
_blobcall_from_mvc0(struct msg_conf *, blob_trap, MSG_TRAP)

_blobcall_to_mvc0_noret(blob_watchdog, MSG_WATCHDOG)

/*
 * Stubs for other devices
 */
_devcall_to_mvc1(int, dev_start, MSG_START, int)
_devcall_to_mvc0(int, dev_run, MSG_RUN)
_devcall_to_mvc0(int, dev_halt, MSG_HALT)
_devcall_to_mvc0(int, dev_stop, MSG_STOP)
_devcall_to_mvc1(int, dev_conf, MSG_CONF, struct msg_conf *)
_devcall_to_mvc1(int, dev_setup, MSG_SETUP, struct msg_setup *)

_devcall_to_mvc1(int, dev_frame_add, MSG_FRAME_ADD, struct msg_frame *)
_devcall_to_mvc1(int, dev_frame_tx, MSG_FRAME_TX, struct msg_frame *)

_devcall_to_mvc1(int, dev_write, MSG_WRITE, struct msg_data *)

_devcall_from_mvc0(int, dev_state, MSG_STATE)
_devcall_from_mvc0(int, dev_reqs, MSG_REQS)
_devcall_from_mvc0(int, dev_service, MSG_SERVICE)

_devcall_from_mvc0(struct msg_conf *, dev_trap, MSG_TRAP)

_devcall_from_mvc0(struct msg_frame *, dev_frame_return, MSG_FRAME_RETURN)
_devcall_from_mvc0(struct msg_frame *, dev_frame_rx, MSG_FRAME_RX)

_devcall_from_mvc0(struct msg_data *, dev_read, MSG_READ)

_devcall_to_mvc0_noret(dev_watchdog, MSG_WATCHDOG)


/* We assume the MVC is at the start of RAM */
const unsigned char **blob_info_ptr = (const unsigned char **)(PHYS_OFFSET + 0x4);

const unsigned char *blobtool_find_element(int id, int skip)
{
	const unsigned char *p = *blob_info_ptr;

	while( *((short*)p) != id || skip > 0 )
	{
		if( (*((short*)p)) == (short)BIS_END )
			return 0L;

		if( *((short*)p) == id )
			skip--;

		p += 4 + *((short*)(p+2));
	}

	return p + 4;
}
