/* $Header$
*  prism_wds.h: Header file for Prism Wireless Distribution Set (WDS) driver.
*
*  Copyright (C) 2001 Intersil Americas Inc.
*  Copyright (C) 2002 Intersil Americas Inc.
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*/

#ifndef _ISL_WDS_H
#define _ISL_WDS_H

#include <linux/netdevice.h>

struct wds_net_local
{
    struct net_device_stats	 stats;		/* tx/rx statistics */
    struct net_device 	    *parent_dev;
    unsigned char 		     wds_mac[6];
};

#ifdef BLOB_V2
struct net_device *wds_find_device( msg_frame *framep, struct net_device *dev );
inline void copy_wds_to_frame( msg_frame *framep, unsigned char *WDS_Mac);
#else
struct net_device *wds_find_device( msg_frame *framep, struct net_device *dev );
inline void copy_wds_to_frame( msg_frame *framep, unsigned char *WDS_Mac);
#endif

/* WDS */
int add_wds_link(unsigned char *MACAddress, struct net_device *dev);
int del_wds_link(unsigned char *MACAddress, struct net_device *dev);
void open_wds_links(struct net_device *dev);
void close_wds_links(struct net_device *dev);
inline int check_skb_for_wds(struct sk_buff *skb, unsigned char *WDS_Mac);
int wds_net_open(struct net_device *dev);
int wds_net_send_packet(struct sk_buff *skb, struct net_device *dev);
int wds_net_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd);
int wds_net_close(struct net_device *dev);

#endif /* _ISL_WDS_H */

