/* $Header$
 *
 * gpio: general purpose I/O port
 * 
 *  
 *  Copyright (C) 2001 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __gpio_h
#define __gpio_h


/* - FSEL */
#define	GPIOFSEL			(0x24)
#define	GPIOFSELUARTTx			(0x10)
#define	GPIOFSELUARTRx			(0x8)

/* Instance values */
#define	uGPIOFSEL			(0xc0000624)

#ifndef __ASSEMBLER__

/* C struct view */

typedef struct s_GPIO {
 unsigned DR; /* @0 */
 unsigned ST; /* @4 */
 unsigned DDR; /* @8 */
 unsigned FIQ; /* @12 */
 unsigned IRQ; /* @16 */
 unsigned INT; /* @20 */
 unsigned INTCL; /* @24 */
 unsigned SNR; /* @28 */
 unsigned EENR; /* @32 */
 unsigned FSEL; /* @36 */
} s_GPIO;

#define uGPIO ((volatile struct s_GPIO *) 0xc0000600)

#else

#define uGPIO 				 (0xc0000600)

#endif // !__ASSEMBLER__

#endif /* !defined(__gpio_h) */
