/*
 * uclinux/include/asm-armnommu/arch-poldhu/hardware.h
 *
 */

#ifndef __ASM_ARCH_HARDWARE_H
#define __ASM_ARCH_HARDWARE_H

#include <linux/config.h>
#include "intctl.h"

#ifndef __ASSEMBLER__
#include <asm/arch/blobcalls.h>

#define HARD_RESET_NOW()  { arch_reset(0); }
#define ERROR_RESET_NOW	HARD_RESET_NOW

extern inline void arch_reset(char mode)
{
	(void)blob_reset();
	while(1);
}

typedef unsigned long u_32;

/* ARM asynchronous clock */
#define ARM_CLK ((u_32)(CONFIG_ARM_CLK))

/* ARM synchronous with OAK clock */
#define A_O_CLK ((u_32)(CONFIG_A_O_CLK))

#else
#define ARM_CLK CONFIG_ARM_CLK
#define A_O_CLK CONFIG_A_O_CLK
#endif

#define PERIPH_BASE	        0xc0000000

#define PCIBIOS_MIN_IO		0x1000
#define PCIBIOS_MIN_MEM 	( (PERIPH_BASE) + 0x00000980 )

#ifndef __ASSEMBLER__

/*
 * Memory definitions
 */

#define MAPTOPHYS(a)      ((unsigned long)a)
#define KERNTOPHYS(a)     ((unsigned long)(&a))

#endif


#endif
