/*
 * uclinux/include/asm-armnommu/arch-poldhu/intctl.h
 */
/*  $Header$
 *  
 *  Copyright (C) 2001 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __ASM_ARCH_INTCTL_H
#define __ASM_ARCH_INTCTL_H

/* - Status */
#define	IntCtlStatus			(0x0)
#define	IntCtlStatusMask		(0x7fffff)

/* - RawStatus */
#define	IntCtlRawStatus			(0x4)
#define	IntCtlRawStatusMask		(0x7fffff)

/* - EnableSet */
#define	IntCtlEnableSet			(0x8)
#define	IntCtlEnableSetMask		(0x7fffff)

/* - EnableClear */
#define	IntCtlEnableClear		(0xc)
#define	IntCtlEnableClearMask		(0x7fffff)

/* - Soft */
#define	IntCtlSoft			(0x10)
#define	IntCtlSoftGenerate		(0x2)
#define	IntCtlSoftMask			(0x2)

/* Instance values */
#define	uIRQStatus			(0xc0000000)
#define	uIRQRawStatus			(0xc0000004)
#define	uIRQEnableSet			(0xc0000008)
#define	uIRQEnableClear			(0xc000000c)
#define	uIRQSoft			(0xc0000010)
#define	uFIQStatus			(0xc0000100)
#define	uFIQRawStatus			(0xc0000104)
#define	uFIQEnableSet			(0xc0000108)
#define	uFIQEnableClear			(0xc000010c)
#define	uFIQSoft			(0xc0000110)

/* C struct view */

#ifndef __ASSEMBLER__

typedef struct s_IntCtl {
 unsigned long Status;
 unsigned long RawStatus;
 unsigned long EnableSet;
 unsigned long EnableClear;
 unsigned long Soft;
} s_IntCtl;

#define uIRQ ((volatile struct s_IntCtl *) 0xc0000000)
#define uFIQ ((volatile struct s_IntCtl *) 0xc0000100)

#else

#define uIRQ (0xc0000000)
#define uFIQ (0xc0000100)

#endif /* !__ASSEMBLER */

#endif
