/*
 * linux/include/asm-armnommu/arch-poldhu/io.h
 *
 * Copyright (C) 1997-1999 Russell King
 *
 * Modifications:
 *  06-12-1997	RMK	Created.
 *  07-04-1999	RMK	Major cleanup
 *  02-19-2001  gjm     Leveraged for armnommu/dsc21
 */
#ifndef __ASM_ARM_ARCH_IO_H
#define __ASM_ARM_ARCH_IO_H

/*
 * kernel/resource.c uses this to initialize the global ioport_resource struct
 * which is used in all calls to request_resource(), allocate_resource(), etc.
 * --gmcnutt
 */
#define IO_SPACE_LIMIT 0xffffffff

/*
 * If we define __io then asm/io.h will take care of most of the inb & friends
 * macros. It still leaves us some 16bit macros to deal with ourselves, though.
 */
#define __mem_pci(a)		((unsigned long)(a))

#define PCIO_BASE 0
#define __io(a) (PCIO_BASE + (a))
#define __arch_getb(a)      (*(volatile unsigned char *)(a))
#define __arch_putb(v,a)    (*(volatile unsigned char *)(a) = (v))
#define __arch_getw(a)      (*(volatile unsigned short *)(a))
#define __arch_putw(v,a)    (*(volatile unsigned short *)(a) = (v))
#define __arch_getl(a)      (*(volatile unsigned long *)(a))
#define __arch_putl(v,a)    (*(volatile unsigned long *)(a) = (v))

/*
 * Defining these two gives us ioremap for free. See asm/io.h.
 * --gmcnutt
 */
#define iomem_valid_addr(iomem,sz) (1)
#define iomem_to_phys(iomem) (iomem)

#endif
