/*
 * asm/arch-poldhu/rtc.h -- real time clock definitions for Poldhu
 */
/*  $Header$
 *  
 *  Copyright (C) 2001 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __rtc_h
#define __rtc_h

/* - Data */
#define	RTCData				(0x0)
#define	RTCDataMask			(0xffffffff)

/* - Match */
#define	RTCMatch			(0x4)
#define	RTCMatchMask			(0xffffffff)

/* - IntControl */
#define	RTCIntControl			(0x8)
#define	RTCIntControlBypassClkDivider	(0x10)
#define	RTCIntControlBypass1Mhz		(0x8)
#define	RTCIntControlSTBARD		(0x4)
#define	RTCIntControlTICK		(0x2)
#define	RTCIntControlEVENT		(0x1)
#define	RTCIntControlMask		(0x1f)

/* - IntStatus */
#define	RTCIntStatus			(0xc)
#define	RTCIntStatusSTBARD		(0x4)
#define	RTCIntStatusTICK		(0x2)
#define	RTCIntStatusEVENT		(0x1)
#define	RTCIntStatusMask		(0x7)

/* - IntClear */
#define	RTCIntClear			(0x14)
#define	RTCIntClearSTBARD		(0x4)
#define	RTCIntClearTICK			(0x2)
#define	RTCIntClearEVENT		(0x1)
#define	RTCIntClearMask			(0x7)

/* Instance values */
#define	uRTCData			(0xc0000200)
#define	uRTCMatch			(0xc0000204)
#define	uRTCIntControl			(0xc0000208)
#define	uRTCIntStatus			(0xc0000210)
#define	uRTCIntClear			(0xc0000214)

#ifndef __ASSEMBLER__

/* C struct view */

typedef struct s_RTC {
 unsigned Data; /* @0 */
 unsigned Match; /* @4 */
 unsigned IntControl; /* @8 */
 unsigned fill0;
 unsigned IntStatus; /* @16 */
 unsigned IntClear; /* @20 */
} s_RTC;

#define uRTC ((volatile struct s_RTC *) 0xc0000200)

#else

#define uRTC (0xc0000200)

#endif

#endif /* !defined(__rtc_h) */
