/*
 * linux/include/asm-arm/arch-poldhu/time.h
 */

#ifndef __ASM_ARCH_TIME_H__
#define __ASM_ARCH_TIME_H__

#include <asm/uaccess.h>
#include <asm/io.h>
#include <asm/hardware.h>
#include <asm/arch/irq.h>
#include <asm/arch/irqs.h>
#include <asm/arch/rtc.h>
#include <asm/arch/timex.h>
#include <linux/interrupt.h>

#define KERNEL_TIMER_IRQ_NUM	IRQ_RTC

extern struct irqaction timer_irq;
extern unsigned long (*gettimeoffset)(void);

extern unsigned long poldhu_gettimeoffset(void);
extern void poldhu_timer_interrupt(int irq, void *dev_id, struct pt_regs *regs);

/*
 * Reset the timer.
 */
extern __inline__ int reset_timer(void)
{
	uRTC->IntClear = RTCIntClearEVENT;
	/* If we had zero latency, this value should be zero. It turnes
	 * out that 1 is a better choice */
	uRTC->Data = 1;
	return (1);
}

extern __inline__ void setup_timer (void)
{
	gettimeoffset = poldhu_gettimeoffset;
	timer_irq.name = "timer";
	timer_irq.handler = poldhu_timer_interrupt;
	timer_irq.flags = SA_INTERRUPT;
	setup_arm_irq(KERNEL_TIMER_IRQ_NUM, &timer_irq);
	uRTC->Match = 10;
	uRTC->IntControl |= RTCIntControlEVENT;
}

#endif /* __ASM_ARCH_TIME_H__ */
