/*
 *  linux/include/asm-arm/mmu_context.h
 *
 *  Copyright (C) 1996 Russell King.
 *  Copyright (C) 2001 RidgRun Inc (www.ridgerun.com)
 *  Copyright (C) 2001 Intersil Americas Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 *  Changelog:
 *   27-06-1996	RMK	Created
 *   20-02-2001 GJM     Gutted for uClinux
 */
#ifndef __ASM_ARM_MMU_CONTEXT_H
#define __ASM_ARM_MMU_CONTEXT_H

#define destroy_context(mm)		do { } while(0)
#define enter_lazy_tlb(mm,tsk,cpu)

#ifndef CONFIG_ARM9_MPU

#define switch_mm(prev,next,tsk,cpu)
#define init_new_context(tsk,mm)	0
#define activate_mm(prev,next)

#else /* CONFIG_ARM9_MPU */

#include <asm/mmu.h>

#define activate_mm(prev, next) \
	switch_mm((prev),(next),NULL,smp_processor_id())

static inline int
init_new_context(struct task_struct *tsk, struct mm_struct *mm)
{
	init_mpu_areas(&mm->context);
	return 0;
}

/*
 * This is the actual mm switch as far as the scheduler
 * is concerned.  No registers are touched.
 */

static inline void
switch_mm(struct mm_struct *prev, struct mm_struct *next,
          struct task_struct *tsk, unsigned int cpu)
{
	if(tsk && tsk->addr_limit == KERNEL_DS)
		program_mpu_areas_kernel();
	else
		program_mpu_areas(&next->context);
}

#endif /* CONFIG_ARM9_MPU */

#endif
