/*  $Header$
 *  
 *  Copyright (C) 2001 Intersil Americas Inc.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License.
 * 
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 * 
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef _IMAGE_H
#define _IMAGE_H

#include <sys/types.h>

/*----------------------------------------------------------------------------*
 | Next structure definition is handy for retrieving a component_id without   |
 | having to cast bootrec[] (since we need component_id in TURBO_AP instead   |
 | of magic2...                                                               |
 *----------------------------------------------------------------------------*/
//struct image_header_extended {
//    u_long dummy[7];
//    u_long component_id;
//} __attribute__((packed));

struct image_header_extended {
   u_long magic1;
   u_long vector;
   u_long crc_start;
   u_long crc_end;
   u_long crc_code;
   u_long component_id_code;
   u_long component_id_length;
   u_long component_id;
} __attribute__((packed));

typedef struct image_header_extended image_header_ext;
typedef struct image_header_st image_header_t;

typedef enum {
    upg_image_ok = 0,
    upg_image_invalid,
    upg_image_unsupported_product,
    upg_image_unsupported_oem_id,
    upg_image_unsupported_hardware_revs,
    upg_image_unsupported_tftp_if,
    upg_image_unsupported_boot,
    upg_image_unsupported_uapfw,
    upg_image_unsupported_webfileset
} upg_image_check_t;

extern upg_image_check_t image_file_check(image_header_t *hdr[]);
extern int GetBootRecordVersionTag(unsigned char *tag);
extern int get_current_bootrecords(const char *search_devices[], long *current_bootrecs[],
                                   long *new_bootrecs[]);

#endif /* _IMAGE_H */

