/*  $Header$
 *  
 *  Copyright (C) 2003 Intersil Americas Inc.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License.
 * 
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 * 
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

/*
 *  FIXME, add comments.
 *
 */

/* CRC and MD5 */
#define BR_DEF_EXT_CARD_CRC16		0x0000
#define BR_DEF_EXT_CARD_MD5		{ 0, 0, 0, 0 }

/*
 * Exposed Interfaces
 */
#define BR_EXP_IF_SIZE		((sizeof(struct s_exposed_if_list) - \
				  sizeof(struct s_bootrec_hdr)) / 4)

#define BR_NOF_EXP_IF		4
struct s_exposed_if_list {
	const struct s_bootrec_hdr hdr;
	const struct s_bootrec_exp_if exposed_if[BR_NOF_EXP_IF];
};

/*
 * Default exposed interface for the expansion card in case no expansion card is available,
 * or when the card is not suited for the available expansion card AP firmware.
 */
const struct s_ext_card_def_boot_record {
    struct s_bootrec_comp_id  component_id;
    struct s_exposed_if_list exposed_if_list;
    struct s_bootrec_end  bootrecord_end;
} ext_card_def_boot_record = {
    component_id:
    {
        { BR_CODE_COMPONENT_ID, 1 },
	BR_COMP_ID_DUMM
    },
    exposed_if_list:
    {
        { BR_CODE_EXPOSED_IF, BR_EXP_IF_SIZE },
        {   /* role, interface ID, variant, bottom compat, top compat */
            { BR_IF_ROLE_SERVER, BR_IF_ID_OEM_IF        , 0, 0, 0xFFFF },
            { BR_IF_ROLE_SERVER, BR_IF_ID_PRODUCT_IF    , 0, 0, 0xFFFF },
            { BR_IF_ROLE_SERVER, BR_IF_ID_ISL37700M, 0, 0, 0xFFFF },
            { BR_IF_ROLE_SERVER, BR_IF_ID_ISL39000M, 0, 0, 0xFFFF },
        }
    },
    bootrecord_end:
    {
        { BR_CODE_END_OF_BRA, 5 },	/* bootrec code, length */
        BR_DEF_EXT_CARD_CRC16,		/* CRC-16 */
        0,				/* padding */
        BR_DEF_EXT_CARD_MD5,		/* MD5 */
    }
};




