/*  $Header$
 *
 *  Copyright (C) 2001 Intersil Americas Inc
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License.
 * 
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 * 
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

/* function prototypes */
int mtd_read( int fd, int offset, u_long *value, size_t size );
int mtd_read_ulong_array( int fd, int offset, u_long *value, int len );
int mtd_read_ushort_array( int fd, int offset, u_long *value, int len );
int mtd_read_uchar_array( int fd, int offset, u_char *value, int len );


/* return 0 on success, 1 on failure */
static inline int
mtd_read_ulong( int fd, int offset, u_long *value )
{
	return(mtd_read( fd, offset, (u_long*)value, sizeof(u_long) ));
}

/* return 0 on success, 1 on failure */
static inline int
mtd_read_ushort( int fd, int offset, u_long *value )
{
	return(mtd_read( fd, offset, (u_long*)value, sizeof(u_short) ));
}

/* return 0 on success, 1 on failure */
static inline int
mtd_read_uchar( int fd, int offset, u_long *value )
{
	return(mtd_read( fd, offset, (u_long*)value, sizeof(u_char) ));
}
