/*  $Header$
 *  
 *  Copyright (C) 2001 Intersil Americas Inc.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License.
 * 
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 * 
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

/* List of currently supported regdomain values */
#define REGDOMAIN_GLOBAL    0x00
#define REGDOMAIN_FCC       0x10
#define REGDOMAIN_IC        0x20
#define REGDOMAIN_ETSI      0x30
#define REGDOMAIN_SPAIN     0x31
#define REGDOMAIN_FRANCE    0x32
#define REGDOMAIN_MKK       0x40
#define REGDOMAIN_UNKNOWN   0xffffffff

#define CURRENT_KNOWN_REGDOMAINS 7

/*
 * default_channel() returns the default channel for
 * the given regulatory domain. If the channels parameter
 * is non-zero, the operational channels for the given
 * regulatory domain are also copied.
 *
 * in:	domain - regulatory domain number.
 *	channels - pointer to null-terminated channelset.
 * ret: default channel number.
 */
int default_channel( int domain );

/*
 * channels() returns the minimum channel, maximum channel
 * and number of channels based on the regulatory domain. If
 * the regulary domain cannot be found, a safe default set
 * is returned.
 *
 * in:	domain - regulatory domain number.
 * out: min - pointer to lowest allowed channel.
 *	max - pointer to maximum allowed channel.
 * ret: number of channels between min and max.
 */
int channels( int domain, int* min, int* max );