/*  $Header$
 *
 *  Copyright (C) 2003 Intersil Americas Inc
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License.
 * 
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 * 
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include "device_config.h"
#include "apinfo.h"
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <string.h>

int apinfo_wanport_present(void) {

	static int wanpresent = -1;

	if(wanpresent == -1) {
		int fd;
		struct ifreq ifr;

		fd = socket(AF_INET, SOCK_DGRAM, IPPROTO_IP);		

		strncpy(ifr.ifr_name, APINFO_WANPORT_NAME, IFNAMSIZ);

		if (ioctl(fd, SIOCGIFMTU, &ifr) == 0) {
			wanpresent = 1;
		}
		else {
			wanpresent = 0;
		}
		
		close(fd);
		
	}
	
	return wanpresent;
}


char* apinfo_get_SysObjectID(void) {
	
	if(apinfo_wanport_present()) {
		return SYS_OBJECT_ID_WAN;
	}
	else {
		return SYS_OBJECT_ID_NOWAN;
	}
}
