/*  $Header$
 *  aplog function. Sends aplog messages to aplogd. 
 *
 *  Copyright (C) 2001 Intersil Americas Inc
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License.
 * 
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 * 
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
 
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#define SOCK "/var/run/aplog.sock"
#define MAXARGS 4



int aplog(unsigned long evid, ...)
{
	int fd;
	struct sockaddr_un unix_addr;
	int r;
	va_list va;
	char *p;
	char buf[128];
	char *tmp;
				

	snprintf(buf, sizeof(buf), "LOG;%ld;", evid);

	va_start(va, evid);

	r=0;
	while((p = va_arg(va, char*)) && (r<MAXARGS)) {

		tmp=strchr(p, '\n');
		if(tmp) *tmp=' ';
		tmp=strchr(p, '\r');
		if(tmp) *tmp=' ';
	
		strcat(buf, p);
		strcat(buf, ";");
	}

	va_end(va);


	fd = socket(AF_UNIX, SOCK_STREAM, 0);

	if(fd<0) {
		fprintf(stderr, "aplog : Error opening socket to aplogd: %s\n", strerror(errno));
		return(1);
	}

	memset(&unix_addr, 0, sizeof(unix_addr));
	unix_addr.sun_family=AF_UNIX;
	strncpy(unix_addr.sun_path, SOCK, sizeof(unix_addr.sun_path));

	r = connect(fd, (struct sockaddr *)&unix_addr, sizeof(unix_addr));

	if(r<0) {
		fprintf(stderr, "aplog : Can't connect to aplogd : %s\n", strerror(errno));
		return(1);
	}

	write(fd, buf, strlen(buf));

	close(fd);
	return(0);
}


// eof..
