# $Header$
#
# Copyright (C) 2001 Intersil Americas Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

# Set up you environment here
ifeq "$(origin INCBASE)" "undefined"
  INCBASE := $(ROCKBASE)/..
  export INCBASE
endif

include $(ROCKBASE)/make_include/tooldir.mak

#TOOLDIR		= /usr/local/bin

CROSS		= arm-elf-

MAKE		= /usr/bin/make -f Makefile
SHELL		= /bin/sh
CC		= $(TOOLDIR)/$(CROSS)gcc
CXX		= $(TOOLDIR)/$(CROSS)g++
AR		= $(TOOLDIR)/$(CROSS)ar
LD		= $(TOOLDIR)/$(CROSS)ld
OBJCOPY		= $(TOOLDIR)/$(CROSS)objcopy
RANLIB		= $(TOOLDIR)/$(CROSS)ranlib
OBJFMT2FLT	= $(TOOLDIR)/elf2flt -d
SMIDUMP		= $(TOOLDIR)/smidump

APP_GPL_SRCDIR			= $(ROCKBASE)/apps-gpl
APP_NON_GPL_SRCDIR		= $(ROCKBASE)/apps-non-gpl
APP_CLOSED_SRC_SRCDIR	= $(ROCKBASE)/apps-closed-src
APPBUILDDIR				= $(ROCKBASE)/appbuild

ROMFSDIR	= $(ROCKBASE)/romfs

# EXECDIR can already be defined for special executables (like cgi-bin exec's)
ifeq "$(origin EXECDIR)" "undefined"
EXECDIR		= $(ROMFSDIR)/bin
endif

CONFDIR		= $(ROMFSDIR)/etc
UCLIBCDIR	= $(ROCKBASE)/lib/uClibc
MIBDIR		= $(ROCKBASE)/../../../MIB

# we are using a global offset table to be able to use XIP
ARCH		= -mapcs-32 -mcpu=arm9tdmi -fpic -fno-builtin\
			-msingle-pic-base -msoft-float
DEFS		= -Dlinux -D__linux__ -Dunix -DEMBED -D__GLIBC__=2 $(PLATFORMDEFS)

INCCDIR		= $(UCLIBCDIR)/include
INCINLDIR	= $(ROCKBASE)/lib/Inl/include
INCGLOBDIR	= $(ROCKBASE)/include
INCFWDIR	= $(INCBASE)/include
INCDIRS		= $(EXTRA_INCLUDES) -I$(INCFWDIR) -I$(INCGLOBDIR) -I$(INCINLDIR) -I$(INCCDIR)

LIBGCC		= $(shell $(CC) $(ARCH) --print-libgcc-file-name)
LIBC		= $(UCLIBCDIR)/libc/libc.a
LIBUTIL		= $(UCLIBCDIR)/libutil/libutil.a
LIBCRYPT	= $(UCLIBCDIR)/libcrypt/libcrypt.a
LIBINL		= $(ROCKBASE)/lib/Inl/libinl.a
LIBS		= $(EXTRA_LIBS) $(LIBINL) $(LIBCRYPT) $(LIBC) $(LIBGCC)
#LIBSD		= $(addprefix debug/, $(LIBS))
LIBSD		= $(LIBS)

OPTIMIZATION	= -Os

DEBUG_CFLAG	= -g3
WARNINGS	= -Wall -Wcast-align
CFLAGS		= $(WARNINGS) $(ARCH) $(DEFS) $(EXTRA_CFLAGS) $(INCDIRS)

XARCH		= $(ROCKBASE)/make_include
STARTUP		= $(UCLIBCDIR)/lib/crt0.o
LDFLAGS		= $(LIBDIRS) $(STARTUP)
OBJFMT		= elf
OBJFMTA		= elfabs
OBJFMTD		= elfdebug
OBJFMTDA	= elfdebugabs

ARFLAGS		= srv
