# $Header$
#
# Copyright (C) 2001 Intersil Americas Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
MAKE		= /usr/bin/make -f Makefile
SHELL		= /bin/sh

export EXTRA_TARGETS

DEFAULT_TARGETS	:= all clean depend
TARGETLIST	:= $(DEFAULT_TARGETS) $(EXTRA_TARGETS)

usage : default_usage dirs_usage

default_usage :
	@echo "Usage:" >&2
	@echo " make all			# build all in subdirectories" >&2
	@echo " make clean			# remove the object files" >&2
	@echo " make depend			# make depend files" >&2

dirs_usage :
	@echo " make [directoryname]		# build all in given directory" >&2
	@echo " make [directoryname] DEBUG=1	# build all in given directory for debug" >&2

# set the target
all : TARGET := all
clean : TARGET := clean
depend : TARGET := depend

# set the extra targets
ifneq ($(word 1,$(EXTRA_TARGETS)),)
$(word 1,$(EXTRA_TARGETS)) : TARGET := $(word 1,$(EXTRA_TARGETS))
endif
ifneq ($(word 2,$(EXTRA_TARGETS)),)
$(word 2,$(EXTRA_TARGETS)) : TARGET := $(word 2,$(EXTRA_TARGETS))
endif
ifneq ($(word 3,$(EXTRA_TARGETS)),)
$(word 3,$(EXTRA_TARGETS)) : TARGET := $(word 3,$(EXTRA_TARGETS))
endif
ifneq ($(word 4,$(EXTRA_TARGETS)),)
$(word 4,$(EXTRA_TARGETS)) : TARGET := $(word 4,$(EXTRA_TARGETS))
endif
ifneq ($(word 5,$(EXTRA_TARGETS)),)
$(word 5,$(EXTRA_TARGETS)) : TARGET := $(word 5,$(EXTRA_TARGETS))
endif

$(TARGETLIST) : subdirs

.PHONY : subdirs $(SUBDIRS)
subdirs : $(SUBDIRS)

$(SUBDIRS) : 
	$(MAKE) -C $@ $(shell \
			if [ "$(TARGET)" = "" ]; then \
				echo all; \
			else \
				echo $(TARGET); \
			fi )
