
#include <stdio.h>
#include "pda.h"

unsigned char pda_Find_Test(void);
extern void pda_Print(void);

int main(void)
{
#if (HARD_CONFIG != 1)
   unsigned char ret;
	
   pda_Cache("/dev/null");  /* device not important, is not opened anyway */
   printf("PDA is cached\n");
   
#if (PDA_TEST != 0)
   pda_Print();
#endif
   ret = pda_Find_Test();

   if (ret == 1) printf("\n\n  -----> TOTAL TEST RESULT: NO ERRORS\n");
   else printf("  -----> TEST RESULT: ERRORS\n\n");
#else
   printf(" THIS Software is meant to test PDA, not HARD_CONFIG\n");
   printf(" Please compile with \"#define HARD_CONFIG 0\" in pda.c\n");
#endif
   return 0;
}

unsigned char pda_Find_Test(void)
{
   struct Pdr_Struct *pdrPtr;
   unsigned short *PdrData;
 
   printf("\n"); 
   printf(" pda_Find(PDR_MF_PART_NUMBER) "); 
   pdrPtr = pda_Find_Pdr(PDR_MF_PART_NUMBER, (struct Pdr_Struct *)0);
   if (pdrPtr != 0) {
      printf(" OK\n");
      PdrData = (unsigned short *)pdrPtr->PdrData;
      printf("   Length=%d, Data[0]=0x%04x, Data[1]=0x%04x\n", pdrPtr->PdrLength, PdrData[0], PdrData[1]);
   } else {
      printf(" FAILED\n");
      return 0;
   }
   
   printf("\n pda_Find(PDR_ALLOWED_CHAN_SET) ");
   pdrPtr = pda_Find_Pdr(PDR_ALLOWED_CHAN_SET, (struct Pdr_Struct *)0);
   if (pdrPtr != 0) {
      printf("OK\n");
      PdrData = (unsigned short *)pdrPtr->PdrData;
      printf("   Length=%d, Data[0]=0x%04x, Data[1]=0x%04x\n", pdrPtr->PdrLength, PdrData[0], PdrData[1]);
   } else {
      printf(" FAILED\n");
      return 0;
   }

   printf("\n pda_Find(PDR_PRODUCT_NAME) ");
   pdrPtr = pda_Find_Pdr(PDR_PRODUCT_NAME, (struct Pdr_Struct *)0);
   if (pdrPtr != 0) {
      printf("OK\n");
      PdrData = (unsigned short *)pdrPtr->PdrData;
      printf("   Length=%d, Data[0]=0x%04x, Data[1]=0x%04x\n", pdrPtr->PdrLength, PdrData[0], PdrData[1]);
   } else {
      printf(" FAILED\n");
      return 0;
   }

   printf("\n pda_Find(PDR_THIS_TEST_SHOULD_FAIL) ");
   pdrPtr = pda_Find_Pdr(-1, (struct Pdr_Struct *)0);
   if (pdrPtr != 0) {
      printf("FAILED\n");
      return 0;
   } else {
      printf("OK\n");
   }

   return 1;
}
