var errorMessage = ""
var userMessage = ""
alert('/general/validation.js wordt gebruikt ipv /js/validation.js, replacen dus');

function verifyIP (IPvalue) {
  //verify IP Address

  errorString = "";
  theName = "IPaddress";
  
  var ipArray = IPvalue.split(".");

  if (!ipArray || ipArray.length != 4)
    errorString += 'The IP Address does not have a valid format. Please use the following format: 123.123.123.123';
  else {
    for (i = 0; i < 4; i++) {
      thisSegment = ipArray[i];
      if (thisSegment != "") {
        if (!(thisSegment >=0 && thisSegment <= 255)) { //check if number?
          errorString += 'The IP Address can only consist out of numbers in the range 0-255 (separated by dots)';
          i = 4;
        }
      } else
         errorString += 'The IP Address does not have a valid format. Please use the following format: 123.123.123.123';
    }
  }
  if (errorString != "") {
    errorMessage = errorString+"\n"
    return false;
  }
  return true;
}

function verifyIPAddress (IPvalue) {
  errorString = "";
  validValue = true;

  if (verifyIP(IPvalue)) {
    var ipArray = ipValue.split(".");    
    if (ipArray[0] >= 224) {
      errorString += "IP Address out of range. Value greater than 224.0.0.0 not allowed.";
      validValue = false;
    }
  } else {
    errorString += "The IP Address is invalid.";
    validValue = false;
  }

  return validValue;
}

  function verifyMAC(macAddress) {
    // This function checks whether the address given is in MAC Address notation
    // MAC Address format is: 00:00:00:00:00:00
    validValue = true
    if (macAddress.length != 17) {
      validValue = false
    } else {
      testAddress = macAddress
      while (testAddress != "") {
        nrs = testAddress.substring(0,2)
        //  Use line below when MAC Address can only contain : . -
        if (testAddress.charAt(2) != ":" && testAddress.charAt(2) != "" && testAddress.charAt(2) != "." && testAddress.charAt(2) != "-"  && testAddress.charAt(2) != " ") return false
        if (!isHex(nrs) && (validValue)) { 
          errorMessage = macAddress+" is not a valid MAC Address.\n\nPlease enter a valid MAC Address."
          validValue = false;
        }
        testAddress = testAddress.substring(3,testAddress.length)
      }
    }
    if (!validValue)
      errorMessage = "Invalid MAC Address. Please use the following format: 00:00:00:00:00:00"
    return validValue
  }
  
function verifyRange (min, max) {
  min = parseInt(min);
  max = parseInt(max);
  if (min <= max)
    return (min <= max)
  else {
    alert('Invalid range. Minimum value exceeds maximum value.')
    return false;
  }
}

function numberInRange (el, elMin, elMax) {
  el = parseInt(el);
  elMin = parseInt(elMin);
  elMax = parseInt(elMax);
  if (el >= elMin && el <= elMax && elMax >=elMin && el.length != 0)
    return true;
  else {
    errorMessage = "Invalid value. Number ("+el+") must be in range "+elMin+"-"+elMax+".";
    return false;
  }
}

function verifyProtocol (myNumber) {
  if (!numberInRange(myNumber,0,256)) {
    errorMessage = "Invalid protocol number. Number must be between 0 and 256.";
    return false;
  } else
  return true;
}

function verifyPort (myNumber) {
  if (!numberInRange(myNumber,0,65535)) {
  errorMessage = "Invalid port number. Port must be between 0 and 65535.";
    return false;
  } else
  return true;
}

function validateString (str) {
// allowed characters: 32,33,35-126 (34=")
// accents are not allowed: 192-214 + 217-246 + 249-255 + 191 (=)

  validString = true
  for (i=0;i<str.length;i++) {
    nr = str.charCodeAt(i) 
    if (!(nr>=32 && nr<=126 && nr != 34)) {
      validString = false
      errorMessage += "The input contains unallowed characters. Please try again\n"
      break
    }
  }
  return validString
}

function validateHexString (str) {
// allowed characters: 48-57 (0-9), 65-70 (A-F), 97-102 (a-f)

  validString = true
  for (i=0;i<str.length;i++) {
    nr = str.charCodeAt(i) 
    if (!((nr >= 48 && nr <= 57) || (nr >=65 && nr <= 70) || (nr >=97 && nr <= 102))) {
      validString = false
      errorMessage = "Incorrect value. Your input must consist of the characters 0 throug 9 or a through f.'\n"
      break;
    }
  }
  return validString
}

function strLength(str, length) {
  if (str.length != length) {
    errorMessage = "Incorrect value. Your input must be "+length+" characters long.\n";
    return false;
  } return true;
}

function verifyIPRange (ipMin, ipMax) {
  // verify IP range
  errorString = ""

  var ipMinArray = ipMin.split(".")
  var ipMaxArray = ipMax.split(".")
  for (i=0;i<4;i++)
    ipMinArray[i] = parseInt(ipMinArray[i])

  for (i=0;i<4;i++)
    ipMaxArray[i] = parseInt(ipMaxArray[i])

  if (verifyIP(ipMin) && verifyIP(ipMax)) {
    validRange = false
    if ((ipMinArray[0]) < ipMaxArray[0])
      validRange = true
    else
      if (ipMinArray[0] == ipMaxArray[0])
        if (ipMinArray[1] < ipMaxArray[1])
          validRange = true  
        else
          if (ipMinArray[1] == ipMaxArray[1])
            if (ipMinArray[2] < ipMaxArray[2])
              validRange = true
            else
              if (ipMinArray[2] == ipMaxArray[2])
                if ((ipMinArray[3]) <= (ipMaxArray[3]))
                  validRange = true

    if (!validRange)
      errorString = "Invalid IP Range. Low IP exceeds high IP."
  } else
    errorString = "Invalid IP Address"
  if (errorString != "")
    errorMessage += errorString+"\n"
  return !(errorString != "")
}

/*
  // example. The # is used to seperate the different strings
  var macList = ""
  macList += "#" + "FF:FF:FF:FF:FF:FF"
  macList += "#" + "FF:FF:00:00:00:00"
*/
  
  function uniqueMACAddress(macValue, macList) {
    macValue = macValue.toUpperCase();
    macList = macList.toUpperCase();
    
    //if the MAC Address is not yet in the list
    return (macList.indexOf(macValue) == -1);
  }

  function uniqueIPAddress(ipValue, ipList) {
    return (ipList.indexOf(ipValue) == -1);  
  }
  
  function uniqueInList(unValue, unList) {
    return (unList.indexOf(unValue) == -1);  
  }

function macKeyFilter() {
//allow 0-9, A-F, a-f
//allow 45=-, 46=., 32= , 58=:
  if ((event.keyCode >= 48 && event.keyCode<=57) || (event.keyCode >= 65 && event.keyCode <= 70) || (event.keyCode >= 97 && event.keyCode <= 102) || 
      (event.keyCode == 45 || event.keyCode == 46 || event.keyCode == 32 || event.keyCode == 58))
    event.returnValue = true;
  else
    event.returnValue = false;
}

function hexKeyFilter() {
//allow 0-9, A-F, a-f
  if ((event.keyCode >= 48 && event.keyCode<=57) || (event.keyCode >= 65 && event.keyCode <= 70) || (event.keyCode >= 97 && event.keyCode <= 102))
    event.returnValue = true;
  else
    event.returnValue = false;
}

function ipKeyFilter() {
//allow 0-9 & "."
  if ((event.keyCode < 48 || event.keyCode > 57) && event.keyCode != 46)
    event.returnValue = false;
}

function digitKeyFilter() {
//allow 0-9
  if (event.keyCode < 48 || event.keyCode > 57)
    event.returnValue = false;
}

function handleError(handleFunc) {
  retValue = handleFunc
  if (!retValue) {
    if (errorMessage != "") {
      alert(errorMessage)
      errorMessage = ""
      return false
    } else
    return false    
  } else
    return true
}

function handle(handleFunc) {
  return handleFunc
}

function validateInput(objStr,validateFunc) {
//validate input with the given validation function
//show errorMessage, but only 1 per submit-request

  var result = validateFunc;
  if (!result) {
    if (userMessage=="")
      userMessage = "("+objStr+"): " + errorMessage;
    return false
  } else
    return true;
}

function announceValidation() {
  if (userMessage != "") {
    alert(userMessage);
    userMessage = "";
    return false;
  } else
    return true;
}