/*
 * TinyLogin is Copyright (C) 1999 by Lineo, inc. and
 * is being maintained  and hopefully imporved by
 * Erik Andersen <andersen@lineo.com>, <andersee@debian.org>
 *
 * Please feed suggestions, bug reports, insults, and bribes back to:
 *         Erik Andersen
 *         <andersen@lineo.com>
 *         <andersee@debian.org>
 *
 * TinyLogin is a curious blend of code from a whole bunch of folks.
 * It was originally cobbled together by Sean Bastille <hightide@ginch.org>
 * based in part on the May of 1998 version of the shadow utilities, which
 * can be downloaded from: ftp://ftp.ists.pwr.wroc.pl/pub/linux/shadow/
 *
 * The build system, and the way in which TinyLogin invokes its component
 * applications has been totally rewritten, based on the build system
 * used for BusyBox.  The code has also been majorly reworked to make it
 * more internally consistent, to make it use fewer global variables,
 * etc, by Erik Andersen.
 *
 *
 * TinyLogin may be used and distributed under the terms of GNU General
 * Public License, _with_ the addition of the special terms enumerated
 * below (after the GPL) by the shadow utilities license (a BSD style
 * license, included below, which does not restrict me from making future
 * releases under the GPL, so I am doing just that).
 *
 *  -Erik
 */
/* passwd.h */

#define FALSE   ((int) 1)
#define TRUE    ((int) 0)

#define USE_SYSLOG
#define FAIL_DELAY 3
#define TIMEOUT 60
#define NOLOGIN_FILE	"/etc/nologin"
#define PASSWD_FILE	    "/usr/etc/passwd"
#define SHADOW_FILE 	"/etc/shadow"
#define GROUP_FILE	    "/etc/group"
#define _PATH_LOGIN	    "/bin/login"
#define CRYPT_EP_SIZE 13		/* Maximum encrypted password size */

/* Utility routines */

static char *pw_encrypt(const char *clear, const char *salt);
static char *xstrdup(const char *s);

#define STRFCPY(A,B) \
        (strncpy((A), (B), sizeof(A) - 1), (A)[sizeof(A) - 1] = '\0')

#include <sys/types.h>

